/****************************************************************************************
*               ki.c - 百相鍵盤 (Keyboard Integration)『き』の実験用 XIM
*         （XIMプロトコルのやりとりは、IMdkitを『き』に特化した kilib.c で行う）
*
*                                                                    13-07-29月  越川和忠
*
* 書き替えたものを配布する時は、日付、作成者名共、更新者のものに書き替えられたい。
*
* 【12-08-24金以降の試行錯誤の跡】
* 12-09-18火 下見している文字鍵だけ G49のフォントで表示することもできるようにしてみる。
* 12-09-22土 鍵盤図の基準点を、四隅ではなく、図心にする。
* 12-09-23日 鍵盤図の対辺が伸縮しても画面内に収まる時は、隅からの伸縮にせず、それを採る。
* 12-09-24月 側枠が画面枠に接していない時の横方向は左右伸縮とし、縦方向は従来通りにする。
* 12-09-27木 下見文字鍵をG49で拡大表示する機能は取消す。
* 12-09-29土 鍵盤図の横方向の位置は、隅ではなく、中心線で指定する。
* 12-09-30日 鍵盤図が画面の左端か右端に接している時は、今まで通り、反対側への伸縮にする。
* 12-10-01月 鍵盤図の位置は、隅ではなく、中心線のＸ座標と下辺あるいは上辺のＹ座標で表す。
* 12-10-13土 ↑無指定であれば、画面下辺中央にとる。
* 12-10-16火 鍵盤図枠の線の太さが 1だったのを 2にする。
* 12-10-28日 案内簿はG01とG02だけにし、#define GFULL なら従来のコードを生成する。
* 12-10-29月 統計を取るコードは#define FREQ による項で生成するように書き直す。
* 12-11-14水 案内簿鍵盤はシフトを押さずに K56を打つと出る仕様に修正する。
* 12-11-15木 鍵矩形有無の指示手段は、#K56ではなく、元の表示簿選択方式に戻す。 
* 12-11-18日 Gk=1のK56は前回フォントへの戻りにし、鍵矩形有無切り替えは表示簿選択に移す。 
* 12-11-25日 表示・不表示は K56に戻し、案内簿はG01とG02だけ、音声なしのコードにする。
* 12-11-30金 K56 の処理およびコード全般を少し整えて、FREQ、GFULL、AUDIO版を作っておく。
* 12-12-04火 配字簿鍵盤での#K54も、案内簿鍵盤と同様に、前回簿への戻りに充てる。
* 12-12-06木 Gk=1の K56も表示を消すにしていたが、文字鍵盤に戻る、に直す。
* 12-12-10月 統計と各種表示様式の機能は残し、音声関連のコードは取り除く。
* 12-12-11火 ExposeがK55の時に来ると再描画はしないとしていたコードを取り除く。
* 13-01-04金 #K57で下見を開始すると鍵盤図をG49のフォントで表示する。
* 13-01-14月 配字簿鍵盤の#K54、表示簿鍵盤の#K56は、それぞれ、M01、G01への戻りにする。
* 13-01-16水 音声なしにしたので、倣い入力開始時に不表示状態なら表示状態にする。
* 13-01-22火 案内簿は表示様式＋フォントの組合せにし、鍵盤図は下辺に少し余白を置く。
* 13-01-24木 「案内簿」は「表示簿」にする。
* 13-01-31木 受けたXIMプロトコルのログを取る場合、出す先はコンソールだけにする。
* 13-02-07木 下見は Shift有無によらず G49で表示する。
* 13-02-08金 表示簿鍵盤で選ぶ以外に、Gk #K56でG01・G02切り替え、下見はG03(固定)とする。
* 13-02-10日 甲鍵を示す矩形は乙鍵盤の表裏共出す(以前の仕様に戻す)。
* 13-02-11月 Mk=1 #K54 を M01 <-> M02 に充てる。下見は G49に戻す。
* 13-02-12火 倣い入力開始時に不表示状態なら表示状態にするのは止め、元に戻す。
* 13-02-13水 不表示時に表示状態にして開始した下見は、終わると不表示に戻す。
* 13-02-15金 倣い入力で、字引に該当見出しの項がない時は、呼び字列全体を表記行にする。
* 13-02-18月 G49 で表示する下見は#K57で開始する場合に限定する 。
* 13-03-07木 Prefは/home/.ki/に置く。
* 13-03-11月 実行時配字は、終了時に /home/.ki/var/K49があれば、その更新として保存する。
* 13-03-21木 鍵盤図の文字鍵間隔を、実鍵盤は等間隔だが、『き』初期に採った近似に戻す。
* 13-03-24日 配鍵簿で鍵位置の数値が範囲外の時は既定値を採る。 
* 13-03-27水 K57、#K57共、下見のオン・オフだけに戻す。
* 13-04-29月 実行時配字簿は、起動時にあれば読み込み、配字成立ごとに更新する。
* 13-05-06月 表示簿は、表示様式とフォントの組に限定しない12年公開版の仕様に戻す。
* 13-05-24金 別のＩＭ名で生成することもしやすくした。
* 13-05-31金 参照簿は/HOME/.IMNAME/Prefがなければ/opt/IMNAME/*。kiMapとStatは固定配列化。
* 13-06-02日 統計は、配字簿設定時に統計簿があれば引き継ぎ、その配字簿終了時に保存する。 
* 13-07-14日 ＩＭ名は ki、参照簿の位置は /opt/ki/に戻す。
* 13-07-28日 クリップボードからの取り込みは、制御字に出会ったらそこで打ち切る。
* 13-07-29月 00-01-28 Fri(ki-xim着手日)から記載していた当「日誌」を前回以降に抑えた。
****************************************************************************************/
#define IMNAME "ki"                                                          /* ＩＭ名 */
#define KIDATE "ki-xim-130729"     /* 版日付：統計簿末に書き出す。]vの配字で入力できる */
#define PREF   "/opt/ki/Pref"                                      /* 初期設定簿所在地 */
#define BKS    "/opt/ki/bks/"                                          /* 参照簿所在地 */
#define VAR    "/opt/ki/var/"                                          /* 可変簿所在地 */
#define LENG   5+2+5+8+12     /* パス字列の最大長: "/opt/IMNAME/var/M01.freq" + 予備12 */

#include <stdio.h>
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xft/Xft.h>
#include "kilib.h"

typedef wchar_t WYTE;
typedef unsigned long UINT;
typedef unsigned short USHORT;

#define Fmax 56                                            /* 機能鍵案内簿の定義行の数 */
#define Bmax 256                                 /* 配字簿、字引の１行の最大バイト数+1 */
#define Hmax 8                                                 /* 見出しの最大バイト数 */
#define Cmax 62        /* 標題欄字列、本字列・備考欄、呼び字列、表記列欄の最大バイト数 */
#define Dmax 10                                                        /* 表記群の行数 */

BYTE IMLOCALE[Cmax+2]="ja_JP,zh_TW,zh_CN,ko_KR,th_TH,iw_IL";             /* ロカール名 */
BYTE MDG[LENG];      /* 参照簿のパス(最長 /opt/IMNAME/bks/M01.freq) を収容するバッファ */
BYTE Kdd[100][3]={                                              /* 文字番号 数値→整数 */
  "00","01","02","03","04","05","06","07","08","09",
  "10","11","12","13","14","15","16","17","18","19",
  "20","21","22","23","24","25","26","27","28","29",
  "30","31","32","33","34","35","36","37","38","39",
  "40","41","42","43","44","45","46","47","48","49",
  "50","51","52","53","54","55","56","57","58","59",
  "60","61","62","63","64","65","66","67","68","69",
  "70","71","72","73","74","75","76","77","78","79",
  "80","81","82","83","84","85","86","87","88","89",
  "90","91","92","93","94","95","96","97","98","99"
};

Display        *dpy;
Window    root, wnd;
Visual *visual=NULL;
Colormap       cmap;
CARD16      cf_id=0;
Atom     utf8, prop;

/*  鍵盤に依存する固定データ
*   既定値のkeycodeは、X.Org 1.5 evdev の jp106 で、 <TLDE>と<CAPS> を交換している。
* 配鍵番号                  keycodes
*  0                         00,
*  1～12 最上段              10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
* 13～24 上段                24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35,
* 25～36 中段                38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 51,
* 37～48 下段と空白文字鍵    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 97, 65,
* 49     余剰文字鍵         132,
* 50     Shift(shift)        50, (Shift_L)
* 51     CapsLock(lock)      49, (Caps_Lock、 evdev原簿は66)
* 52     Ctrl(control)       37, (Control_L)
* 53     Alt(mod1)           64, (Alt_L)
* 54     配字切替            66,（Eisu_toggle、evdev原簿は49)
* 55     倣い入力           102, (Muhenkan)
* 56     表示               100, (Henkan_Mode)
* 57     下見               101, (Hiragana_Katakana）
* 58～61 ↑←→↓           111,113,114,116,
* 62～63 BS、Enter           22, 36,
* 64～66 右Shift、Ctrl、Alt  62,105, 108
*/
BYTE kton[256]={                                            /* keycodeから番号を引く表 */
     /* keycode   0   1   2   3   4   5   6   7   8   9 */
      /*   0 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /*  10 */   1,  2,  3,  4,  5,  6,  7,  8,  9, 10,
      /*  20 */  11, 12, 62,  0, 13, 14, 15, 16, 17, 18,
      /*  30 */  19, 20, 21, 22, 23, 24, 63, 52, 25, 26,
      /*  40 */  27, 28, 29, 30, 31, 32, 33, 34, 35, 51,  /* 49 は CAPS と交換している */
      /*  50 */  50, 36, 37, 38, 39, 40, 41, 42, 43, 44,
      /*  60 */  45, 46, 64,  0, 53, 48, 54,  0,  0,  0,  /* 66 は TLDE と交換している */
      /*  70 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /*  80 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /*  90 */   0,  0,  0,  0,  0,  0,  0, 47,  0,  0,
      /* 100 */  56, 57, 55,  0,  0, 65,  0,  0, 66,  0,
      /* 110 */   0, 58,  0, 59, 60,  0, 61,  0,  0,  0,
      /* 120 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 130 */   0,  0, 49,  0,  0,  0,  0,  0,  0,  0,
      /* 140 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 150 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 160 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 170 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 180 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 190 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 200 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 210 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 220 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 230 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 240 */   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
      /* 250 */   0,  0,  0,  0,  0,  0
};
BYTE ntok[67]={                                         /* 配鍵番号からkeycodeをひく表 */
    0,                                                                       /*  0     */
   10,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,  21,                /*  1～12 */
   24,  25,  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,                /* 13～24 */
   38,  39,  40,  41,  42,  43,  44,  45,  46,  47,  48,  51,                /* 25～36 */
   52,  53,  54,  55,  56,  57,  58,  59,  60,  61,  97,  65,                /* 37～48 */
  132,                                                                       /* 49     */
   50,  49,  37,  64,  66, 102, 100, 101,     /*  TLDE と CAPS は交換してある   50～57 */
  111, 113, 114, 116,  22,  36,                                              /* 58～63 */
   62, 105, 108                                                              /* 64～66 */
};
BYTE ntox[58]={                                          /* 配鍵番号から桁位置をひく表 */
   44,                                                               /* 鍵盤図幅の桁数 */
    4,   7,  10,  13,  16,  19,  22,  25,  28,  31,  34,  37,                /*  1～12 */
    5,   8,  11,  14,  17,  20,  23,  26,  29,  32,  35,  38,                /* 13～24 */
    6,   9,  12,  15,  18,  21,  24,  27,  30,  33,  36,  39,                /* 25～36 */
    7,  10,  13,  16,  19,  22,  25,  28,  31,  34,  37,  19,                /* 37～48 */
   40,                                                                       /* 49     */
    2,   1,   3,   9,   1,  12,  26,  29      /*  TLDE と CAPS は交換してある   50～57 */
};
BYTE ntoy[58]={                                          /* 配鍵番号から段位置をひく表 */
    6,                                                           /* 鍵盤図の鍵盤の段数 */
    1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,                /*  1～12 */
    2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,                /* 13～24 */
    3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,                /* 25～36 */
    4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,                /* 37～48 */
    1,                                                                       /* 49     */
    4,   1,   5,   5,   3,   5,   5,   5      /*  TLDE と CAPS は交換してある   50～57 */
};
UINT Stat[100][100];                                               /* 配字の使用計数控 */
BYTE FH[1+30][Hmax+2]={                                            /* 54～57鍵の見出し */
  "\0",
  "_?", "<-",                                                           /* 01～02  K57 */
  "1t", "2d", " a", "M_", "_M", "->", "<-", "+ ", "++", "<-",           /* 03～12  K54 */
  ">>", "<<", "<-", "  ", "D_", "<-", "++", "cp", "<-", "<:",           /* 13～22  K55 */
  "][", "--", "G_", "_G", "<-", "  ", "  ", "  "                        /* 23～30  K56 */
};
XRenderColor Col[10]={                                                         /* 配色 */
  {224,224,224, 0xffff},                            /* C0 標題地   灰   light grey+    */
  {255,215,  0, 0xffff},                            /* C1 下見地   金   gold           */
  {  0,  0,  0, 0xffff},                            /* C2 基本字   黒   black          */
  {  0,  0,255, 0xffff},                            /* C3 甲鍵字   青   blue           */
  {  0,139,  0, 0xffff},                            /* C4 機能字   緑   green4         */
  {255,255,255, 0xffff},                            /* C5 白抜き   白   white          */
  {255,250,205, 0xffff},                            /* C6 注目行   淡黄 lemon chiffon  */
  {255,  0,  0, 0xffff},                            /* C7 特異字   赤   red            */
  {238,232,170, 0xffff},                            /* C8 字鍵地   黄   pale goldenrod */
  {255,250,205, 0xffff}                             /* C9 押鍵地   淡黄 lemon chiffon  */
};
BYTE XCol[10][8]={                                                 /* 配字案内に使う色 */
  {'#', 'e', 'd', 'e', 'd', 'e', 'd', 0},           /* C0 標題地   灰   light grey+    */
  {'#', 'f', 'f', 'd', '7', '0', '0', 0},           /* C1 下見地   金   gold           */
  {'#', '0', '0', '0', '0', '0', '0', 0},           /* C2 基本字   黒   black          */
  {'#', '0', '0', '0', '0', 'f', 'f', 0},           /* C3 甲鍵字   青   blue           */
  {'#', '0', '0', '8', 'b', '0', '0', 0},           /* C4 機能字   緑   green4         */
  {'#', 'f', 'f', 'f', 'f', 'f', 'f', 0},           /* C5 白抜き   白   white          */
  {'#', 'f', 'f', 'f', 'a', 'c', 'd', 0},           /* C6 注目行   淡黄 lemon chiffon  */
  {'#', 'f', 'f', '0', '0', '0', '0', 0},           /* C7 特異字   赤   red            */
  {'#', 'e', 'e', 'e', '8', 'a', 'a', 0},           /* C8 字鍵地   黄   pale goldenrod */
  {'#', 'f', 'f', 'f', 'a', 'c', 'd', 0}            /* C9 押鍵地   淡黄 lemon chiffon  */
};
BYTE dfs[Cmax+2]="-*-*-medium-r-normal--12-*-*-*-*-*-*-*";     /* 起動時無指定フォント */
XColor wcol[10];                                                               /* 配色 */
XftColor xcol[10];                              /* XftColrAllocValueで得る各色の構造体 */
BYTE S_date[20];                                                 /* 計数開始日時の控え */
BYTE kiDsp[3][100][Hmax+2];                                              /* 簿選択鍵盤 */
BYTE kiStH[8][100][Hmax+2];                    /* 単打はXlibのものを取り出して設定する */
BYTE kiStM[8][100][6];                                           /* 単打字の文字コード */
BYTE kiMapH[100][100][Hmax+2];                                       /* 複打字(見出し) */
BYTE kiMapM[100][100][Cmax+2];                                       /* 複打字(本字列) */
BYTE K49H[2][100][Hmax+2];                                          /* K49配字の見出し */
BYTE K49M[2][100][Cmax+2];                                          /* K49配字の本字列 */
BYTE DsM[Dmax+2][Cmax+2];                                /* 同じ呼び字列に対する表記群 */
BYTE DicM[Cmax+2];                                                         /* 字引標題 */
BYTE w_str[64];                                                      /* 作業用字列控え */
BYTE Log=0;                              /* XIM Protocolのログをコンソールに出すとき 1 */
BYTE K49=0;                                                /* 実行時配字を保存する時 1 */
BYTE kiM=1;                                                  /* 現在の配字簿の配鍵控え */
BYTE kiD=1;                                                          /* 字引の配鍵控え */
BYTE kiF=1;                                                  /* 現在の表示簿の配鍵控え */
BYTE Km=49;                                                  /* 最大文字鍵番号  49か48 */
BYTE Sv=0;                                                            /* 1 Ctrl、2 Alt */
BYTE Cp=0;                                                 /* CapsLock  0 オフ、1 オン */
BYTE Mr=0;                                                       /* 0 単打相、8 複打相 */
BYTE Ms=0;               /* 配字が対相の時 0x01、乙鍵盤固定解除を要する時 0x02の論理和 */
BYTE Mkn=0;  /* 倣い入力の配字簿探しで得た配字簿の文字鍵番号（但し、0:無、100:未調査） */
BYTE Mkns=0;                     /* 倣い入力で文字列のある配字簿を探す余地がある時 100 */
BYTE Dkn=0;                /* 字引探しで得た字引の文字鍵番号（但し、0:無、100:未調査） */
BYTE Mk=0;                                                   /* 配字簿の選択待ちの時 1 */
BYTE Dk=0;                                                     /* 字引の選択待ちの時 1 */
BYTE Gk=0;                                                   /* 表示簿の選択待ちの時 1 */
BYTE Ak=0;             /* 鍵盤の備考参照の時 1、文字鍵の下見の時 2、機能鍵の下見の時 3 */
BYTE Ll=0;                                       /* 甲鍵Lock(複打相での甲打省略)の時 1 */
BYTE Sh=0;                                                         /* Shift 0 離、1 押 */
BYTE Kn=0;                                                                 /* 配鍵番号 */
BYTE pKn=0;                                                      /* 前回打鍵の配鍵番号 */
BYTE pKpr=0;                                                         /* 前回押しなら 1 */
Time ptime=0;                                                    /* 前回打鍵の生起時刻 */
BYTE K0=0;                                                        /* 鍵盤表裏 50*Sh    */
BYTE Kd=0;                                                        /* 文字打鍵 50*Sh+Kn */
BYTE Lk=0;                                                           /* 甲鍵番号00～99 */
BYTE Rk=0;                                                       /* 倣い甲鍵番号00～99 */
BYTE Fk=0;                                                       /* 倣い乙鍵番号00～99 */
BYTE Fn=0;      /* 赤い字で示す文字列のバイト数の控え(但し多バイトでも１字だけの時は0) */
BYTE Knx=0;                                          /* 該当鍵ではない倣い打鍵Knの控え */
BYTE rd=0;                                                     /* 再描画が必要なとき 1 */
BYTE CT=0;                                           /* 自力入力の時 0、倣い入力の時 1 */
BYTE Co=1;                   /* 呼び字列入力時 1、表記群表示時 2、倣いの乙打待ちの時 3 */
BYTE Ci=0;                                                     /* 呼び字列中の文字位置 */
BYTE Cn=0;                                               /* 呼び字列の入力済みバイト数 */
BYTE Ti=0;                                                   /* 注目表記列中の文字位置 */
BYTE Tn=0;                                                     /* 注目表記列のバイト数 */
BYTE Cd[10]={' ',' ',' ',' ',' ',' ',' ',' ', 0, 0};       /* 案内右下に示す文字コード */
BYTE Cs[Cmax+2];                                                     /* 呼び字列表示用 */
BYTE Ts[Cmax+2];                                                   /* 注目表記列表示用 */
BYTE Cw[Cmax+2];                               /* 呼び字列の各文字の開始位置とバイト数 */
BYTE Tw[Cmax+2];                             /* 注目表記列の各文字の開始位置とバイト数 */
long int Dl=0;                       /* 字引の読出し先頭の行位置（1 から数えた行番号） */
BYTE Dc=0;                          /* 表記の種類： 該当なし 0、コード 1、一般文字列 2 */
BYTE Di=0;                                               /* 表記群中の注目表記行の位置 */
BYTE Dn=0;                                                             /* 表記群の行数 */
XftFont *cft=NULL;                                       /* 現在使用中のフォントセット */
int          Wx=0, Wy=0;                                   /* 配字案内の位置（左上端） */
int          Fx=0, Fy=0;                 /* 配字案内枠の中心線のＸ座標と基準辺のＹ座標 */
unsigned int Ww, Wh;                                                           /* 寸法 */
BYTE Wxt=0;    /* 鍵盤図か完全に画面の内側にある時 0、左側が画面左端の時 1、右端の時 2 */
BYTE Wyt=1;  /* 倣い入力時の拡張を鍵盤図の上方に出す、つまり、配字案内の基線が下の時 1 */
int          hh, hx, cxo, cyo;                                     /* 表示部分の諸寸法 */
unsigned int uw, dh, dh2, lh, ccw, cch, cw2, ch2;
BYTE         Gw=44;                                      /* 鍵盤図の縦格子による区画数 */
unsigned int KPos[58][2];                                                /* 各鍵の位置 */
int          Rc1x, Rc2x, Rc3x, Rc4x, Rc5x;                                   /* 位置 x */
int          Rc1y, Rc2y, Rc3y, Rc4y, Rc5y;                                   /* 位置 y */
unsigned int Rc1w, Rc2w, Rc3w, Rc4w, Rc5w;                                     /* 幅 w */
unsigned int Rc1h, Rc2h, Rc3h, Rc4h, Rc5h;                                     /* 高 h */
int  En=0;                 /* XNextEventで取り出した時まだキューに残るイベント数の控え */
BYTE Gon=1;                                         /* 配字案内表示 0:出さない、1:出す */
BYTE Dsp=3;                  /* 0:無盤表示、1:鍵盤定形表示、2:注目行表示、3:表記群表示 */
BYTE Hon=1;                                        /* 白抜き文字矩形の表示を用いる時 1 */
BYTE sz =0;                                                  /* 表示枠に変更がある時 1 */
BYTE Son=0;                              /* 現在設定している配字簿の使用統計を取る時 1 */
BYTE Sfq=0;                                            /* 計数後まだ保存していない時 1 */
UINT Sctt=0;                                         /* 起動から現時点までの乙打成立数 */
UINT Sct=0;                                                        /* 積算数の一時控え */
UINT Rct=0;                                /* 起動時からの総KeyRelease回数の積算値控え */
BYTE SctCd[12];                                        /* 積算数の表示用数字表記の控え */
BYTE ph=0;                                           /* 非倣い打鍵表示の控えがある時 1 */
BYTE ntD[Cmax+2];                                                    /* 下見字列の控え */

char *fgett(char *B, int M, FILE *f){      /* 改行まで読み込み、B[]に最大でM-1まで採る */
  int i;
  BYTE *s, c, *w, W[256];

  B[0]=0; B[1]=0; B[2]=0; B[3]=0;              /* 予めバッファの先頭４バイトを空にして */
  if(s=fgets(B, M, f)){                                         /* 最大M-1まで読み込む */
    for(i=0; (c=B[i])!='\n' && i<M-1; i++);                          /* 終りまで辿って */
    if(c=='\n') B[i]=0;       /* 改行符号なら１行全部収めた最後なので、それを0に替える */
    else{                                       /* でなければM-1を越える残りがあるので */
      for(; w=fgets(W, 256,f); ){           /* 最大255バイトずつ読み込むことを繰返して */
        for(i=0; (c=W[i])!='\n' && i<255; i++);
        if(c=='\n') break;                                       /* 行末まで読み捨てる */
      }
    }
  }
  return s;
}

BYTE mb_chk(BYTE *p){                         /* バイト列pの先頭字のバイト数を算出する */
  BYTE m, b;

  if((b=*p) & 0x80){                                                     /* 多バイト字 */
    if((b&0xe0)==0xc0 && (*(p+1)&0xc0)==0x80) m=2;
    else if((b&0xf0)==0xe0 && (*(p+1)&0xc0)==0x80 && (*(p+2)&0xc0)==0x80) m=3;
    else if((b&0xf8)==0xf0 &&
       (*(p+1)&0xc0)==0x80 && (*(p+2)&0xc0)==0x80 && (*(p+3)&0xc0)==0x80) m=4;
    else if((b&0xfc)==0xf8 &&
       (*(p+1)&0xc0)==0x80 && (*(p+2)&0xc0)==0x80 && (*(p+3)&0xc0)==0x80 &&
       (*(p+4)&0xc0)==0x80 ) m=5;
    else if((b&0xfe)==0xfc &&
       (*(p+1)&0xc0)==0x80 && (*(p+2)&0xc0)==0x80 && (*(p+3)&0xc0)==0x80 &&
       (*(p+4)&0xc0)==0x80 && (*(p+5)&0xc0)==0x80) m=6;
    else m=0;                                                            /* 不当コード */
  }else{                                                                 /* １バイト字 */
    m=1;
  }
  return m;
}

void h2c(BYTE h, BYTE s[2]){                       /* hを十六進数２字にしてs[]に入れる */
  BYTE d;
  d=h>>4;   if(d<=9) s[0]=d+'0'; else s[0]=d-10+'A';
  d=h&0x0f; if(d<=9) s[1]=d+'0'; else s[1]=d-10+'A';
}

void w2c(WYTE w, BYTE s[4]){                       /* wを十六進数４字にしてs[]に入れる */
  BYTE c;
  c=(BYTE)(w >> 8);     h2c(c, &s[0]);
  c=(BYTE)(w & 0x00ff); h2c(c, &s[2]);
}

BYTE u2U(BYTE *u, BYTE *U){/* UTF-8のバイト列uをUnicodeの数字列にしてUに入れ桁数を得る */
  CARD32         dw;
  WYTE            w;
  BYTE c, i=0, m=0, n=0;

  if((c=u[0]) & 0x80){                                          /* 多バイト字 1xxxxxxx */
    if(c & 0x40){                                                          /* 11xxxxxx */
      if(c & 0x20){                                                        /* 111xxxxx */
        if(c & 0x10){                                                      /* 1111xxxx */
          if(c & 0x08){                                                    /* 11111xxx */
            if(c & 0x04){                                                  /* 111111xx */
              if(c & 0x02) m=0;                              /* 非UTF-8バイト 1111111x */
              else {c&=0x01; m=6;}                              /* ６バイト字 1111110u */
            }else {c&=0x03; m=5;}                               /* ５バイト字 111110vv */
          }else {c&= 0x07; m=4;}                                /* ４バイト字 11110www */
        }else {c&=0x0f; m=3;}                                   /* ３バイト字 1110xxxx */
      }else {c&=0x1f; m=2;}                                     /* ２バイト字 110yyyyy */
      dw=(CARD32)c;
      for(i=1; i<m; i++){                                          /* 従属バイトの処理 */
        if(((c=u[i]) & 0xc0)==0x80){dw=(dw<<6) + (c&=0x3f);}               /* 10xxxxxx */
        else {m=0; break;}                       /* 従属バイトでなければ 非UTF-8バイト */
      }
      if(m && m<4){w2c((WYTE)dw, U); n=4;}                     /* ４桁で表せる数は４桁 */
      else if(m>3){                               /* 上16ビットが0でなければ８桁で表す */
        w=(WYTE)(dw>>16);                                                    /* 上４桁 */
        if(dw<0x00110000){        /* 0x00010000～0x0010ffff の範囲にある文字コードの時 */
          h2c((BYTE)w, U); w2c((WYTE)dw, &U[2]); n=6;
        }else{                                    /* UCS-4でしか表せない文字コードの時 */
          w2c(w, U);       w2c((WYTE)dw, &U[4]); n=8;
        }
      }
    }                                          /* 先頭バイトが10xxxxxxは 非UTF-8バイト */
  }else {w2c((WYTE)c, U); n=4; i=1; m=1;}                      /* １バイト字 0xxxxxxx  */
  if(i && i==m){                                                     /* 文字が成立して */
    if(u[i-1]>' ' && u[i]>' ') U[n++]='+';     /* 後続字も倣わず入力の対象になるなら + */
    else                       U[n++]=' ';         /* そうでなければ半角スペースを付す */
  }
  U[n]=0;
  return n;
}

BYTE b2B(BYTE *B, BYTE *C){      /* BをUTF-8字列と見てそれをUnicode表記にしてCに入れる */
  BYTE i, j, c, d, n=0;
  BYTE w, U[Hmax+2];
  if(j=u2U(B, &C[2])){     /* BがUTF-8のバイト列ならそれをUnicodeの数字列にしてCに入れ */
    C[0]='U'; C[1]='+'; j+=2;                                              /* U+を冠す */
  }
  C[j]=0;
  return j;
}

BYTE isCode(BYTE B[], BYTE u[]){/* BがU+十六進数4,6,8桁ならUTF-8をuに入れバイト数を返す*/
  BYTE  i, c, d, n=0;
  CARD32 dw=0;
  if(B[0]=='U' && B[1]=='+'){                                     /* Unicodeの数字表記 */
    for(i=2; (c=B[i])>='0' && c<='F' && i<10; i++){/* 十六進数字表記をバイナリ値に変換 */
      if     (c<='9') d=c-'0';                                   /* '0'～'9' なら 0～9 */
      else if(c>='A') d=c-'A'+10;                                /* 'A'～'F' なら a～f */
      else break;                            /* 非十六進数字に出会ったらそこで打ち切る */
      dw=(dw<<4) + d;
    }
    if((i==10 || i==8 || i==6) && c<=' '){         /* U+HHHHHHHH か U+HHHHHH か U+HHHH */
      if(dw<=0x0000007f){                       /* 00000000 00000000 00000000 0zzzzzzz */
        u[0]=(BYTE)dw; n=1;                                                /* 0zzzzzzz */
      }else if(dw<=0x000007ff){                 /* 00000000 00000000 00000yyy yyzzzzzz */
        u[1]=(BYTE)(dw & 0x0000003f) | 0x80;                      /*          10zzzzzz */
        dw=dw>>6; u[0]=(BYTE)(dw & 0x0000001f) | 0xc0; n=2;       /*          110yyyyy */
      }else if(dw<=0x0000ffff){                 /* 00000000 00000000 xxxxyyyy yyzzzzzz */
        u[2]=(BYTE)(dw & 0x0000003f) | 0x80;                      /*          10zzzzzz */
        dw=dw>>6; u[1]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10yyyyyy */
        dw=dw>>6; u[0]=(BYTE)(dw & 0x0000000f) | 0xe0; n=3;       /*          1110xxxx */
      }else if(dw<=0x001fffff){                 /* 00000000 000wwwxx xxxxyyyy yyzzzzzz */
        u[3]=(BYTE)(dw & 0x0000003f) | 0x80;                      /*          10zzzzzz */
        dw=dw>>6; u[2]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10yyyyyy */
        dw=dw>>6; u[1]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10xxxxxx */
        dw=dw>>6; u[0]=(BYTE)(dw & 0x00000007) | 0xf0; n=4;        /*         11110www */
      }else if(dw<=0x03ffffff){                 /* 000000vv wwwwwwxx xxxxyyyy yyzzzzzz */
        u[4]=(BYTE)(dw & 0x0000003f) | 0x80;                      /*          10zzzzzz */
        dw=dw>>6; u[3]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10yyyyyy */
        dw=dw>>6; u[2]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10xxxxxx */
        dw=dw>>6; u[1]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10wwwwww */
        dw=dw>>6; u[0]=(BYTE)(dw & 0x00000003) | 0xf8; n=5;        /*         111110vv */
      }else if(dw<=0x7fffffff){                 /* 0uvvvvvv wwwwwwxx xxxxyyyy yyzzzzzz */
        u[5]=(BYTE)(dw & 0x0000003f) | 0x80;                      /*          10zzzzzz */
        dw=dw>>6; u[4]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10yyyyyy */
        dw=dw>>6; u[3]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10xxxxxx */
        dw=dw>>6; u[2]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10wwwwww */
        dw=dw>>6; u[1]=(BYTE)(dw & 0x0000003f) | 0x80;            /*          10vvvvvv */
        dw=dw>>6; u[0]=(BYTE)(dw & 0x00000001) | 0xfc; n=6;       /*          1111110u */
      }
    }
  }
  u[n]=0;
  return n;
}

BYTE str_chk(BYTE *s){          /* 0終端バイト列sがUTF-8のバイト列であることを確かめる */
  BYTE i, m;
  for(i=0; s[i] && (m=mb_chk(&s[i])); i+=m);
  s[i]=0;
  return i;
}

void hm(BYTE *B, BYTE *h, BYTE *m, BYTE *H, BYTE *M){
                                      /* 行内容B～の見出しをH～に、本字列をM～に入れる */
  unsigned int i;
  BYTE c, j, k;
  j=0; k=0; M[0]=0;
  for(i=0; (c=B[i])>=' '; i++) {if(j<Hmax){H[j]=c; j++;}}                  /* 見出し部 */
  H[j]=0;
  j=str_chk(H);
  if(c=='\t'){                                   /* 次の区画(本字列)との区切りがあれば */
    for(i++; (c=B[i])>=' '; i++){if(k<Cmax){M[k]=c; k++;}} M[k]=0;           /* 本字列 */
    k=str_chk(M);
  }
  *h=j; *m=k;
}

Bool head_hm(BYTE *fname, BYTE *h, BYTE *m, BYTE *H, BYTE *M){
                  /* fname簿の先頭行を見出しと本字列に分けてそれぞれを指定場所に収める */
  FILE *f;
  int  r=False;
  BYTE B[Bmax];
  *h=0; *m=0; H[0]=0; M[0]=0;                                      /* まず全部空にして */
  if(fname && *fname && (f=fopen(fname, "r"))){                      /* ファイルを開き */
    fgett(B, Bmax, f);                                           /* 先頭行を読み込んで */
    fclose(f);                                                       /* ファイルは閉じ */
    hm(B, h, m, H, M);                                   /* 行内容を見出しと標題に分け */
    if(*h||*m) r=True;                                  /* どちらかがあればTrueにする  */
  }
  return r;
}

BYTE *specialString(BYTE *p){    /* ]で始まる特殊字列の処理   pは]の次のアドレスを指す */
  BYTE *r, *q, b, i;
  w_str[0]=0;
  r=w_str;
  q=p;
  if((b=*q++)==']'){                                          /* ]から始まる通常の字列 */
    r=p;
  }else if(b=='t'){                                    /* その時点での日時の字列を作る */
    if(*q=='D' || *q=='T' || *q=='W'){                       /* ]tD か ]tT か ]tW なら */
      struct tm *t;
      time_t timer;
      time(&timer);
      if(*(q+1)=='g'){                                                       /* 世界時 */
        t=gmtime(&timer);
      }else{                                                   /* 'l' を想定    地域時 */
        t=localtime(&timer);
      }
      if(*q=='D'){                                                             /* 日付 */
        sprintf(w_str, "%02d%c%02d%c%02d",
                    t->tm_year%100, *(q+2), t->tm_mon+1, *(q+2), t->tm_mday);
      }else if(*q=='T'){                                                       /* 時刻 */
        sprintf(w_str, "%02d:%02d:%02d", t->tm_hour, t->tm_min, t->tm_sec);
      }else{                                                           /* 'W'     曜日 */
        b=t->tm_wday;                                                          /* 0～6 */
        if(b<7){                                                           /* 念のため */
          q++;                                                        /* qはgかlの位置 */
          for(i=0; i<b; i++) for(q++ ; *q!=0 && *q!=' ' ;q++);
          if(*q){
            for(i=0, q++; *q!=0 && *q!=' ' ;i++, q++) w_str[i]=*q;
            w_str[i]=0;
          }
        }
      }
    }
  }else if(b=='v' && *q<=' '){                                              /* ]v なら */
    r=KIDATE;                                                        /* IMNATEの版日付 */
  }else if(b=='M' && q[0]=='/' && q[1]=='R' && q[2]<=' '){                /* ]M/R なら */
    sprintf(w_str, "M/R=%ld/%ld", Sctt, Rct);   /* 起動後成立した乙打数/総KeyRelease数 */
  }else if(!b){                                                                /* 未定 */
  }
  return r;
}

BYTE *s_date(){                                  /* 統計簿の作成・更新日時の字列を作る */
  struct tm *t;
  time_t timer;
  time(&timer);
  t=localtime(&timer);
  sprintf(w_str, "%02d-%02d-%02d %02d:%02d:%02d",
         t->tm_year%100, t->tm_mon+1, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec);
  return w_str;
}

BYTE *pMDG(BYTE e, BYTE k){
  BYTE *p;
  BYTE E[3][2]={"M", "D", "G"};
  strcpy(MDG, BKS); strcat(MDG, E[e]); strcat(MDG, Kdd[k]);
  return p=MDG;
}

Bool load_kiKey(){                                                 /* 配鍵表を設定する */
  FILE *f;
  Bool r=False;
  USHORT i;
  BYTE B[Bmax];
  BYTE n, u, l, sc, kn[256], nk[67], ny[58], nx[58];
  if(!(f=fopen(pMDG(0, 0), "r"))) return r;                  /* 配鍵簿がなければ即出る */
    for(i=0; i<256; i++) kn[i]=0;  /* keycode の配鍵番号を見る作業用の表を空にしておく */
    for(n=1; n<67; n++){       /* 先頭行から66行を順に読込んで各鍵の設定値を採取をする */
      if(!fgett(B, Bmax, f)) break;    /* １行ずつ読み込み、途中で簿末なら採取を止める */
      if(n==1 && B[0]==0xef && B[1]==0xbb && B[2]==0xbf){   /* 先頭にBOMが付いていたら */
        B[0]=B[3]; B[1]=B[4];  B[2]=B[5];                                /* 取り除いて */
        B[3]=B[6];  B[4]=B[7];  B[5]=B[8]; B[6]=B[9]; B[7]=B[10];        /* 前に詰める */
      }
      if((B[0]==' '||B[0]=='0'||B[0]=='1'||B[0]=='2') &&
         ((B[0]==' ' && B[1]==' ')||(B[1]>='0'&& B[1]<='9')) &&
         (B[2]>='0' && B[2]<='9')   ){            /* ３桁までの十進数表記によるkeycode */
        if(B[0]==' ') B[0]='0';
        if(B[1]==' ') B[1]='0';
        i=(B[0]-'0')*100+(B[1]-'0')*10+(B[2]-'0');
        if(!i && (n<49 || n==50)) break;      /* 基本文字鍵の文字コードが0なら中止する */
        if(i && kn[i]) break;    /* 配鍵に重複があったらこの配鍵簿からの採取を中止する */
        nk[n]=i; if(i) kn[i]=n;                        /* 正常なら作業領域に控えておく */
        if(n<58){                            /* １～57の鍵については表示位置を取り出す */
          BYTE y, x;
          ny[n]=0; nx[n]=0;                                    /* 始め 0,00 にしておく */
          if(B[3]=='|' && (y=B[4])>='0' && y<='5' && B[5]==',' &&
             (u=B[6])>='0' && u<='4' && (l=B[7])>='0' && l<='9'){
            y=y-'0';                                                             /* 段 */
            x=(u-'0')*10+(l-'0');                                                /* 桁 */
            if(i && y && x && x<(Gw-2)){ny[n]=y; nx[n]=x;}       /* 鍵の段と桁を控える */
          }
        }
      }else{
        break;                         /* 正しい指定でなければこの配鍵簿の採用を止める */
      }
    }
    fclose(f);                                                       /* ファイルを閉じ */
    if(n==67){             /* 全66行を採取できたら、作業領域に得たデータをメモリに写す */
      BYTE j;
      for(i=0; i<256; i++) kton[i]=kn[i];         /* keycodeに対応する配鍵番号を引く表 */
      for(j=1; j<67; j++) ntok[j]=nk[j];
      for(j=1; j<=57; j++){if(ny[j]) ntoy[j]=ny[j]; if(nx[j]) ntox[j]=nx[j];}
      if(ntok[49]) Km=49; else {Km=48; ntoy[j]=0; ntox[j]=0;}/* 最大配鍵番号が48か49か */
      r=True;
    }
  return r;
}

void load_FH(){                                    /* 54～57鍵の見出し字列群を読み込む */
  FILE *f;
  BYTE k, h, m, B[Bmax], H[Hmax+2], M[Cmax+2];
  if(!(f=fopen(pMDG(2, 0), "r"))) return;          /* 機能鍵案内簿がなければ何もしない */
  for(k=1; k<=30; k++){                                          /* １行ずつ読み込んで */
    if(!fgett(B, Bmax, f)) break;            /* ファイルが途中で終っていたらそこで終了 */
    if(B[0]) hm(B, &h, &m, FH[k], M);          /* 空行でなければ見出し字列をFHに納める */
  }
  fclose(f);                                                       /* ファイルを閉じる */
}

void make_kiSt(){                      /* 単打鍵盤の配字表をXlib内の“配字表”から作る */
  BYTE  i, kn, m, n, sm, sh, k, c, *r, *w;
  KeySym ksm;
  XKeyEvent kev;                                                       /* 擬似イベント */

  kev.type        = KeyPress;
  kev.serial      = 0;
  kev.send_event  = False;
  kev.display     = dpy;
  kev.window      = root;
  kev.root        = root;
  kev.subwindow   = 0;
  kev.time        = 0;
  kev.x           = 0;
  kev.y           = 0;
  kev.x_root      = 0;
  kev.y_root      = 0;
  kev.same_screen = True;
  for(kn=1; kn<=Km; kn++){
    kev.keycode= ntok[kn];
    for(m=0; m<16; m++){
      BYTE buf[6]={0, 0, 0, 0, 0, 0};
      sm=m/2; sh=m%2; kev.state=m; k=50*sh+kn;
      n=XLookupString(&kev, buf, 4, &ksm, 0);
      w=kiStH[sm][k];                                                        /* 見出し */
      if((c=buf[0])<' '){                                   /* 0x00～0x1f   ７乂制御字 */
        w[0]='^';
        w[1]=0x40 | buf[0];                                            /* ^Aの形で示す */
        if(n>1) w[1] |= 0x20;                  /* 後に更に字がある場合には^aの形で示す */
      }else if(c>=0x80 && c<0xa0){                           /* 0x80～0x9f  ８乂制御字 */
        w[0]='~';
        w[1]=(c & 0x7f) | 0x40;                                        /* ~Aの形で示す */
        if(n>1) w[1] |= 0x20;                  /* 後に更に字がある場合には~aの形で示す */
      }else{                                       /* 0x20～0x7f、0xa0～0xff  図形文字 */
        if(n==1){                                                    /* それ１字だけで */
          if(c==' ') {w[0]='S'; w[1]='P';}                     /* 空白文字ならSPで示し */
          else       {w[0]=' '; w[1]=c;}             /* 図形文字なら空白文字を前に置く */
        }else        {w[0]=c;   w[1]='+';} /* 後に更に字があれば、+ を付してそれを示す */
        w[2]=0;
      }
      w=kiStM[sm][k];                                                    /* 文字コード */
      for(i=0; i<n; i++) w[i]=buf[i];
      w[i]=0;
    }
  }
  if(Km==48){                                                  /* 49番鍵のない鍵盤の時 */
    for(m=0; m<16; m++){                             /* 49番鍵の部分を空コードで埋める */
      sm=m/2; sh=m%2; k=50*sh+49;
      kiStH[sm][k][0]=' '; kiStH[sm][k][1]=' '; kiStH[sm][k][2]=0;
      kiStM[sm][k][0]=0;
    }
  }
  for(m=0; m<16; m++){                /* 25番鍵(通常a)の見出しを鍵盤の見出しに流用する */
    sm=m/2; sh=m%2; k=50*sh;
    for(i=0; (c=kiStH[sm][k+25][i]); i++) kiStH[sm][k][i]=c; kiStH[sm][k][i]=0;
    for(i=0; (c=kiStM[sm][k+25][i]); i++) kiStM[sm][k][i]=c; kiStM[sm][k][i]=0;
  }
}

void make_Dsp(BYTE e){               /* 0;配字簿 、1:字引、2:表示簿 の配鍵案内表を作る */
  BYTE *q, k, h, m, M[Cmax+2];
  for(k=1; k<100; k++){
    if(k==50) continue;
    head_hm((q=pMDG(e, k)), &h, &m, kiDsp[e][k], M);
    if(!h){                                          /* 見出しが空なら空白文字で埋める */
      q=kiDsp[e][k]; q[0]=' '; q[1]=' '; q[2]=0;
    }
  }
}

void load_Stat(){              /* 現配字簿の統計値があれば取り込んで、統計の用意をする */
  FILE *f;
  Son=0; Sfq=0;                        /* 始めは、現配字簿に統計簿無し、保存不要にして */
  strcpy(MDG, VAR); strcat(MDG, "M"); strcat(MDG, Kdd[kiM]); strcat(MDG, ".freq");
  if(f=fopen(MDG, "r")){                                     /* 現配字簿の統計簿を開き */
    BYTE j, B[Bmax];
    BYTE lk, fk;
    UINT total=0, d;
    fgett(B, Bmax, f);                                           /* 先頭行を読み込んで */
    if(B[0]){                                                          /* 空でなければ */
      B[9]=0; total=(UINT)atol(B);                           /* 総数を取り出して控える */
      for(lk=0; lk<100; lk++){                   /* 統計値領域Stat[100][100]に読み込む */
        if(lk==50) continue;                         /* Stat[50][fk]に該当する行はない */
        fgett(B, Bmax, f);                           /* 文字鍵番号見出し行は読み捨てる */
        for(fk= 0; fk< 50; fk++){                                            /* 表鍵盤 */
          if(fk== 0 || fk== 1 || fk==13 || fk==25 || fk==37){fgett(B, Bmax, f); j=0;}
          B[j+9]=0;
          Stat[lk][fk]=(UINT)atol(&B[j+1]);                        /* 該当項を取り出す */
          j+=9;                                      /* 取り出す位置を次の項目に進める */
        }
        fgett(B, Bmax, f);                       /* 裏鍵盤に移る区切りの行は読み捨てる */
        for(fk=50; fk<100; fk++){                                            /* 裏鍵盤 */
          if(fk==50 || fk==51 || fk==63 || fk==75 || fk==87){fgett(B, Bmax, f); j=0;}
          B[j+9]=0;
          Stat[lk][fk]=(UINT)atol(&B[j+1]);                        /* 該当項を取り出す */
          j+=9;                                      /* 取り出す位置を次の項目に進める */
        }
        fgett(B, Bmax, f);                   /* 次の甲鍵盤に移る区切りの行は読み捨てる */
      }
      fgett(B, Bmax, f);                                 /* 開始日時をS_dateに取り出す */
      for(j=0; B[j]!=0 && j<19 ;j++) S_date[j]=B[j]; S_date[j]=0;
      fclose(f);                                   /* 従来値を採取したファイルを閉じる */
      for(lk=1; lk<=49; lk++){                                   /* 乙鍵盤表裏各の小計 */
        for(d=0, fk= 1; fk<=49; fk++) d+=Stat[lk][fk]; if(Stat[lk][ 0]!=d) return;
        for(d=0, fk=51; fk<=99; fk++) d+=Stat[lk][fk]; if(Stat[lk][50]!=d) return;
      }
      for(lk=51; lk<=99; lk++){                                  /* 乙鍵盤表裏各の小計 */
        for(d=0, fk= 1; fk<=49; fk++) d+=Stat[lk][fk]; if(Stat[lk][ 0]!=d) return;
        for(d=0, fk=51; fk<=99; fk++) d+=Stat[lk][fk]; if(Stat[lk][50]!=d) return;
      }
      for(lk= 1; lk<=49; lk++){d=Stat[lk][0]+Stat[lk][50]; if(Stat[0][lk]!=d) return;}
      for(lk=51; lk<=99; lk++){d=Stat[lk][0]+Stat[lk][50]; if(Stat[0][lk]!=d) return;}
      for(d=0, lk= 1; lk<=49; lk++) d+=Stat[0][lk]; if(Stat[0][ 0]!=d) return;
      for(d=0, lk=51; lk<=99; lk++) d+=Stat[0][lk]; if(Stat[0][50]!=d) return;
      d=Stat[0][0]+Stat[0][50];
      if(total!=d) return;
    }else{                                /* 空なら統計値領域に0を詰めて新たに開始する */
      fclose(f);                                             /* 空だった統計簿を閉じる */
      for(lk=0; lk<100; lk++){
        for(fk=0; fk<100; fk++) Stat[lk][fk]=0;
      }
      strcpy(S_date, s_date());                                    /* 作成日時を控える */
    }
    Son=1;
  }
}

void save_Stat(){                                  /* Statを該当の配字統計簿に保存する */
  FILE *f;
  if(!Son || !Sfq) return;     /* 配字簿設定時に統計簿なし、あるいは、変化なしなら出る */
  strcpy(MDG, VAR); strcat(MDG, "M"); strcat(MDG, Kdd[kiM]); strcat(MDG, ".freq");
  if(f=fopen(MDG, "w")){                                 /* 統計簿への書出しを準備する */
    BYTE lk, fk;
    fprintf(f, " %8ld %s\n", Stat[ 0][ 0]+Stat[ 0][50], MDG);          /* 総数と統計簿 */
    for(lk= 0; lk<=49; lk++){
      fprintf(f, "%02d %s\n", lk, kiMapH[lk][ 0]);
      for(fk= 0; fk<=49; fk++){;
        fprintf(f, " %8ld", Stat[lk][fk]);
        if(fk== 0 ||fk==12 || fk==24 || fk==36 || fk==49) fprintf(f, "\n");
      }
      fprintf(f, "\n");
      for(fk=50; fk<=99; fk++){;
        fprintf(f, " %8ld", Stat[lk][fk]);
        if(fk==50 ||fk==62 || fk==74 || fk==86 || fk==99) fprintf(f, "\n");
      }
      fprintf(f, "\n");
    }
    for(lk=51; lk<=99; lk++){
      fprintf(f, "%02d %s\n", lk, kiMapH[lk][ 0]);
      for(fk= 0; fk<=49; fk++){;
        fprintf(f, " %8ld", Stat[lk][fk]);
        if(fk== 0 ||fk==12 || fk==24 || fk==36 || fk==49) fprintf(f, "\n");
      }
      fprintf(f, "\n");
      for(fk=50; fk<=99; fk++){;
        fprintf(f, " %8ld", Stat[lk][fk]);
        if(fk==50 ||fk==62 || fk==74 || fk==86 || fk==99) fprintf(f, "\n");
      }
      fprintf(f, "\n");
    }
    fprintf(f, "%s\n", S_date);                                            /* 作成日と */
    fprintf(f, "%s\n", s_date());                                    /* 更新日を付して */
    fprintf(f, "%s\n", KIDATE);
    fclose(f);                                                         /* 統計簿を閉じ */
    Sfq=0;                                                     /* 保存済みの印をつける */
  }
}

Bool load_kiMap(BYTE k){                       /* 文字鍵番号 kの配字簿で配字を設定する */
  FILE *f;
  Bool r=False;

  if(!k || k==50) return r;                                            /* 00と50は除く */
  if(f=fopen(pMDG(0, k), "r")){                                    /* 配字簿が開けたら */
    BYTE h, m, H[Hmax+2], M[Cmax+2], B[Bmax];
    BYTE j, c, lk, fk;
    BYTE *q;
    int l;
    fgett(B, Bmax, f);                                             /* 先頭行を読み込み */
    hm(B, &h, &m, H, M);                                       /* 見出しと標題に分けて */
    if(!h || !m){fclose(f); return r;}             /* 見出しも標題もなければ無効とする */
    save_Stat();                             /* 元の配字簿に統計簿があればそれを更新し */
    strcpy(kiMapH[0][0], H); strcpy(kiMapM[0][0], M);/* 新配字簿の見出しと標題を取込む */
    fgett(B, Bmax, f);                                             /* ２行目を読み込み */
    hm(B, &h, &m, kiMapH[0][50], kiMapM[0][50]);         /* 裏甲の見出しと標題を収める */
    for(l=3; l<10000; l++){
      fgett(B, Bmax, f);                                           /* １行ずつ読み込み */
      if((l>=100 && l<5000)||(l>=5100 && l<10000)){          /* 配字記述行から採取する */
        lk=(BYTE)(l/100); fk=(BYTE)(l%100);
        hm(B, &h, &m, kiMapH[lk][fk], kiMapM[lk][fk]);     /* 見出しと本字列を取り込む */
        if(!fk){                               /* 表乙鍵盤の標題行を集めて甲鍵盤を作る */
          strcpy(kiMapH[0][lk], kiMapH[lk][0]); strcpy(kiMapM[0][lk], kiMapM[lk][0]);
        }
      }
    }
    fclose(f);                                                       /* 配字簿を閉じる */
    {
      BYTE s, lk, fk;
      for(s=0; s<2; s++){
        if(s){lk=99; fk=0;} else {lk=49; fk=1;}
        for(; fk<=99; fk++){
          if(K49H[s][fk][0]){                                    /* 見出しがあれば採る */
            strcpy(kiMapH[lk][fk], K49H[s][fk]);
            strcpy(kiMapM[lk][fk], K49M[s][fk]);
          }
        }
      }
    }
    kiM=k;                                                   /* 配字簿の控えを更新して */
    load_Stat();                               /* 統計採取の用意があればその準備をする */
    Ll=Lk=0;                                     /* 甲打省略を解放して甲打待ちに備える */
    r=True;
  }
  return r;
}                                                               /* end of load_kiMap() */

Bool load_kiDic(BYTE k){                   /* 文字鍵番号 kの字引があれば現行に設定する */
  BYTE h, m, H[Hmax+2], M[Cmax+2];
  if(!k || k==50) return False;            /* 標題ファイルの指定番号であれば何もしない */
  if(head_hm(pMDG(1, k), &h, &m, H, M));                     /* 字引があればそれを採る */
  else return False;                                         /* それ以外なら現在のまま */
  if(!h){                                                          /* 見出しがない場合 */
    return False;
  }
  strcpy(kiDsp[1][k], H);                      /* 念のため現字引の見出しを更新しておく */
  strcpy(DicM, M);                                                       /* 字引の標題 */
  kiD=k;
  Dl=0;
  Dn=0;
  return True;
}

void check_kiDic(BYTE *B){    /* B[]の標題行内容が現行字引の控えと違っていたら更新する */
  BYTE h, m, H[Hmax+2], M[Cmax+2];
  hm(B, &h, &m, H, M);                                         /* 見出しと標題に分けて */
  if(strcmp(kiDsp[1][kiD], H) || strcmp(DicM, M)){                   /* 控えと違うなら */
    strcpy(kiDsp[1][kiD], H);                                  /* 更新しておく: 見出し */
    strcpy(DicM, M);                                                           /* 標題 */
  }
  return;
}

Bool load_kiFnt(BYTE k){                                         /* フォントを設定する */
  BYTE  *q, h, m, H[Hmax+2], M[Cmax+2];
  Bool  r=False;
  BYTE  gon=0;
  if(!k || k==50) return r;                              /* 実文字鍵番号でなければ無効 */
  if(head_hm(pMDG(2, k), &h, &m, H, M)){
    if(M[0]==']'){                                               /* 様式指定部がある時 */
      BYTE a;
      a=M[1];
      if(a=='_'|| a=='-' || a=='=' || a=='~'){                     /*  ]_  ]-  ]=  ]~  */
        BYTE dsp;
        if(a=='_') dsp=0; else if(a=='-') dsp=1; else if(a=='=') dsp=2; else dsp=3;
        if(dsp!=Dsp){Dsp=dsp; gon=1; sz=1;}              /* 異なればその様式に変更する */
        q=&M[2];                                     /* 改めてフォント名先頭位置を出す */
      }else {if(k==1) q=dfs; else return r;}                         /* ] だけなら無効 */
    }else if(M[0]==':' && M[1]==':'){           /* :: 鍵矩形の表示・不表示を切り替える */
      if(k==1) q=dfs;
      else {if(Hon) Hon=0; else Hon=1; return r;}
    }else q=M;
    if(q[0]<=' ' && k==1) q=dfs;   /* 起動時フォントが無指定なら用意したフォントを使う */
  }else{                                             /* 表示簿が実質的に開けなかった時 */
    if(k==1) q=dfs;                            /* それが起動時フォントなら内蔵値を充て */
    else return r;                                             /* その他は無処理にする */
  }
  if(q[0]>' '){
    unsigned int cw, ch;
    XftFont         *ft;
    XGlyphInfo      xgl;
    BYTE h=0;
    if(ft=XftFontOpenXlfd(dpy, 0, q)) h=1;
    else if(ft=XftFontOpenName(dpy, 0, q)) h=1;
    if(h){
      if(cft) XftFontClose(dpy, cft);              /* 今までのフォントセットを解放して */
      cft=ft;                                                /* 使用フォントを更新する */
      cw=cft->max_advance_width;
      XftTextExtentsUtf8(dpy, cft, "MW", 2, &xgl);   /* 最大幅半角字２字分を鍵幅にして */
      if(xgl.width > cw) cw=xgl.width;               /* 大きい方を単位幅の２倍値に採る */
      cxo=0; cyo=-cft->ascent;                         /* 背後矩形の左上隅のオフセット */
      ccw=cw;                                                        /* 背後矩形の寸法 */
      cch=cft->height;
      cw2=ccw+2; ch2=cch+2;                   /* 文字背後矩形の左右、上下、各1の縁取り */
      dh=3+(cch/20);                                                           /* 行間 */
      uw =(ccw+2)/2;                                                         /* 格子幅 */
      dh2=dh+dh;
      lh =cch+dh;                                                              /* 行高 */
      strcpy(kiDsp[2][0], H);                                                /* 見出し */
      sz=1;
      kiF=k;                                 /* 更新があれば現行表示簿の控えを更新する */
      r=True;
      gon=1;
    }
  }
  if(!Gon && gon){Gon=1; XMapWindow(dpy, wnd);}        /* 表示していなければ表示させる */
  return r;
}

void layout(){                         /* これから使用する配字案内の枠内諸元を用意する */
  hh=dh2;                                                              /* 鍵盤最上位置 */
  if(Dsp){                                                           /* 鍵盤表示の場合 */
    BYTE k;
    Ww=Gw*uw; Wh=dh2+6*lh+dh2;                                             /* 幅と高さ */
    if(CT){                                            /* 拡張部の表示があるときの補正 */
      if(Dsp>=2){                              /* 倣い入力用に領域を拡張するときの補正 */
        if(Wyt) hx=0; else hx=Wh;        /* 下辺基準なら鍵盤が下、上辺基準なら鍵盤が上 */
        if(Dsp==2){                                        /* 表記群は注目行だけの表示 */
          if(Wyt) hh+=dh2+3*lh+dh2;                              /* 下基準なら鍵盤は下 */
          Wh+=dh2+3*lh+dh2;
        }else{                                                       /* 表記群は群表示 */
          if(Wyt) hh+=dh2+(Dmax+2)*lh+dh2;
          Wh+=dh2+(Dmax+2)*lh+dh2;
        }
        Rc3x=uw-1; Rc3y=hx+lh+dh; Rc3w=(Gw-2)*uw+2; Rc3h=lh+2;             /* 呼び字列 */
      }else{ /* Dsp==1 */                                  /* 表示領域の拡張をしない時 */
        Rc3x=uw-1; Rc3y=1; Rc3w=(Gw-2)*uw+2; Rc3h=lh;                      /* 呼び字列 */
      }
    }
    for(k=1; k<58; k++){KPos[k][0]=ntox[k]*uw; KPos[k][1]=hh+ntoy[k]*lh;}/* 各鍵の位置 */
    Rc2x=(Gw-1)*uw; Rc2y=hh+5*lh;  Rc2w=0;           Rc2h=cch;           /* 文字コード */
    Rc4x=uw;        Rc4y=hh-dh2+2; Rc4w=(Gw-2)*uw;   Rc4h=cch;   /* 標題欄の文字列矩形 */
  }else{                                                             /* 無盤表示の場合 */
    Ww=(Gw+2+1)*uw; Wh=dh2+lh+dh;                                          /* 幅と高さ */
    Rc1x=Gw*uw;   Rc1y=hh;    Rc1w=2*uw;          Rc1h=cch;        /* 配鍵番号表示矩形 */
    Rc4x=uw;      Rc4y=hh;    Rc4w=(Gw-2)*uw;     Rc4h=cch;        /* 下見内容表示矩形 */
    Rc5x=1;       Rc5y=1;     Rc5w=(Gw+2+1)*uw-2; Rc5h=dh2+lh+dh-2;    /* 標題下地矩形 */
  }
}

void  check_Wxy(){               /* 配字案内が画面からはみ出るなら収まるように補正する */
  Window       r;
  int          x, y;
  unsigned int w, h, b, d;
  
  XGetGeometry(dpy, root, &r, &x, &y, &w, &h, &b, &d);       /* root画面の寸法を求める */
  if(Wx+(int)Ww >= x+(int)w) {Wx= x+(int)w -(int)Ww; Wxt=2;}
  if(Wx <= x) {Wx= x; Wxt=1;}
  if(Wx > x && Wx+(int)Ww < x+(int)w) Wxt=0;
  Fx=Wx+(int)Ww/2;
  if(Wy+(int)Wh>  y+(int)h) {Wy = y +(int)h -(int)Wh; Wyt=1;}
  if(Wy < y)                {Wy = y; Wyt=0;}           /* 上にはみ出すなら上端で抑える */
  if(Wyt) Fy=Wy+(int)Wh; else Fy=Wy;
}                                   /* 画面から食み出る場合は、左端あるいは下辺を保つ。*/

MyOpenHandler(XIMS ims, IMOpenStruct *call_data){
  return True;
}

MyCloseHandler(XIMS ims, IMCloseStruct *call_data){
  if(Sfq) save_Stat();                       /* 統計を取っていたら現在のものを保存する */
  return True;
}

MyCreateICHandler(XIMS ims, IMChangeICStruct *call_data){
  static CARD16 icid = 0;
  if(!(++icid)) ++icid;                                                        /* 還暦 */
  call_data->icid = icid;
  return True;
}

MyDestroyICHandler(XIMS ims, IMDestroyICStruct *call_data){
  CARD16 icid;
  icid=call_data->icid;
  if(cf_id==icid){
    cf_id = 0;
    if(Gon) {rd=0; XUnmapWindow(dpy, wnd);}
  }
  if(Sfq) save_Stat();                       /* 統計を取っていたら現在のものを保存する */
  return True;
}

MySetICValuesHandler(XIMS ims, IMChangeICStruct *call_data){
  return True;
}

MyGetICValuesHandler(XIMS ims, IMChangeICStruct *call_data){
  XICAttribute *ic_attr = call_data->ic_attr;
  register int i;
  for (i=0; i<(int)call_data->ic_attr_num; i++, ic_attr++) {
    if (ic_attr->name==NULL) continue;                 /* 項目名の所在地が空なら飛ばす */
    if (!strcmp(XNFilterEvents, ic_attr->name)) {    /* フィルタの問合せなら返事をする */
      CARD32 *p;
      if(p=ic_attr->value){
        if(*p==KeyPressMask|KeyReleaseMask){
        }else{
          ic_attr->value = (void *)malloc(sizeof(CARD32));
          *(CARD32*)ic_attr->value = KeyPressMask|KeyReleaseMask;
          ic_attr->value_length = sizeof(CARD32);
        }
      }else{
        ic_attr->value = (void *)malloc(sizeof(CARD32));
        *(CARD32*)ic_attr->value = KeyPressMask|KeyReleaseMask;
        ic_attr->value_length = sizeof(CARD32);
      }
    }
  }
  return True;
}

BYTE insC(BYTE m, BYTE *p){ /* 呼び字列Cs[Ci]～にmバイトの１文字を挿入する。  m>0, p>0 */
  BYTE d, s, n, w;

  if((n=Cn+m)>Cmax) return 0;                      /* 挿入するとはみ出るようなら止める */
  s=Cn;                                                                /* 移動元最後尾 */
  d=n;                                                                 /*  〃 先  〃   */
  for( ; s!=Ci; s--, d--){
    Cs[d]=Cs[s];                                                     /* CsとCwの各々を */
    Cw[d]=Cw[s];                                            /* Ci以降mだけ後にずらして */
  }
  Cs[d]=Cs[s];                                           /* つまり、Cs[新Ci]<-Cs[旧Ci] */
  Cw[d]=Cw[s];                                           /*         Cw[新Ci]<-Cw[旧Ci] */
  Ci=d;                                                          /* 新たな位置を控える */
  Cn=n;
  w =s;
  for( ; s<d; s++){                                        /* 文字のバイト列を挿入する */
    Cs[s]=*p++;
    Cw[s]=0;
  }
  Cw[w]=m;
  return (Cmax-n);
}

void insS(BYTE *p){                           /* 字列pを呼び字列溜CsのCi位置に挿入する */
  BYTE m;
  
  if(!p) return;
  for( ; *p>=' '; ){   /* 制御字に出会うまで多バイト字を１字ずつ呼び字列溜に詰めてゆく */
    if(!(m=mb_chk(p))) break;                  /* 字列先頭の多バイト字のバイト数を出し */
    if(!insC(m, p)) break;               /* その１文字をCsに挿入する。一杯なら打ち切る */
    p+=m;                                              /* 次の多バイト字取り出しに移る */
  }
  return;
}

Bool RkFk(BYTE *t, BYTE m){                  /* 文字列t～の先頭mバイト字のRk, Fkを出す */
  BYTE i, j, k, c, *q, *s, B[Cmax+2];
  BYTE rk=0, fk=0;

  if(Co>1){
    Knx=0;                                         /* 新たな配字探しであることを控える */
    if(m) b2B(t, B); else B[0]=0;      /* 先頭字があればその文字コードの表記を取り出す */
    i=0;
    if(Tw[Ti] && B[0]=='U'){
      for(s=&B[2]; s[i] && i<9; i++) Cd[i]=s[i];
    }
    Cd[i]=0;
  }
  Ms=0;                                                            /* 基本は現打相維持 */
  if(m==1){                                    /* １バイト字であれば先ず単打配字を探す */
    c=*t;
    Rk=0;
    for(Fk=1; Fk<=99; Fk++){
      if(Fk==50) continue;
      if(kiStM[0][Fk][0]==c){                                  /* 該当鍵が見つかったら */
        if(!Fn){if(Mr) Ms=1; return True;}             /* １字だけが対象なら採って終了 */
        else {fk=Fk; break;}         /* 文字列が対象なら位置を控えて単打探しは打ち切る */
      }
      if(fk) break;                      /* 既に見つかっていれば単打配字探しは打ち切る */
    }
  }
  if(m){    /* (１バイト字で単打配字がないかあっても文字列が対象の時も）複打配字を探す */
    k=m;
    for(Rk=1; Rk<=99; Rk++){
      if(Rk==50) continue;
      for(Fk=1; Fk<=99; Fk++){
        if(Fk==50) continue;
        if(*(q=kiMapM[Rk][Fk])<=' ') q=kiMapH[Rk][Fk];
        if(!*q) continue;                              /* いずれにしても空なら次に移る */
        for(i=0, s=t; i<k; i++) if(*s++!=*q++) break;          /* 違いに出会ったら捨て */
        if(i==k){                                                  /* 文字列が一致して */
          if(*q<=' '){                                     /* 配字表文字列に一致した時 */
            if(!Fn || k==Fn){                                        /* 照合が成立して */
              if(Mr){                                                  /* 現在複打相で */
                if(Ll){if(Rk==Lk) Ms=0; else Ms=2;}
              }else{
                if(Ll){if(Rk==Lk) Ms=1; else Ms=3;}
                else  Ms=1;
              }
              return True;                                               /* 控えて出る */
            }
            if(!fk){rk=Rk; fk=Fk;}                  /* 文字列最初の一致先頭字なら控えて*/
            for(k=Fn; i<k; i++) if(*s++!=*q++) break;        /* 後続文字の照合を続けて */
            if(i==k && *q<=' '){
              if(Mr){                                                  /* 現在複打相で */
                if(Ll){if(Rk==Lk) Ms=0; else Ms=2;}
              }else{
                if(Ll){if(Rk==Lk) Ms=1; else Ms=3;}
                else  Ms=1;
              }
              return True;                                               /* 控えて出る */
            }
          }else if(Fn && k!=Fn){         /* 文字列配字探しで初めて先頭字が一致した時は */
            if(!fk){rk=Rk; fk=Fk;}                     /* 単打配字になかったなら控えて */
            for(k=Fn; i<k; i++) if(*s++!=*q++) break;        /* 後続文字の照合を続けて */
            if(i==k && *q<=' '){
              if(Mr){                                                  /* 現在複打相で */
                if(Ll){if(Rk==Lk) Ms=0; else Ms=2;}
              }else{
                if(Ll){if(Rk==Lk) Ms=1; else Ms=3;}
                else  Ms=1;
              }
              return True;                                               /* 控えて出る */
            }
          }
        }
      }
    }
  }
  Fn=0;                                          /* 文字列探しだった時も単字扱いにして */
  if(fk){                                                    /* 文字列の先頭字があれば */
    Rk=rk; Fk=fk;                                                        /* それを控え */
    if(!Rk){if(Mr) Ms=1; else Ms=0;}         /* 単打字なら現複打相の時は対相への切替え */
    else{                                                                /* 複打字なら */
      if(Mr){                                                          /* 現在複打相で */
        if(Ll){if(Rk==Lk) Ms=0; else Ms=2;}
      }else{
        if(Ll){if(Rk==Lk) Ms=1; else Ms=3;}
        else  Ms=1;
      }
    }
    return True;                                                               /* 出る */
  }else {                                                                /* それ以外は */
    Rk=0; Fk=0;                                        /* 該当鍵なしで、打相はそのまま */
    return False;
  }
}

BYTE Cs2DsM(){     /* Csが U+か0xを冠した十六進字列であるとして その数値をDsM[0]に作る */
  BYTE n;
  n=isCode(Cs, DsM[0]);    /*  文字コードの字列ならコード値をDsMに入れ、バイト数を得る */
  return n;
}

void G_n(BYTE n, BYTE *q){                   /* 機能鍵簿でn行目の本字列をq～に読み込む */
  FILE *f;
  BYTE i, c, h, m, B[Bmax], H[Hmax+2], M[Cmax+2];

  if(q) q[0]=0;                                            /* 格納先を予め空にしておく */
  if(n>Fmax||!n) return;                                    /* nが範囲外なら何もしない */
  if(f=fopen(pMDG(2, 0), "r")){                                    /* ファイルを開いて */
    BYTE *d;
    for(i=1; i<=n; i++) fgett(B, Bmax, f);                            /* n行目まで読み */
    hm(B, &h, &m, H, M);                    /* n行目の内容を、見出しと表記字列に分けて */
    fclose(f);                                             /* ひとまずファイルを閉じる */
    if(q) d=q; else d=ntD;                /* 格納先の指定があればそこへ、なければntDに */
    for(i=0; (c=M[i]); i++) d[i]=c; d[i]=0;                          /* 表記字列を写す */
  }
  return;
}

void setCand(FILE *f, BYTE s[]){ /* sを筆頭表記列にし、以下字引fから順に表記群を取出す */
  BYTE c, i, j, B[Bmax];
  Dn=0; Di=0;

  if(s[0]!='.' || s[1]<=' '){                      /* 筆頭行が次の見出しの行でなければ */
    for(i=0, j=0; (c=s[j])>=' '; j++){if(i<Cmax) DsM[0][i++]=c;} DsM[0][i]=0;/*筆頭表記*/
    str_chk(DsM[0]);
    DsM[1][0]=0; Di=0;
    for(Dn=1; Dn<Dmax; Dn++){/* 現在指している行から順に表記行を群最大行数まで読み込む */
      if(!fgett(B, Bmax, f)) break;                      /* １行読み込む。なければ終了 */
      if(B[0]=='.' && B[1]>' ') break;                 /* 見出し行に出会ったら打ち切る */
      for(i=0, j=0; (c=B[j])>=' '; j++){if(i<Cmax) DsM[Dn][i++]=c;} DsM[Dn][i]=0;
      str_chk(DsM[Dn]);
    }
  }
  DsM[Dn][0]=0;
  Dc=2;
  return;
}

BYTE kiDicstr(int v){                                        /* 表記列をTs[]に取り出す */
  long int l, ln, lp;
  BYTE B[Bmax];                                                /* 読み込んだ１行の内容 */
  BYTE i, j, r, b, c;
  FILE *f;
  BYTE *a, *s, *t;

  r =0;                                  /* 表記列更新の有無。始めは変化なしにしておく */
  if(!v){                                          /* 呼び字列から表記群を取り出す場合 */
    Di=0; Dn=0; Dl=0;              /* 筆頭表記列、取り出した表記行 0、字引未参照の状態 */
    if(Cs2DsM()){                  /* 文字コードの表記であればその数値列をDsM[0]に作る */
      Dc=1; Dn=1; DsM[1][0]=0;         /* 呼び字列は文字コード、表記列は筆頭表記列だけ */
      r =1;                                                  /* 表記列更新の印をつける */
    }else{                                             /* 呼び字列が一般の文字列の場合 */
      Dc=0;                                            /* 該当表記は始めなしにしておき */
      if(f=fopen(pMDG(1, kiD), "r")){              /* 表記群を取り出すため、字引を開く */
        if(fgett(B, Bmax, f) && B[0]>=' '){                        /* 標題行を読み込み */
          check_kiDic(B);                    /* 記載が控えと違っていたら控えを更新して */
          for(Dl=2; (s=fgett(B, Bmax, f)); Dl++){/* ２行目から１行ずつ読み込んで調べる */
            if(*s++!='.' || *s<=' ') continue;       /* 見出し行でなければ次の行に移る */
            a=Cs;
            if(*s++!=*a++) continue;         /* 先頭バイトが不一致なら、即、次行に移る */
            for( ; *a>' ' && *s>' ' && *s++==*a++; );/* 行内を次のバイトから順に比べて */
            if(*(a-1)==*(s-1) && *a<=' ' && *s<=' '){/* 実効呼び字列の部分が一致したら */
              for(; *s>=' '; s++);                       /* 見出し欄の残りを読み捨てて */
              Cn=Ci=0; Cs[0]=0; Cw[0]=0; insS(&B[1]);/* 呼び字列欄を字引の見出しで更新 */
              fgett(B, Bmax, f);                               /* 筆頭表記行を読み込み */
              setCand(f, B); r=1;                                  /* 表記群を取り込む */
              break;
            }
          }
        }
        fclose(f);                                           /* ファイルはここで閉じる */
      }
      if(!r){                                                    /* 該当行がなかったら */
        for(j=0; (c=Cs[j])>=' '; j++) DsM[0][j]=c; DsM[0][j]=0;  /* 呼び字列全体を採り */
        Dn=1; DsM[1][0]=0;                       /* 表記列は筆頭表記列だけの扱いにする */
        r=1;
      }
    }
  }else if(v>0){                                                         /* 次の表記を */
    if(v==1){                                                    /* 次の行から取り出す */
      if((Di+1)<Dn) {Di++; r=1;}
    }else if(v==2){                                    /* 字引で次の群に移って取り出す */
      if(Dl>1){                                              /* 前回の読み出しがあれば */
        if(f=fopen(pMDG(1, kiD), "r")){                              /* 再び字引を開き */
          if(fgett(B, Bmax, f) && B[0]>=' '){                      /* 標題行を読み込み */
            check_kiDic(B);            /* 標題の記載が控えと違っていたら控えを更新して */
            for(l=2; l<Dl && (s=fgett(B, Bmax, f)); l++);/* 前回の群直前まで読み捨てて */
            if(l==Dl){                                 /* 前回の群先頭位置に到達したら */
              if(fgett(B, Bmax, f)){                              /*  その行を読み込み */
                if(B[0]=='.' && B[1]>' ') ln=Dl+Dn+1; else ln=Dl+Dn; /* 見出行なら１増 */
                for( ; l<ln && (s=fgett(B, Bmax, f)); l++);      /* 前回分を読み捨てる */
                if(s){                                       /* ファイル末には至らずに */
                  if(B[0]=='.' && B[1]>' '){           /* 次の見出し位置が得られたなら */
                    for(i=0, j=2; B[j]>=' '; j++);               /* 見出し欄は飛ばして */
                    Cn=Ci=0; Cs[0]=0; Cw[0]=0; insS(&B[1]);      /* 呼び字列を更新する */
                    fgett(B, Bmax, f);                         /* 筆頭表記行を読み込み */
                    setCand(f, B); r=1;                            /* 表記群を取り込む */
                    Dl=l;                  /* 行番号を見出し行の読出し位置として控える */
                  }else{               /* その他は現行呼び字列の続きの表記行と見なして */
                    setCand(f, B); r=1;                            /* 表記群を取り込む */
                    Dl=l;                    /* 行番号を表記群の読出し位置として控えて */
                  }
                }
              }
            }
          }
          fclose(f);                                               /* ファイルを閉じる */
        }
      }else if(Dc==1){                                                   /* 文字コード */
        BYTE x;
        for(x=Cn, i=Cn; x && i>2; i--){        /* 先頭２バイトの U+、0x には繰上らない */
          s=&Cs[i-1];
          if     (*s=='9') {*s='A'; x=0;}                   /* 9ならAへ (桁上りはない) */
          else if(*s=='F') {*s='0'; x=1;}                          /* Fなら0で、桁上り */
          else if(Cn==10 && i==3 && *s=='7') {*s='0'; x=1;} /* 31ビット目なら7で桁上り */
          else {*s+=1; x=0;}                                      /* その桁のまま1増す */
        }
        if(Cs2DsM()){          /* 文字コードの表記であればその数値列でDsM[0]を更新する */
        }else{                                       /* 文字コードに該当しなくなったら */
          strcpy(DsM[0], Cs);                          /* Csをそのまま表記列として採り */
          Dc=0; Dn=1;  /* 文字コードの入力状態を解消して、該当表記なしの状態に変更する */
          DsM[1][0]=0;
        }
        r=1;
      }
    }
  }else{                                                                        /* v<0 */
    if(v==-1)     {if(Di) {Di--; r=1;}}                        /* １つ前の表記行に戻る */
    else if(v==-2){                                              /* 字引で前の群に戻る */
      if(Dl>1){                                              /* 前回の読み出しがあれば */
        if(f=fopen(pMDG(1, kiD), "r")){                                /* 字引を開いて */
          if(fgett(B, Bmax, f) && B[0]>=' '){                      /* 標題行を読み込み */
            check_kiDic(B);            /* 標題の記載が控えと違っていたら控えを更新して */
            for(l=2, lp=0; fgett(B, Bmax, f) && l<Dl; l++){  /* ２行目から現在位置まで */
              if(B[0]=='.' && B[1]>' '){lp=l; ln=0;} /* 見出し行ならその行番号に取替え */
            }
            if(l==Dl && lp){                           /* 現群先頭位置まで調べ着いたら */
              long int h;
              fseek(f, 0L, SEEK_SET);                                  /* 先頭行に戻り */
              for(l=1; l<lp && fgett(B, Bmax, f); l++);  /* 前群の見出しのある行に来て */
              fgett(B, Bmax, f);                                   /* その行を読み込み */
              for(i=0, j=0; B[j]>=' '; j++);                   /* 見出しの欄は飛ばして */
              Cn=Ci=0; Cs[0]=0; Cw[0]=0; insS(&B[1]);            /* 呼び字列を更新する */
              if(!ln) ln=Dl;       /* 現位置までに空行がなければ次群位置に現位置を採る */
              h=ln-lp-1;                                   /* この見出し下の表記行の数 */
              if(h<=Dmax){                                         /* １群に収まるなら */
                fgett(B, Bmax, f);                             /* 筆頭表記行を読み込み */
              }else{                                               /* ２群以降があれば */
                long int dl, el;
                if(!(el=h%Dmax)) el=Dmax;
                lp++; dl=lp+h-el;                      /* 先頭行と最後の群の先頭行位置 */
                for(; fgett(B, Bmax, f) && lp<dl; lp++); /* 最後の群の先頭行を取り出し */
              }
              setCand(f, B); r=1;                                  /* 表記群を取り込み */
              Dl=lp;                                         /* 群先頭の行番号を控える */
            }
          }
          fclose(f);                                               /* ファイルを閉じる */
        }
      }else if(Dc==1){                                                   /* 文字コード */
        BYTE x;
        for(x=Cn, i=Cn; x && i>2; i--){   /*  先頭の２バイト U+、0x には演算が及ばない */
          s=&Cs[i-1];
          if(*s=='0'){                                                       /* 0 なら */
            if(Cn==10 && i==3) *s='7'; else *s='F'; x=1;  /* 7かFにして上桁からも1引く */
          }else if(*s=='A') {*s='9'; x=0;}                         /* Aなら9にするだけ */
          else {*s-=1; x=0;}                         /* その他の数ならその桁で引くだけ */
        }
        if(Cs2DsM()){          /* 文字コードの表記であればその数値列でDsM[0]を更新する */
        }else{                                       /* 文字コードに該当しなくなったら */
          strcpy(DsM[0], Cs); DsM[1][0]=0;             /* Csをそのまま表記列として採る */
        }
        r=1;
      }
    }
  }
  if(r){                                                /* DsM[Di]～を表記列溜めに写す */
    BYTE m;
    for(i=0; i<=Cmax; i++) {Ts[i]=0; Tw[i]=0;}                 /* 表記列溜めを空にして */
    for(i=0, Ti=0, Tn=0, t=DsM[Di]; *t; ){
      if((m=mb_chk(t)) && (i+m)<=Cmax){
        Tw[i]=m;                   /* 各文字の先頭バイトの位置に構成バイト数を書き込む */
        i+=m; t+=m; Tn=i;
      }else{
        break;
      }
    }
    for(i=0, t=DsM[Di]; i<Tn; i++) Ts[i]=*t++;                     /* 表記列を取り込む */
    m=Tw[0];
    if(Ts[0]>' ' && Ts[m]>' '){              /* 先頭から２字以上あるときは先頭文字列の */
      for(i=0; Ts[i]>' ' && i<Tn; i+=Tw[i]);
      Fn=i;
    }else{                                                     /* それ以外は先頭文字の */
      Fn=0;
    }
    RkFk(Ts, m);                                                         /* 配字を探す */
  }
  return r;
}

void kiCommitString(Display *display, XIMS ims, IMCommitStruct *call_data){
                                               /* 該当字(列)を送り、使用回数を加算する */
  XTextProperty tp;
  BYTE c, j, *p, *q, lk, M[Cmax+4];

  if(CT && Co>1) lk=Rk; else lk=Lk;
  if(*(p=kiMapM[lk][Kd])>' '){                                       /* 本字列があれば */
    if(p[0]==']') p=specialString(p+1);     /* ]で始まる特殊字列は結果の字列に置替える */
    for(q=M, j=0; (c=p[j])>' '; j++) q[j]=c; q[j]=0;             /* 最初の区切りを写し */
  }else{                                                           /* 本字列がなければ */
    for(q=M, j=0; (c=kiMapH[lk][Kd][j]); j++) q[j]=c; q[j]=0;          /* 見出しを採る */
  }
  if(CT && Co==1){                                             /* 呼び字列の入力中なら */
    if(*q) insS(q);                                  /* 空でなければCs[Ci～]に取り込む */
  }else{                                                             /* 通常の入力なら */
    tp.value=(unsigned char *)NULL;
    setlocale(LC_CTYPE,"");
    Xutf8TextListToTextProperty(display,(char **)&q, 1, XCompoundTextStyle, &tp);
    call_data->flag |= XimLookupChars;
    call_data->commit_string = (unsigned char *)tp.value;
    IMCommitString(ims, (XPointer)call_data);                          /* 文字列を送り */
    if(tp.value!=NULL) XFree(tp.value);
  }
  Sctt++;                                      /* 起動時からの乙打成立総数に１加算する */
  if(Son){           /* 統計中なら(字列の成立不成立に依らず)この鍵打順の成立を加算する */
    Sfq=1;                                               /* 保存を要する旨の印をつける */
    Stat[lk][Kd]++;                                                  /* 乙打鍵を１加算 */
    Stat[lk][K0]++;                                      /* 乙鍵盤該当面の総数を１加算 */
    Stat[ 0][lk]++;                                        /* 甲鍵盤中の乙鍵盤に１加算 */
    if(lk>50) Stat[0][50]++; else Stat[0][0]++;          /* 甲鍵盤該当面の総数に１加算 */
  }
}

MyForwardEventHandler(XIMS ims, IMForwardEventStruct *call_data){
  int i, kpr;
  XKeyEvent *kev;
  unsigned int keycode, state;
  Time ktime;
  Display *display = ims->core.display;
  BYTE k, n;

  if(((kpr=call_data->event.type) != KeyPress) && (kpr != KeyRelease)) return True;
  kev = (XKeyEvent*)&call_data->event;
  ktime   = kev->time;                                           /* 生起時刻を取り出す */
  keycode = kev->keycode;
  state   = kev->state;                                      /* 押上鍵の状態を取り出す */
  if(keycode<8 || keycode>255){                     /* keycodeが8から255まででなければ */
    return True;                                   /* 無効イベントとして処理を終了する */
  }
  pKn=Kn;
  Kn= kton[keycode];                                                 /* 配鍵番号で表す */
  if     (Kn==64) Kn=50;                                 /* 右Shiftは左Shiftとして扱う */
  else if(Kn==65) Kn=52;                                 /* 右Ctrl は左Ctrl    〃      */
  else if(Kn==66) Kn=53;                                 /* 右Alt  は左Alt     〃      */
  if(Kn!=50){                             /* Shiftでない時、念のため、Shを修正しておく */
    if     ( (state & 1) &&!Sh){Sh=1; K0=50; rd=1; if(Ak>1) Ak=1;}        /* Shift押に */
    else if(!(state & 1) && Sh){Sh=0; K0= 0; rd=1; if(Ak>1) Ak=1;}        /* Shift放に */
  }
  if(Kn!=51){                                        /* Lock打でない時Cpを較正しておく */
    if     ( (state & 2) &&!Cp){Cp=1; rd=1;}             /* LockなのにCp=0になっていた */
    else if(!(state & 2) && Cp){Cp=0; rd=1;}        /* LockでないのにCp!=0になっていた */
  }
  if(Kn!=52){                              /* Ctrlでない時、念のため、Svを修正しておく */
    if     ( (state & 4) &&!(Sv & 1)){Sv|= 0x01; rd=1;}
    else if(!(state & 4) && (Sv & 1)){Sv&=~0x01; rd=1;}
  }
  if(Kn!=53){                               /* Altでない時、念のため、Svを修正しておく */
    if     ( (state & 8) &&!(Sv & 2)){Sv|= 0x02; rd=1;}
    else if(!(state & 8) && (Sv & 2)){Sv&=~0x02; rd=1;}
  }
  if(kpr == KeyRelease){                                                 /* 鍵が離れた */
    pKpr=0; ptime=ktime;               /* 前鍵事象控えを「離れ」にし、生起時刻を控える */
    if     (Kn==50){Sh =0; K0=0; rd=1; if(Ak) Ak=1;}                          /* Shift */
    else if(Kn==52){Sv &= ~0x01; rd=1;}                                        /* Ctrl */
    else if(Kn==53){Sv &= ~0x02; rd=1;}                                        /* Alt  */
    if(!Ak) IMForwardEvent(ims, (XPointer)call_data);/* 下見でなければフィルタせず渡す */
    Rct++;                                                   /* KeyRelease数を積算する */
    return True;
  }
  if(pKn==Kn && (pKpr||ptime==ktime)){                     /* 同じ鍵が押し続けられたら */
    if((!Sv && (Mr||CT) && Kn>=1 && Kn<=49)||          /* それが複打か倣い時の文字鍵か */
       (CT  && Kn>=58 && Kn<=63)  ||               /* 倣い入力時だけkiが占有する６鍵か */
       (!Sv && Kn>=54 && Kn<=57)             ){                      /* kiの機能鍵なら */
      ptime=ktime;                                               /* 生起時刻を更新して */
      return True;                                                       /* 読み捨てる */
    }
  }
  pKpr=1; ptime=ktime;               /* 前鍵事象控えを「押し」にし、生起時刻を更新する */
  if(!Kn){                                                         /* kiでは扱わない鍵 */
    if(Ak) return True;                      /* 下見中であればkiの処理として終了させる */
    if(Gk||Dk||Mk) {Gk=Dk=Mk=0; rd=1;}                       /* 選択待ちがあれば解消し */
    if(Lk && !Ll) {Lk=0; rd=1;}          /* 甲打省略ではない乙鍵盤であれば甲鍵盤に戻る */
    if(CT){if(Co==3) Co=2; CT=0; rd=1; sz=1;}            /* 倣い入力であれば自力に戻し */
    IMForwardEvent(ims, (XPointer)call_data);                    /* フィルタせずに渡す */
    return True;
  }
  if(Kn<50){                                                                 /* 文字鍵 */
    Kd=K0+Kn;
    if(Ak){                                                              /* 備考参照時 */
      Ak=2; rd=1;                                  /* 該当文字鍵の下見を表示する準備へ */
    }else if(Gk){                                                  /* 表示簿の選択待ち */
      Gk=0;
      if(Kd!=kiF) load_kiFnt(Kd);  /* 現在のフォントでなければ指定のフォントを設定する */
      rd=1;                                                    /* 要再描画の印を付ける */
    }else if(Dk){                                                    /* 字引の選択待ち */
      Dk=0;
      if(Kd!=kiD) load_kiDic(Kd);              /* 指定が現在の鍵でなければそれに変えて */
      rd=1;                                                    /* 要再描画の印を付ける */
    }else if(Mk){                                                    /* 配字簿選択待ち */
      Mk=0;
      if(Kd!=kiM){                                     /* 指定が現配字表の鍵でなければ */
        if(load_kiMap(Kd)){                                  /* 指定配字簿に取り替え、 */
          if(!Mr) Mr=8;                                    /* 単打相だったら複打相にし */
          if(CT && Co>1){                  /* 倣い入力中の配字簿探しで出した甲鍵盤なら */
            RkFk(&Ts[Ti], Tw[Ti]);         /* Fnに従い単字あるいは文字列の鍵打順を出す */
          }
        }
      }
      rd=1;                                                          /* 表示を更新する */
    }else if(CT && ((Co==2 && Ll && Mr && !Ms)||Co==3)){   /* 倣い乙鍵盤になっている時 */
      if(Co==3) Co=2;                /* 固定でない倣い乙鍵盤なら倣い甲鍵盤に戻しておく */
      if(Kd==Fk){                                          /* 打鍵が乙打に該当するなら */
        Knx=0;                                               /* 非該当打鍵の控えを消し */
        if(Tw[Ti]){                                      /* 有限長の文字コードがあれば */
          BYTE ti;
          kiCommitString(display, ims, (IMCommitStruct*)call_data);    /* 複打字を送る */
          if(Fn){ti=Fn; Fn=0;}         /* 文字列の配字探しなら対象を第１表記に限定する */
          else   ti=Ti+Tw[Ti];                   /* そうでなければ次の字の位置に進めて */
          Ti=ti; RkFk(&Ts[Ti], Tw[Ti]);                          /* 新たな鍵位置を出す */
        }
      }else{                                                         /* 該当しなければ */
        if(!Fk && (Rk%50)==49){                              /* 実行時配字鍵盤であれば */
          BYTE j, s, *t;
          s=Rk/50;
          Fk=Kd;
          for(t=kiMapH[Rk][Fk], j=0; j<Tw[0]; j++) t[j]=Ts[j]; t[j]=0;        /* 見出し*/
          j=0;
          strcpy(K49H[s][Fk], t);                                /* 見出しを控えに写す */
          for(t=kiMapM[Rk][Fk]; Ts[j]>' '; j++) t[j]=Ts[j]; t[j]=0;
          strcpy(K49M[s][Fk], t);                                /* 本字列を控えに写す */
          Fn=j;
          if(K49){                                         /* 実行時配字を保存するなら */
            FILE *fp;
            strcpy(MDG, VAR); strcat(MDG, "K49");                /* 実行時配字控え簿を */
            if(fp=fopen(MDG, "w")){                /* 書き込みファイルとして改めて開く */
              BYTE s, k;
              for(s=0; s<2; s++){
                if(s) k=0; else k=1;
                for(; k<=99; k++){
                  if(K49H[s][k][0]){
                    fprintf(fp, "%s", K49H[s][k]);
                    if(K49M[s][k][0]){
                      fprintf(fp, "\t%s", K49M[s][k]);
                    }
                  }
                  fprintf(fp, "\n");
                }
              }
              fclose(fp);
            }
          }
        }
        Knx=Kd; ph=1;                      /* やり直しの印としてこの文字鍵番号を控える */
      }
      rd=1;
    }else if(CT && Co==2){                           /* 表記の案内に甲打鍵盤が出ている */
      if(!Ms && !Ll && Kd==Rk){Co=3; Knx=0;}                       /* 該当字の乙鍵盤に */
      else if(!Ms && !Rk && Kd==Fk){                             /* 赤い字が単打字の時 */
        BYTE m;
        Knx=0;                                           /* まず非該当打鍵の控えを消す */
        if(m=Tw[Ti]){
          BYTE *q, w[Cmax+4];
          XTextProperty tp;
          for(i=0; i<m; i++) w[i]=Ts[Ti+i]; w[i]=0;                      /* その文字を */
          q=w;
          tp.value=(unsigned char *)NULL;
          setlocale(LC_CTYPE,"");
          Xutf8TextListToTextProperty(display,(char **)&q, 1,XCompoundTextStyle, &tp);
          ((IMCommitStruct*)call_data)->flag |= XimLookupChars;
          ((IMCommitStruct*)call_data)->commit_string = (unsigned char *)tp.value;
          IMCommitString(ims, (XPointer)call_data);                            /* 送り */
          if(tp.value!=NULL) XFree(tp.value);
          Fn=0;
          Ti+=m; RkFk(&Ts[Ti], Tw[Ti]);      /* 次の字の位置に進めて新たな鍵位置を出す */
        }
      }else if(Kn==49 && !Ti && Mr && !Ll) {                     /* 実行時配字指示なら */
        Knx=0; Ms=0; Rk=K0+49; Fk=0; Co=3;                     /* その設定鍵盤用意する */
      }else{                                                         /* 該当しなければ */
        Knx=Kd; ph=1;                      /* やり直しの印としてこの文字鍵番号を控える */
      }
      rd=1;                                                          /* 表示を更新する */
    }else if(Mr && !Sv){                                               /* 複打入力状態 */
      if(!Lk) Lk=Kd;                            /* 甲鍵盤なら 甲鍵の文字鍵番号を控える */
      else{                                                              /* 乙鍵盤なら */
        kiCommitString(display, ims, (IMCommitStruct*)call_data);  /* 成立字を送出して */
        if(!Ll) Lk=0;                                /* 固定乙鍵盤でなけば甲鍵盤に戻る */
      }
      rd=1;                                                    /* 要再描画の印を付ける */
    }else{                                                             /* 単打入力状態 */
      if(Sv){                                             /* CtrlかAltが押されている時 */
        if(CT){if(Co==3) Co=2; CT=0; rd=1; sz=1;}            /* 倣い入力状態を解消して */
        IMForwardEvent(ims, (XPointer)call_data);                /* フィルタせずに渡す */
      }else{                                                                 /* 基本字 */
        BYTE *q;
        if(CT && Co==1){                                       /* 呼び字列の入力中なら */
          q=kiStM[Cp][Kd];
          insC(1, q);                                              /* 呼び字列に追加し */
          rd=1;                                                /* 要再描画の印を付ける */
        }else{                                                   /* 通常の単打入力なら */
          IMForwardEvent(ims, (XPointer)call_data);              /* フィルタせずに渡す */
        }
      }
      if(Lk && !Ll){Lk=0; rd=1;}
    }
  }else if(Kn==51){                                                      /* CapsLock鍵 */
    BYTE wCp=Cp;
    if(state & 2) Cp=0;                                                    /* Lock解除 */
    else          Cp=1;                                                        /* Lock */
    if(Ak) return True;                      /* 下見中であればkiの処理として終了させる */
    if(wCp!=Cp) rd=1;                  /* Lockの状態に変化があったら再描画の印をつける */
    if(Gk||Dk||Mk) {Gk=Dk=Mk=0; rd=1;}                   /* 選択鍵盤があれば御破算にし */
    if(Lk  && !Ll){Lk=0; rd=1;}          /* 甲打省略ではない乙鍵盤であれば甲鍵盤に戻る */
    IMForwardEvent(ims, (XPointer)call_data);                    /* フィルタせずに渡す */
  }else if(Kn==50||Kn==52||Kn==53){               /* stateは直前の状態であることに注意 */
    if(Kn==50){
      if(!Sh||!(state&1)){Sh=1; K0=50; rd=1; if(Ak) Ak=1;}        /* Shiftの控えを較正 */
    }else{                                                            /* CtrlかAltなら */
      if(Ak){Ak=0; rd=1;}                                        /* まず下見を終了させ */
      if(Kn==52){if(!(Sv&1)||!(state&4)) rd=1; Sv |= 1;}   /* Ctrlならその状態の控えを */
      else      {if(!(Sv&2)||!(state&8)) rd=1; Sv |= 2;}   /* Alt ならその控えを更新し */
      if(Gk||Dk||Mk) {Gk=Dk=Mk=0; rd=1;}                 /* 選択鍵盤があれば御破算にし */
      if(Lk && !Ll) {Lk=0; rd=1;}        /* 甲打省略ではない乙鍵盤であれば甲鍵盤に戻る */
      if(CT){if(Co==3) Co=2; CT=0; rd=1; sz=1;}        /* 倣い入力中なら自力入力に戻る */
    }
    if(!Ak) IMForwardEvent(ims, (XPointer)call_data);            /* フィルタせずに渡す */
  }else if(Kn<57 && !Sv && Ak){                            /* kiの機能鍵で下見中のとき */
    Ak=3; rd=1;                                                      /* その備考を出す */
  }else if(Kn==54 && !Sv){                                       /* 配字簿選択の制御鍵 */
    if(Gk) Gk=0; if(Dk) Dk=0;                      /* 案内鍵盤や字引鍵盤は御破算にする */
    {
      if(!Mk){                                             /* 配字簿鍵盤が出ていなくて */
        if(!CT || Co==1){                  /* 以下文字の入力時で表記を表示してなければ */
          if(Sh){
            if(Lk && Mr){     /* 乙打待ちでShiftが押されていたら、甲打省略を切り替える */
              if(Ll) Ll=Lk=0;
              else   Ll=1;
            }else{
              Mkn=Mkns=0;
              make_Dsp(0); Mk=1;                           /* 配字簿選択鍵盤を準備する */
            }
          }else{                        /* Shiftが押されていなければ単・複を切り替える */
            if(Mr) {if(!Ll) Lk=0; Mr=0;}               /* 甲打省略か甲鍵盤なら単打相へ */
            else   Mr=8;                                         /* 単打相なら複打相へ */
          }
        }else if(Ms==3 && !Sh){ /* 単打鍵盤で鍵は固定乙鍵盤に在りShiftが押されてない時 */
          Mr=8; Ms=2;                                    /* ひとまず複打相に切り替える */
        }else if(Ms==2 && Sh){  /* 固定乙鍵盤で鍵は他乙鍵盤に在りShiftが押されている時 */
          Ll=Lk=0; Ms=0;                           /* 固定乙鍵盤を解消して甲鍵盤に戻る */
        }else if(Ms==1 && !Sh){ /* 現単で鍵は複(かその逆)に在りShiftが押されてなければ */
          if(Mr){if(!Ll) Lk=0; Mr=0;}                            /* 複打相なら単打相へ */
          else   Mr=8;                                           /* 単打相なら複打相へ */
          Ms=0;                                                            /* 切替える */
        }else if(Ms<2 && Sh && Ts[0]>' '){           /* 他の配字簿を探す可能性があれば */
          make_Dsp(0); Mk=1; Mkn=100;                          /* 配字簿鍵盤を準備する */
          if(!Ti && Ts[0]>' ' && Ts[Tw[0]]>' ' ) Mkns=100; else Mkns=0;
        }
      }else{                                             /* 配字簿鍵盤が既に出ている時 */
        if((!Sh && Mkn)||(Sh && Mkns && !Ti && Ts[0]>' ' && Ts[Tw[0]]>' ')){ /* 文字列 */
          FILE *f;
          BYTE fn, rk, fk, wk, k, *q;
          BYTE n, wMkn, r=0, B[Bmax], h, m, wH[Hmax+2], wM[Cmax+2];
          if(!Sh){if(Mkn==100) wMkn=kiM; else wMkn=Mkn;}    /* 単字   最初は現行配字簿 */
          else  {if(Mkns==100) wMkn=kiM; else wMkn=Mkns;}   /* 文字列 最初は現行配字簿 */
          n=Tw[Ti];
          if(Sh){                                            /* 先頭表記を文字列として */
            BYTE i;
            for(i=0; Ts[i]>' ' && i<Tn; i+=Tw[i]);
            fn=i;                                                          /* 文字列長 */
          }else{                                             /* それ以外は注目字だけで */
            fn=0;                                             /* 文字列長は0にしておく */
          }
          for(wk=1; wk<100; wk++){                     /* 現配字簿の次からひと回り探す */
            k=wMkn+wk;
            if(k>99) k-=99;
            if((k>Km && k<51) || k>50+Km) continue;
            if(f=fopen(pMDG(0, k), "r")){        /* 配字簿の割り付けがあればそれを開き */
              UINT l;
              for(l=1; fgett(B, Bmax, f) && l<10000; l++){
                if(((l>100 && l<5000) || l>5100) && (l%50)){         /* 配字定義行だけ */
                  hm(B, &h, &m, wH, wM);                       /* 見出しと本字列に分け */
                  if(m && wM[0]!=' ') q=wM;                    /* 本字列があればそれと */
                  else {q=wH; m=h;}                                /* なければ見出しと */
                  for(i=0; i<n && Ts[Ti+i]==q[i]; i++);          /* １バイトずつ比べて */
                  if(i==n){                              /* 単字については一致したなら */
                    if(fn){                                    /* 文字列が対象であれば */
                      for(; i<fn && Ts[Ti+i]==q[i]; i++);          /* 更に比較を続けて */
                      if(i==fn && q[i]<=' ') {r=1; break;}         /* 全長一致なら採る */
                    }else{                                           /* 単字が対象なら */
                      if(q[i]<=' ') {r=1; break;}                  /* 空でなければ採る */
                    }
                  }
                }
              }
              fclose(f);                                                 /* 簿を閉じる */
              if(r==100) r=0;
              if(r) break;                         /* 一致があれば他の配字簿は調べない */
            }
          }
          if(r){if(fn) Mkns=k; else Mkn=k; Fn=fn;}             /* 該当配字簿の鍵を出し */
          else {if(!fn) Mkn=0; else Mkns=0; Fn=0;}                 /* なければ空にして */
        }else {
          if(Sh && (!CT||Co==1)){if(kiM==1) load_kiMap(2); else load_kiMap(1);}/* 主副 */
          Mk=0;
        }
      }
    }
    rd=1;
  }else if(Kn==55 && !Sv){                                           /* 倣い入力の起動 */
    if(Gk) Gk=0; if(Mk) Mk=0;
    {
      if(Lk && !Ll) Lk=0;                                    /* 乙鍵盤なら甲鍵盤に戻る */
      if(!CT){                                                           /* 自力入力時 */
        Dk=0;
        if(Sh){                                           /* Shiftを押しながらであれば */
          if(Co>1){                                /* 表記群が表示されている状態の時は */
            RkFk(&Ts[Ti], Tw[Ti]);     /* Fnに従って単字あるいは文字列の鍵打順を出して */
          }
          sz=1; CT=1;                                            /* 習い入力を再開する */
        }else{                                                           /* 単独打なら */
          Cn=Ci=0; Cs[0]=0; Cw[0]=0; Dn=0;                 /* 呼び字列の変数を空にして */
          CT=1; Co=1; sz=1;                                      /* 倣い入力を開始する */
        }
      }else{
        if(Co>1){
          if(Sh){           /* Shiftが押されていたら注目字以下行末までを呼び字列にする */
            Cn=Ci=0; Cs[0]=0; Cw[0]=0;
            insS(&Ts[Ti]);                         /* 注目字以下行末までを呼び字列にし */
            Ci=0; Co=1; Dn=0;                          /* 呼び字列先頭からの編集に戻る */
          }else {if(Co==3) Co=2; CT=0; sz=1;}              /* 単独打なら自力入力に戻る */
        }else if(Co==1){                                         /* 呼び字列の編集時で */
          if(!Dk){                                           /* 字引鍵盤が出ていなくて */
            if(Sh){make_Dsp(1); Dkn=100; Dk=1;}             /* Shift押しは選択鍵盤準備 */
            else  {CT=0; sz=1;}               /* Shiftが押されてなければ自力入力に戻る */
          }else{                                                 /* 字引鍵盤が出ていて */
            if(Sh){        /* Shift が押されていたらセレクションから取り込む要求を出す */
              Dk=0;
              XConvertSelection(dpy, XA_PRIMARY, utf8, prop, wnd, kev->time);
            }else{
              if(Dkn){                      /* K55の押し続けでなければ、他の字引を探す */
                FILE *f;
                long int  l;
                BYTE wDkn, *s, *a, r=0, wk, k, B[Bmax];
                if(Dkn==100) wDkn=kiD; else wDkn=Dkn;              /* 最初は現行配字簿 */
                for(wk=1; wk<100; wk++){                 /* 現字引の次からひと回り探す */
                  k=wDkn+wk;
                  if(k>99) k-=99;
                  if((k>Km && k<51) || k>50+Km) continue;
                  if(!(f=fopen(pMDG(1, k), "r"))) continue;/* 字引が開けなくば次文字鍵 */
                  if(fgett(B, Bmax, f) && B[0]>=' '){            /* 先頭行は読み捨てて */
                    for(l=2; s=fgett(B, Bmax, f); l++){/* ２行目から１行ずつ読み込んで */
                      if(*s++!='.') continue;        /* 見出し行でなければ次の行に移る */
                      a=Cs;
                      if(*s++!=*a++) continue; /* 先頭バイトが不一致なら、即次行に移る */
                      for( ; *a>' ' && *s>' ' && *s++==*a++; );  /* 次のバイトから調べ */
                      if(*(a-1)==*(s-1) && *a<=' ' && *s<=' '){/* 呼び字列一致なら採る */
                        r=1; break;
                      }
                    }
                  }
                  fclose(f);                                       /* ファイルを閉じる */
                  if(r) break;               /* 一致があったら字引探しはそこまでにして */
                }
                if(r){                                   /* 設定する字引が見つかったら */
                  Dkn=k;
                }else if(Dkn==100) Dkn=0;/* 当見出しのある字引は無く、以後字引探し無用 */
              }else{
                Dk=0;
              }
            }
          }
        }
      }
    }
    rd=1;                                                      /* 要再描画の印を付ける */
  }else if(Kn==56 && !Sv){                                       /* 56番鍵(表示の制御) */
    if(Gon){                                                         /* 表示している時 */
      if(Sh){                                                     /* Shiftを押していて */
        if(Gk){if(kiF==1) load_kiFnt(2); else load_kiFnt(1); Gk=0;}  /* Gk=1主副切替え */
        else  {make_Dsp(2); Gk=1;}                     /* 通常鍵盤なら表示簿鍵盤を出す */
        rd=1;
      }else{                                                /* Shiftを押していなければ */
        if(Gk){Gk=0; rd=1;}                      /* 表示簿選択鍵盤が出ていれば解消して */
        else {Gon=0; rd=0; XUnmapWindow(dpy, wnd);}                      /* 表示を消す */
      }
    }else{                                                       /* 表示を消している時 */
      if(Sh){make_Dsp(2); Gk=1;}                /* Shiftを押していたら表示簿鍵盤を出す */
      Gon=1; rd=1;                                                       /* 表示を出す */
      XMapWindow(dpy, wnd);
    }
  }else if(Kn==57 && !Sv){                                       /* 57  下見機能の制御 */
    if(Ak) Ak=0;                                     /* 既に下見状態なら下見を終了する */
    else {if(!Gon){XMapWindow(dpy, wnd); Gon=1;} ph=0; Ak=1;}/* 通常状態なら下見を開始 */
    rd=1;                                                                /* 再描図する */
  }else if(Kn<=63 && !Sv && Ak){               /* 倣い入力時のkiの機能鍵を下見中のとき */
    Ak=3; rd=1;                                                      /* その備考を出す */
  }else if(Kn>57){                                         /* 呼び字列入力時の編集用鍵 */
    if(Gk||Dk||Mk){Gk=Dk=Mk=0; rd=1;}                        /* 選択待ちは御破算にする */
    if(CT && Co>1){                                                      /* 表記表示中 */
      switch(Kn){  
        case 58:                                                                 /* ↑ */
          if(Co==3){Co=2; rd=1;}                     /* Co=3の状態ならCo=2の状態に戻る */
          if(Sh){                                            /* 字引で前の表記群に移る */
            if(En){                  /* イベントがキューに残っていたらこの打鍵は捨てる */
            }else{
              if(kiDicstr(-2)) rd=1;
            }
          }else{                                                                 /* ↑ */
            if(kiDicstr(-1)) rd=1;                                 /* 前の表記行に移動 */
          }
          break;
        case 59:                                                 /* ←  前の文字に移動 */
          if(Co==3){Co=2; rd=1;}                     /* Co=3の状態ならCo=2の状態に戻る */
          if(Ti){                                                /* 既に左端ではなくて */
            if(Sh){                                                     /* Shift打なら */
              BYTE ti, tn;
              ti=Ti;
              if(Ts[ti]==' '&&Tw[ti]==1){                    /* 現在位置が空白文字なら */
                for(ti--; (Tw[ti]==1&&Ts[ti]==' ') && ti; ti--);     /* 一般字まで辿り */
                if(!(Tw[ti]==1&&Ts[ti]==' ')){                               /* あれば */
                  tn=ti;                                             /* ひとまず控える */
                  if(ti){                                      /* それが左端でなければ */
                    for(ti--; !(Tw[ti]==1&&Ts[ti]==' ') && ti; ti--) tn=ti;  /* 空白迄 */
                    if(!(Tw[ti]==1&&Ts[ti]==' ')) tn=ti;             /* ti=0つまり左端 */
                  }
                  Ti=tn; Fn=0;
                  RkFk(&Ts[Ti], Tw[Ti]);                         /* 改めて鍵位置を出す */
                  rd=1;
                }
              }else{                                         /* 現在位置が一般文字なら */
                for(tn=ti--; !(Tw[ti]==1&&Ts[ti]==' ') && ti; ti--) tn=ti; /* 空白字迄 */
                if(!(Tw[ti]==1&&Ts[ti]==' ')) tn=ti;
                if(ti){                                          /* tiは左最終空白文字 */
                  for(ti--; (Tw[ti]==1&&Ts[ti]==' ') && ti; ti--);   /* 空白字を読捨て */
                  if(!(Tw[ti]==1&&Ts[ti]==' ')){                   /* 一般文字であれば */
                    tn=ti;                                 /* ひとまずこの位置を控える */
                    if(ti){                                      /* 既に左端でなければ */
                      for(ti--; !(Tw[ti]==1&&Ts[ti]==' ') && ti; ti--) tn=ti;
                      if(!(Tw[ti]==1&&Ts[ti]==' ')) tn=ti;                     /* 左端 */
                    }
                  }
                }
                if(tn!=Ti){
                  Ti=tn; Fn=0;
                  RkFk(&Ts[Ti], Tw[Ti]);                         /* 改めて鍵位置を出す */
                  rd=1;
                }
              }
            }else{                                                         /* 平打なら */
              for(Ti--; !Tw[Ti]; Ti--);                          /* 位置を１字分戻して */
              Fn=0;
              RkFk(&Ts[Ti], Tw[Ti]);                             /* 改めて鍵位置を出す */
              rd=1;
            }
          }
          break;
        case 60:                                                 /* →  次の文字に移動 */
          if(Co==3){Co=2; rd=1;}                     /* Co=3の状態ならCo=2の状態に戻る */
          if(Ti<Tn){                                             /* 右端直前ではなくて */
            if(Sh){                                                       /* Shift打で */
              BYTE ti, tn;
              ti=Ti;
              if(Ts[ti]==' '&&Tw[ti]==1){                    /* 現在位置が空白文字なら */
                for(ti++; (ti!=Tn)&&(Ts[ti]==' '&&Tw[ti]==1); ti++);   /* 空白を読捨て */
                Ti=ti; Fn=0;             /* 現在位置を更新し１字ずつ見てゆく設定にして */
                RkFk(&Ts[Ti], Tw[Ti]);                           /* この鍵の打順を出す */
                rd=1;
              }else{                                         /* 現在位置が一般文字なら */
                for(ti++; (ti!=Tn)&&!(Ts[ti]==' '&&Tw[ti]==1); ti++);  /* 文字を読捨て */
                if(ti!=Tn){                                /* 少くとも右端ではないなら */
                  for(ti++; (ti!=Tn)&&(Ts[ti]==' '&&Tw[ti]==1); ti++); /* 空白を読捨て */
                  Ti=ti; Fn=0;                 /* それを採り１字ずつ見てゆく設定にして */
                  RkFk(&Ts[Ti], Tw[Ti]);                         /* この鍵の打順を出す */
                  rd=1;
                }else{                                                         /* 行末 */
                  Ti=Tn; Fn=0;
                  RkFk(&Ts[Tn], Tw[Tn]);
                  rd=1;
                }
              }
            }else{                                                         /* 平打なら */
              Ti+=Tw[Ti]; Fn=0;          /* 位置を１字分進めて１字ずつ処理する設定にし */
              RkFk(&Ts[Ti], Tw[Ti]);                             /* 新たな鍵位置を出す */
              rd=1;
            }
          }
          break;
        case 61:                                                                 /* ↓ */
          if(Co==3){Co=2; rd=1;}                     /* Co=3の状態ならCo=2の状態に戻る */
          if(Sh){                                            /* 字引で次のの表記に移る */
            if(En){                  /* イベントがキューに残っていたらこの打鍵は捨てる */
/* 02-08-03土 
  fprintf(stderr, "Sh 61: %2d Events rest\n", En);
 -- */
            }else{
              if(kiDicstr(2)) rd=1;
            }
          }else{                                                                 /* ↓ */
            if(kiDicstr(1)) rd=1;                                  /* 次の表記行に移る */
          }
          break;
        case 62:                                                                 /* BS */
          if(Co==3){Co=2; rd=1;}                     /* Co=3の状態ならCo=2の状態に戻る */
          else{                                                            /* Co=2なら */
            Dn=0; Co=1; rd=1;                                          /* Co=1に戻るが */
            if(Sh){Cn=Ci=0; Cs[0]=0; Cw[0]=0;}/* Shiftを押していたら呼び字列を空にする */
          }
          break;
        case 63:                                       /* Enter 該当表記として取り込む */
          if(Co==3) Co=2;                    /* 乙鍵盤の状態であれば甲鍵盤に戻しておく */
          if(!Ts[Ti]){                                                   /* 行末の時は */
            if     (kiDicstr(1));                                      /* 次の行に移る */
            else if(kiDicstr(2));                    /* 既に最下行なら次の表記群に移る */
            else   {Dn=0; Co=1;}                     /* 字引末なら呼び字列の編集に戻る */
            IMForwardEvent(ims, (XPointer)call_data);            /* フィルタせずに渡す */
          }else{                                                       /* それ以外の時 */
            BYTE *q, i, j, c, w[Cmax+2];
            XTextProperty tp;
            if(!Sh||(Ts[Ti]==' ')){         /* Shiftが押されていないか半角空白文字なら */
              for(i=0; i<Tw[Ti]; i++) w[i]=Ts[Ti+i]; w[i]=0;               /* 取り込む */
            }else{                       /* それ以外は該当字以降空白文字の前か行末まで */
              for(i=0, q=&Ts[Ti]; (c=q[i]) && c!=' '; i++) w[i]=c; w[i]=0;
            }
            q=w;
            tp.value=(unsigned char *)NULL;
            setlocale(LC_CTYPE,"");
            Xutf8TextListToTextProperty(display,(char **)&q,1,XCompoundTextStyle, &tp);
            ((IMCommitStruct*)call_data)->flag |= XimLookupChars;
            ((IMCommitStruct*)call_data)->commit_string = (unsigned char *)tp.value;
            IMCommitString(ims, (XPointer)call_data);                  /* 文字列を送る */
            if(tp.value!=NULL) XFree(tp.value);
            Ti+=i;
            RkFk(&Ts[Ti], Tw[Ti]);                               /* 新たな鍵位置を出し */
          }
          rd=1;
          break;
      }
    }else if(Kn==62 && Lk && !Ll){                 /* 甲打省略でない乙打待ちでのBSなら */
      Lk=0; rd=1;                                                    /* 甲打待ちに戻る */
    }else{                             /* Co=1 か Co=0  呼び字列入力中も含む自力入力中 */
      if(Lk && !Ll) {Lk=0; rd=1;}              /* 甲打省略でなければ甲打も御破算にする */
      if(CT && Co==1){                                               /* 呼び字列入力中 */
        BYTE Cio, Cin;
        switch(Kn){
          case 59:                                             /* ←        前方に移動 */
            if(Ci){                                              /* 既に左端ではなくて */
              if(Sh) Ci=0;                        /* Shiftが押されていたら左端に移動し */
              else  {for(Ci--; !Cw[Ci]; Ci--);}    /* 押されていなければ１字左に戻して */
              rd=1;                                    /* 要再描画および要通知を控える */
            }
            break;
          case 60:                                             /* →        後方に移動 */
            if(Cn && Ci<Cn){ /* 簡単にif(Ci!=Cn)でもよいか */    /* 既に右端ではなくて */
              if(Sh) Ci=Cn;                       /* Shiftが押されていたら右端に移動し */
              else   Ci+=Cw[Ci];                   /* 押されていなければ１字だけ進めて */
              rd=1;                                    /* 要再描画および要通知を控える */
            }
            break;
          case 62:                                               /* BS    前の字を消す */
            if(Ci){                                            /* 既に左端でなければ   */
              if(Sh){                                           /* Shift押されていたら */
                BYTE j;
                for(j=0; Ci+j<Cn; j++ ){             /* 左端から直前の字までを削除する */
                  Cs[j]=Cs[Ci+j]; Cw[j]=Cw[Ci+j];
                }
                Ci=0; Cn=j; Cs[j]=0; Cw[j]=0;
              }else{                                             /* 押されていなければ */
                Cio=Ci;                                        /* 今の位置を控えてから */
                for(Ci--; !Cw[Ci]; Ci--);                      /* 文字位置を１字分戻す */
                for(Cin=Ci; Cio<Cn; Cin++, Cio++){
                  Cs[Cin]=Cs[Cio];
                  Cw[Cin]=Cw[Cio];
                }
                Cs[Cin]=Cs[Cio];
                Cw[Cin]=Cw[Cio];
                Cn=Cin;
              }
              rd=1;
            }
            break;
          case 63:                                           /* Enter 表記群を呼び出す */
            if(!Cn){                                             /* 呼び字列が空の時は */
              FILE *f;
              BYTE j, B[Bmax];
              if(f=fopen(pMDG(1, kiD), "r")){                            /* 字引を開き */
                if(fgett(B, Bmax, f) && B[0]>=' '){                /* 標題行を読み込み */
                  check_kiDic(B);      /* 標題の記載が控えと違っていたら控えを更新して */
                  for(; fgett(B, Bmax, f) && B[0]!='.'; );     /* 最初の見出し行を出す */
                  if(B[0]=='.' && B[1]>' '){                 /* 実際に見出し行であれば */
                    for(j=1; B[j]>=' ' && j<=Cmax; j++); B[j]=0;   /* 最大でCmaxまでを */
                    insS(&B[1]);                                 /* 呼び字列として採り */
                  }
                }
                fclose(f);                                             /* 字引を閉じる */
              }
            }
            if(Cn){                                            /* 呼び字列があれば     */
              Co=2;                                              /* Csに対する表記列の */
              kiDicstr(0);
              rd=1;                                            /* 要再描画の印を付ける */
            }
            break;
          case 58:                                                               /* ↑ */
            break;
          case 61:                                                               /* ↓ */
            break;
        }
      }else{                                                             /* 通常の入力 */
        IMForwardEvent(ims, (XPointer)call_data);                /* フィルタせずに渡す */
      }
    }
  }
  return True;
}

MySetICFocusHandler(XIMS ims, IMChangeFocusStruct *call_data){
  CARD16 nf_id;

/* 02-09-13金 
fprintf(stderr, "SetFocus  connect_id=%4d icid=%4d\n",
         call_data->connect_id, call_data->icid);
 -- */

  nf_id = call_data->icid;
  if(cf_id != nf_id){
    cf_id = nf_id;
    if(Gon) {rd=1; XMapWindow(dpy, wnd);}
  }
}

MyUnsetICFocusHandler(XIMS ims, IMChangeFocusStruct *call_data){
  CARD16 nf_id;

/* 02-09-13金 
fprintf(stderr, "Unfocus   connect_id=%4d icid=%4d\n",
         call_data->connect_id, call_data->icid);
 -- */

  nf_id = call_data->icid;
  if(cf_id == nf_id){
    cf_id = 0;
    if(Gon) {rd=0; XUnmapWindow(dpy, wnd);}                    /* 表示をしていたら消す */
  }
}

MyProtoHandler(XIMS ims, IMProtocol *call_data){
  switch (call_data->major_code) {
    case XIM_OPEN:
      MyOpenHandler(ims, (IMOpenStruct *)call_data);
      break;
    case XIM_CLOSE:
      MyCloseHandler(ims, (IMCloseStruct *)call_data);
      break;
    case XIM_CREATE_IC:
      MyCreateICHandler(ims, (IMChangeICStruct *)call_data);
      break;
    case XIM_DESTROY_IC:
      MyDestroyICHandler(ims, (IMDestroyICStruct *)call_data);
      break;
    case XIM_SET_IC_VALUES:
      MySetICValuesHandler(ims, (IMChangeICStruct *)call_data);
      break;
    case XIM_GET_IC_VALUES:
      MyGetICValuesHandler(ims, (IMChangeICStruct *)call_data);
      break;
    case XIM_FORWARD_EVENT:
      MyForwardEventHandler(ims, (IMForwardEventStruct *)call_data);
      break;
    case XIM_SET_IC_FOCUS:
      MySetICFocusHandler(ims, (IMChangeFocusStruct *)call_data);
      break;
    case XIM_UNSET_IC_FOCUS:
      MyUnsetICFocusHandler(ims, (IMChangeFocusStruct *)call_data);
      break;
    case XIM_RESET_IC:
      break;
    case XIM_TRIGGER_NOTIFY:
    case XIM_PREEDIT_START_REPLY:
    case XIM_PREEDIT_CARET_REPLY:
    default:
      fprintf(stderr, "ki: %2d: %2d XIM_ki_unexpected\n",
                           call_data->any.connect_id, call_data->major_code);
  }
}

void customize(int l, BYTE *a){
  int  j;
  BYTE c, k, B[Bmax];
  
  for(j=0; (c=a[j])>=' ' && j<l; j++) B[j]=c; B[j]=0;      /* 制御字までの文字列を採る */
  if(B[0]=='G' && B[1]=='o'){                              /* 起動時から表示するか否か */
    if     (B[2]=='n')              Gon=1;                                     /* する */
    else if(B[2]=='f' && B[3]=='f') Gon=0;                                   /* しない */
  }else if(B[0]=='L' && B[1]=='o' && B[2]=='g'){     /* 受けたXIM Protocolのログを取る */
    Log=1;
  }else if(l>=7 && l<Cmax && B[0]=='L' && B[1]=='_'){                      /* ロカール */
    BYTE *q;
    q=&B[2];
    for(j=0; (((c=q[j])>='0' && c<='9')||(c>='A'&&c<='Z')||(c>='a'&&c<='z')||
              c=='_'||c=='-'||c=='.'||c==',') && j<Cmax; j++);           /* 字列を調べ */
    if(j>=5 && c<' ' && j<=Cmax){                        /* locale名になり得る字列まで */
      q[j]=0;
      strcpy(IMLOCALE, q);                                               /* そこに写す */
    }
  }else if(l>10 && B[0]=='O' && B[1]=='_' &&                               /* 表示位置 */
                 B[ 2]>='0' && B[ 2]<='9' && B[ 3]>='0' && B[ 3]<='9' &&/* 横方向:中央 */
                 B[ 4]>='0' && B[ 4]<='9' && B[ 5]>='0' && B[ 5]<='9' &&
                 B[ 6]==',' &&
                 B[ 7]>='0' && B[ 7]<='9' && B[ 8]>='0' && B[ 8]<='9' &&/* 縦方向:上下 */
                 B[ 9]>='0' && B[ 9]<='9' && B[10]>='0' && B[10]<='9' ){
    Fx=(B[ 2]-'0')*1000+(B[ 3]-'0')*100+(B[ 4]-'0')*10+B[ 5]-'0';                 /* x */
    Fy=(B[ 7]-'0')*1000+(B[ 8]-'0')*100+(B[ 9]-'0')*10+B[10]-'0';                 /* y */
  }else if(l>13 && B[0]=='C' && ((B[1]>='0' &&  B[1]<='9') && B[2]=='_')){ /* 配色指定 */
    if(((c=B[3])==' '||(c>='0'&&c<='2')) && ((c=B[4])==' ' ||(c>='0' && c<='9'))
                           && (B[5]>='0' && B[5]<='9') && B[6]==',' &&
       ((c=B[7])==' '||(c>='0'&&c<='2')) && ((c=B[8])==' ' ||(c>='0' && c<='9'))
                           && (B[9]>='0' && B[9]<='9') && B[10]==',' &&
       ((c=B[11])==' '||(c>='0'&&c<='2')) && ((c=B[12])==' ' ||(c>='0' && c<='9'))
       && (B[13]>='0' && B[13]<='9') && (!B[14] || B[14]=='\t')){
      USHORT r, g, b;                    /* 各値が0～255の範囲にあることを確認しておく */
      if(B[3]==' ') B[3]='0'; if(B[4]==' ') B[4]='0';
      if(B[7]==' ') B[7]='0'; if(B[8]==' ') B[8]='0';
      if(B[11]==' ') B[11]='0'; if(B[12]==' ') B[12]='0';
      r=(B[3]-'0')*100+(B[4]-'0')*10+B[ 5]-'0';
      g=(B[7]-'0')*100+(B[8]-'0')*10+B[ 9]-'0';
      b=(B[11]-'0')*100+(B[12]-'0')*10+B[13]-'0';
      if(r<256 && g<256 && b<256){
        k=B[1]-'0';
        h2c(r, &XCol[k][1]); h2c(g, &XCol[k][3]); h2c(b, &XCol[k][5]);
      }
    }
  }
}

main(int argc, BYTE *argv[]){
  FILE *fp;
  int  i, l;
  BYTE *p, a, b, c, B[Bmax];
  XIMS ims;
  XSetWindowAttributes attr;
  char *display_name = NULL;

  if(setlocale(LC_ALL, "")==NULL){
    fprintf(stderr, "XIM %s cannot set the locale.\n", IMNAME);
    exit(1);
  }
  if ((dpy = XOpenDisplay(display_name)) == NULL) {
    fprintf(stderr, "Can't Open Display: %s\n", display_name);
    exit(1);
  }
  root  = DefaultRootWindow (dpy);
  visual= DefaultVisual(dpy, 0);                             /* デフォルトのビジュアル */
  cmap  = DefaultColormap(dpy, 0);                         /* デフォルトのカラーマップ */
  {
    Window       r;
    int          x, y;
    unsigned int w, h, b, d;
    XGetGeometry(dpy, root, &r, &x, &y, &w, &h, &b, &d);     /* root画面の寸法を求めて */
    Fx=(int)w/2; Fy=(int)h;                        /* 無指定の位置を下辺中央に設定する */
  }
  {
    if(fp=fopen(PREF, "r")){                                   /* Prefファイルを開いて */
      BYTE *w;
      do{              /* 表示の有無・位置・配色、ロカールなどを、指定に従って設定する */
        if(w=fgett(B, Bmax, fp)){                                      /* １行読み込む */
          for(l=0; (b=B[l])!='\t' && b!=0; l++); B[l]=0;
          customize(l, B);
        }
      }while(w);
      fclose(fp);
    }
  }
  for (i = 1; i < argc; i++) {                     /* コマンド行の指定に従って設定する */
    l=strlen(argv[i]);
    customize(l, argv[i]);
  }
  if(load_kiKey()) fprintf(stderr, "\nKeyMap: %s\n", pMDG(0, 0));      /* 配鍵表の設定 */
  else  fprintf(stderr, "\nKeyMap: Default\n");
  load_FH();                                     /* 54～57鍵の見出しの文字列を設定する */
  strcpy(MDG, VAR); strcat(MDG, "K49");                              /* 実行時配字簿を */
  if(fp=fopen(MDG, "r")){                                                    /* 開いて */
    BYTE k, h, m;
    for(k=1; k<=99; k++){
      fgett(B, Bmax, fp);
      hm(B, &h, &m, K49H[0][k], K49M[0][k]);
    }
    for(k=0; k<=99; k++){
      fgett(B, Bmax, fp);
      hm(B, &h, &m, K49H[1][k], K49M[1][k]);
    }
    fclose(fp);
    K49=1;                               /* 以後、更新があればそれを保存する印をつける */
  }
  load_kiMap(1);                                   /* 起動時配字表として01簿を設定する */
  make_kiSt();                                                 /* 単打字の配字表を作る */
  load_kiDic(1);                                                         /* 字引を設定 */
  if(!load_kiFnt(1)){    /* 起動時フォントを設定する。それが得られない時は内蔵値を使う */
    fprintf(stderr, "XIM %s cannot create the primary FontSet.\n", IMNAME);
    exit(1);
  }
  for(i=0; i<10; i++){                                               /* 配色を設定する */
    if(XParseColor(dpy, cmap, XCol[i], &wcol[i])){         /* #RRGGBB表記をRGB値に変え */
      Col[i].red=wcol[i].red; Col[i].green=wcol[i].green; Col[i].blue=wcol[i].blue;
    }
    if(XftColorAllocValue(dpy, visual, cmap, &Col[i], &xcol[i]));
  }
  layout();
  Wx=Fx-(int)Ww/2; Wy=Fy-(int)Wh;                                /* 鍵盤図左上隅の位置 */
  check_Wxy();                   /* 配字案内が画面からはみ出るなら収まるように補正する */
  make_Dsp(0);                                               /* 配字簿の配鍵案内を作る */
  make_Dsp(1);                                                 /* 字引の配鍵案内を作る */
  make_Dsp(2);                                               /* 表示簿の配鍵案内を作る */
  wnd = XCreateSimpleWindow(dpy, root, Wx, Wy, Ww, Wh, 2, xcol[0].pixel, xcol[5].pixel);
  if (wnd == (Window)NULL) {
    fprintf(stderr, "Can't Create Window\n");
    exit(1);
  }
  bzero(&attr, sizeof(XSetWindowAttributes));
  attr.override_redirect = True;
  attr.win_gravity       = SouthGravity;                           /* 枠は上方に拡がる */
  XChangeWindowAttributes(dpy, wnd, CWOverrideRedirect | CWWinGravity, &attr);

  utf8 = XInternAtom(dpy, "UTF8_STRING", False);
  prop = XInternAtom(dpy, "__COPY_TEXT", False);
  ims=IMOpenIM(dpy, wnd, IMNAME, IMLOCALE, MyProtoHandler);
  if (ims == (XIMS)NULL) {
    fprintf(stderr, "XIM %s cannot open (or is running already)\n", IMNAME);
    exit(1);
  }else{
    fprintf(stderr, "XIM %s @im=%s opened\n", KIDATE, IMNAME);
  }
  XSelectInput(dpy, wnd, ButtonPressMask     |
                         ButtonReleaseMask   |
                         Button1MotionMask   |
                         ExposureMask        |
                         VisibilityChangeMask|
                         StructureNotifyMask  );

  for (;;) {
    XEvent event;
    static int mouse, x1, y1;
    XNextEvent(dpy, &event);
    En=XQLength(dpy);
    if(XFilterEvent(&event, None) == True){
    }else{
      switch (event.type) {
        case ButtonPress:
          if((event.xbutton.window == wnd) && (event.xbutton.button == 1)){
            x1 = event.xbutton.x_root;
            y1 = event.xbutton.y_root;
          }else if((event.xbutton.window == wnd) && (event.xbutton.button == 3)){
            Gon=0; rd =0;                  /* 不表示の控えに変え、再描画不要の印にして */
            XUnmapWindow(dpy, wnd);                                      /* 表示を消す */
          }
          break;
        case MotionNotify:
          if((event.xmotion.window == wnd)&&(event.xmotion.state & Button1Mask)){
            int x2, y2;
            mouse++;                                           /* 移動回数を１更新する */
            x2 = event.xmotion.x_root;
            y2 = event.xmotion.y_root;
            Wx = x2 - x1 + Wx;
            Wy = y2 - y1 + Wy;
            check_Wxy();             /* 配字案内が画面から出るなら収まるように補正する */
            XRaiseWindow(dpy, wnd);
            XMoveWindow(dpy, wnd, Wx, Wy);
            x1 = x2; y1 = y2;
          }
          break;
        case Expose:
          rd=1;                                                          /* 再描画する */
          break;
        case SelectionNotify:                              /* 既存字列を呼び字列にする */
          if(event.xselection.selection == XA_PRIMARY &&
             event.xselection.property  == prop){
            Atom type;
            XTextProperty tp;
            UINT nitems, left;
            int fmt, cnt;
            BYTE *buf;
            char **cl;
            if(XGetWindowProperty(dpy, wnd, prop, 0, 64, False, utf8,
                     &type, &fmt, &nitems, &left, &buf) == Success &&
                     type == utf8 && nitems>0){
              tp.value=buf;                                 /* BYTE * 原文字列表所在地 */
              tp.encoding=utf8;                                    /* Atom UTF8_STRING */
              tp.format  =fmt;                                    /* int  8            */
              tp.nitems  =nitems;                                   /* UINT 文字列の数 */
              Xutf8TextPropertyToTextList(dpy, &tp, &cl, &cnt);
              XFree(buf);
              insS(cl[0]);                                     /* 先頭の文字列だけ採る */
              XFreeStringList(cl);
              rd=1;                                                    /* 再描画を要す */
            }                                /* 正しい文字列が得られなかったら空のまま */
          }
          break;
        case VisibilityNotify:
          XRaiseWindow(dpy, wnd);
          rd=1;                                                        /* 再描画を要す */
          break;
        case GravityNotify:
          rd=1;                                                        /* 再描画を要す */
          break;
        case MappingNotify:
          make_kiSt();                                     /* 単打字の配字表を更新する */
          rd=1;                                                        /* 再描画を要す */
          break;
        default:
          break;
      }
    }
    if(Ak){                                          /* 下見の字列を控える指示がある時 */
      BYTE j, c, *q;
      ntD[0]=0; Sct=0; SctCd[0]=0;                         /* まず統計値控えを空にして */
      if(Son && Dsp && !Dk && !Gk){                    /* 統計値を表示する鍵盤であれば */
        if(Mk){                                                    /* 配字簿選択鍵盤で */
          if(Ak==1){                                                           /* 鍵盤 */
            if((kiM/50)==Sh){/* 現行簿が同側にあればメモリにある総統計値を数字で控える */
              Sct=Stat[0][0]+Stat[0][50]; sprintf(SctCd, "%8ld", Sct);
            }
          }else if(Ak==2){                                                   /* 文字鍵 */
            FILE *f;
            strcpy(MDG,VAR); strcat(MDG,"M"); strcat(MDG,Kdd[Kd]); strcat(MDG, ".freq"); 
            if(f=fopen(MDG, "r")){                           /* 現配字簿の統計簿を開き */
              BYTE  B[Bmax];
              fgett(B, Bmax, f); B[9]=0;                     /* 先頭行の行頭８桁を採り */
              fclose(f);                                               /* 統計簿は閉じ */
              Sct=(UINT)atol(B); sprintf(SctCd, "%8ld", Sct);  /* 統計値表示用に控える */
            }
          }
        }else if(Mr){                                              /* 複打相の文字鍵盤 */
          if(Ak==1){                                                           /* 鍵盤 */
            if(CT && Co==3) Sct=Stat[Rk][K0];                                /* 倣い乙 */
            else if(Lk)     Sct=Stat[Lk][K0];                                    /* 乙 */
            else            Sct=Stat[ 0][K0];                                    /* 甲 */
            sprintf(SctCd, "%8ld", Sct);                 /* 統計値の表示用字列に控える */
          }else if(Ak==2){                                                   /* 文字鍵 */
            if(CT && Co==3) Sct=Stat[Rk][Kd];                                /* 倣い乙 */
            else if(Lk)     Sct=Stat[Lk][Kd];                                    /* 乙 */
            else            Sct=Stat[ 0][Kd];                                    /* 甲 */
            sprintf(SctCd, "%8ld", Sct);                 /* 統計値の表示用字列に控える */
          }
        }
      }
      if(Ak==2){                                                             /* 文字鍵 */
        if(Gk||Dk||Mk){                                                    /* 選択鍵盤 */
          BYTE e, h, m, H[Hmax+2], M[Cmax+2];
          if(Gk) e=2; else if(Dk) e=1; else e=0;
          if(head_hm(pMDG(e, Kd), &h, &m, H, M)){          /* 該当する鍵の簿先頭行から */
            for(h=0; M[h]; h++) ntD[h]=M[h]; ntD[h]=0;                  /* 標題を控える*/
          }
        }else{                                                           /* 配字の時は */
          BYTE j=0, *s;
          if(CT && Co==3) s=kiMapM[Rk][Kd];                  /* 該当乙鍵盤が出ている時 */
          else{
            if(Mr){if(Lk) s=kiMapM[Lk][Kd]; else s=kiMapM[Kd][0];}
            else s=kiStM[Cp][Kd];
          }
          if(*s){for(j=0; s[j]; j++) ntD[j]=s[j]; ntD[j]=0;}     /* 標題欄に重ねる字列 */
        }
      }else if(Ak==3){                                                 /* 機能鍵の下見 */
        BYTE n=0;
        if(Kn==54){                                                      /* 配字操作鍵 */
          if(Mk){                                            /* 配字簿鍵盤が出ている時 */
            if(!CT || Co==1){if(Sh) n=7; else n=12;}                     /* 自力入力時 */
            else{                                                /* 表記群が出ている時 */
              if(Mkns && Sh) n=11;    /* Shift K54なら字列で配字のある次の配字簿を示す */
              else if(Mkn && !Sh) n=10;    /* 同 K54なら単字で配字のある次配字簿を示す */
              else n=12;                         /* 該当配字簿がなければ文字鍵盤に戻る */
            }
          }else{                                                       /* 文字鍵盤の時 */
            if(!CT || Co==1){                                    /* 表記が出ていない時 */
              if(Sh){                                           /* Shiftが押されていて */
                if(Lk && Mr){                        /* 乙打待ちなら甲打省略の切り替え */
                  if(Ll) n=9; else n=8;                      /* 甲打省略・解除への表示 */
                }else n=6;                     /* 乙打待ちでなければ配字簿選択鍵の表示 */
              }else{                        /* Shiftが押されていなければ単・複切り替え */
                if(Mr) n=5;                    /* 現在甲鍵盤か通常の乙鍵盤なら単打相へ */
                else{                                            /* 単打相なら複打相で */
                  if(Ll) n=4; else n=3;      /* 甲打省略なら乙打、そうでなければ甲打へ */
                }
              }
            }else{                                               /* 表記群が出ている時 */
              if(Ms==3 && !Sh) n=4;    /* 固定乙鍵盤にあるならまず複打相(固定乙鍵盤)へ */
              else if(Ms==2 &&  Sh) n=9;
              else if(Ms==1 && !Sh){
                if(Mr) n=5; else {if(Ll) n=4; else n=3;}
              }else if(Ts[0]>' ' && Ms<2 && Sh) n=6;               /* 配字簿鍵盤を出す */
            }
          }
        }else if(Kn==55) {                                               /* 字引操作鍵 */
          if(Dk){if(Sh) n=20; else if(Dkn) n=19; else n=18;}/* clipboard、次字引、戻り */
          else if(!CT){if(Sh) n=14; else n=13;}                          /* 自力入力時 */
          else if(Co==1){if(Sh) n=17; else n=15;}                    /* 呼び字列入力時 */
          else {if(Sh) n=22; else n=21;}           /* 表記表示中なら呼び字列編集に戻る */
        }else if(Kn==56) {                                               /* 案内操作鍵 */
          if(Sh){if(Gk) n=26; else n=25;}   /* Shift押しなら主表示簿戻りか表示簿鍵盤へ */
          else   {if(Gk) n=27; else n=24;}     /* 押してなければ文字盤鍵戻りか不表示へ */
        }else if(Kn==58) {                                                       /* ↑ */
          if(CT){                                                        /* 倣い入力で */
            if(Co==1){if(Sh) n=32; else n=31;}                     /* 呼び字列の編集時 */
            else     {if(Sh) n=34; else if(Di) n=33;}                        /* 表記群 */
          }
        }else if(Kn==59) {                                                       /* ← */
          if(CT){                                                        /* 倣い入力で */
            if(Co==1){                                               /* 呼び字列編集時 */
              if(Ci){if(Sh) n=36; else n=35;}                    /* 左端か左へ１字移動 */
            }else{                                               /* 表記行が出ている時 */
              if(Ti){if(Sh) n=38; else n=37;}      /* 左端でなければ左へ１語か１字移動 */
            }
          }
        }else if(Kn==60) {                                                       /* → */
          if(CT && Co==1 && Ci!=Cn) {if(Sh) n=40; else n=39;}    /* 右端か右へ１字移動 */
          else if(CT && Co>1 && Ti!=Tn && (Ti+Tw[Ti]!=Tn)){if(Sh) n=42; else n=41;}
        }else if(Kn==61) {                                                       /* ↓ */
          if(CT){                                                        /* 倣い入力で */
            if(Co==1){if(Sh) n=44; else n=43;}                     /* 呼び字列の編集時 */
            else     {if(Sh) n=46; else if(Di<Dn-1) n=45;}                   /* 表記行 */
          }
        }else if(Kn==62) {                                                       /* BS */
          if(CT && Co==3) n=3; else if(CT && Co==2){if(Sh) n=50; else n=49;}
          else if(Mr && Lk && !Ll) n=3;
          else if(CT && Co==1 && Ci){if(Sh) n=48; else n=47;}
        }else /* Kn==63*/{                                                    /* Enter */
          if(CT && Co==1) {if(Sh) n=52; else n=51;}
          else if(CT && Co>1){
            if(Sh) n=54; else n=53;
          }
        }
        G_n(n, 0);                              /* 標題位置に出す本字列をntDに追加する */
      }
    }
    if(rd && Gon){                                               /* 再描画が必要の場合 */
      BYTE ls, lk, fs, fk, kn, gkn, *Bw, rk, gk, ak, *pt, *p, *q;
      BYTE buf[Cmax+2];
      BYTE cgc;
      GC    gc;
      XftDraw *draw =NULL;
      Pixmap pix;
      if((Ak||ph) && Kn<=Km) ak=Kn; else ak=0;                     /* 下見鍵か非倣い鍵 */
      if((Ll && !Mr)||Gk){ls=0; lk=0;} else{ls=Lk/50; lk=(Lk%50);} /* 甲鍵位置を控える */
      rk=gk=0;                             /* 緑や赤で表示する鍵は始めは無しにしておく */
      if(sz){                                          /* サイズ変更の指示があった場合 */
        int w, h;
        w=(int)Ww; h=(int)Wh;                                  /* 今の幅と高さを控えて */
        layout();                                                      /* 枠を作り直し */
        if     (!Wxt  ) Wx += w/2-(int)Ww/2; /* 内側にあれば現在の中央から左右への伸縮 */
        else if(Wxt>1)  Wx += w-(int)Ww;                       /* 右固定なら左への伸縮 */
        if(Wyt)         Wy += h-(int)Wh;                       /* 下基準なら上に伸ばす */
        sz=0;
        check_Wxy();             /* 配字案内が画面から出るようなら収まるように補正する */
        XRaiseWindow(dpy, wnd);
        XMoveResizeWindow(dpy, wnd, Wx, Wy, Ww, Wh);
      }
      pix=XCreatePixmap(dpy, wnd, Ww, Wh, DefaultDepth(dpy, 0));
      gc= XCreateGC(dpy, pix, 0, 0);
      draw=XftDrawCreate(dpy, pix, visual, cmap);
      kn=gkn=0;
      if(Sv){                                             /* CtrlかAltが押されている時 */
        cgc=4;                                                            /* 機能字 緑 */
        Bw=kiStH[Sv+Sv+Cp][K0];                                    /* 単打鍵盤の見出し */
        pt=kiStM[Sv+Sv+Cp][K0];                                                /* 標題 */
      }else if(Gk){
        cgc=2;                                                            /* 基本字 黒 */
        Bw=kiDsp[2][K0];                                               /* 表示簿の配鍵 */
        gkn=kiF; if((gkn/50)==Sh) gk=gkn%50;                         /* 現行表示簿の鍵 */
        G_n(25, buf); pt=buf;                                  /* 表示簿選択鍵盤の標題 */
      }else if(Dk){
        cgc=2;                                                            /* 基本字 黒 */
        Bw=kiDsp[1][K0];                                                 /* 字引の配鍵 */
        if(CT && Co==1 && Dkn && Dkn<100){kn=Dkn; if((kn/50)==Sh) rk=kn%50;} /* 該当鍵 */
        gkn=kiD; if((gkn/50)==Sh) gk=gkn%50;                     /* 現在の割当て文字鍵 */
        G_n(17, buf); pt=buf;                                    /* 字引選択鍵盤の標題 */
      }else if(Mk){                                                  /* 配字簿選択鍵盤 */
        cgc=2;                                                            /* 基本字 黒 */
        Bw=kiDsp[0][K0];                                             /* 選択鍵盤を表示 */
        if(CT && Co>1){
          if(Fn && Mkns && Mkns<100){kn=Mkns; if((kn/50)==Sh) rk=kn%50;}     /* 文字列 */
          else if(!Fn && Mkn && Mkn<100){kn=Mkn; if((kn/50)==Sh) rk=kn%50;}  /* １文字 */
        }
        gkn=kiM; if((gkn/50)==Sh) gk=gkn%50;                         /* 現行配字簿の鍵 */
        G_n( 6, buf); pt=buf;                                  /* 配字簿選択鍵盤の標題 */
      }else if(CT && ((Co==2 && Ll && Mr && Fk && !Ms)||Co==3)){ /* 有効倣い乙鍵盤の時 */
        cgc=2;                                                            /* 基本字 黒 */
        Bw=kiMapH[Rk][K0];                                               /* 倣い乙鍵盤 */
        kn=Fk; if((Fk/50)==Sh) rk=kn%50;                                 /* 該当文字鍵 */
        ls=Rk/50; lk=Rk%50;                                                /* 甲鍵位置 */
        if(!*(pt=kiMapM[Rk][K0])) pt=Bw;                                       /* 標題 */
      }else if(CT && Co==2 && Fk && !Ms){          /* 注目字を打つ鍵が現鍵盤相にある時 */
        if(Rk){                                                          /* 複打相なら */
          cgc=3;                                                          /* 甲鍵色 青 */
          Bw=kiMapH[0][K0];
          kn=Rk; if((kn/50)==Sh) rk=kn%50;                                 /* 該当甲鍵 */
          if(!*(pt=kiMapM[0][K0])) pt=Bw;                                  /* 鍵盤標題 */
        }else{                                                             /* 単打鍵盤 */
          cgc=2;                                                          /* 基本字 黒 */
          Bw=kiStH[Cp][K0];                                          /* 単打字(基本字) */
          kn=Fk; if((kn/50)==Sh) rk=kn%50;
          if(!*(pt=kiStM[Cp][K0])) pt=Bw;                            /* 単打鍵盤の標題 */
        }
      }else if(Mr && Lk){                                                    /* 乙鍵盤 */
        cgc=2;                                                            /* 基本字 黒 */
        Bw=kiMapH[Lk][K0];                                           /* 乙打鍵盤の表示 */
        ls=Lk/50; lk=Lk%50;                                      /* 甲鍵の位置を控える */
        if(!*(pt=kiMapM[Lk][K0])) pt=Bw;                                       /* 標題 */
      }else if(Mr){                                                          /* 複打相 */
        cgc=3;                                                            /* 甲鍵色 青 */
        Bw=kiMapH[0][K0];                                                    /* 甲鍵盤 */
        if(!*(pt=kiMapM[0][K0])) pt=Bw;                                    /* 鍵盤標題 */
      }else{                                                               /* 単打鍵盤 */
        cgc=2;                                                            /* 基本字 黒 */
        Bw=kiStH[Cp][K0];                                                  /* 単打鍵盤 */
        if(!*(pt=kiStM[Cp][K0])) pt=Bw;                              /* 単打鍵盤の標題 */
      }
      XftDrawRect(draw, &xcol[5], 0, 0, Ww, Wh);                     /* 白鍵盤に戻して */
      if(Dsp){                                                 /* 鍵盤図も表示する場合 */
        XftDrawRect(draw, &xcol[0], 1, hh-dh2+1, Gw*uw-2, lh);         /* 標題地を塗る */
        XftDrawStringUtf8(draw, &xcol[cgc], cft, uw-cxo, hh-dh-cyo, pt, strlen(pt));
        if(Hon){
          XftDrawRect(draw, &xcol[cgc], KPos[25][0]-1, KPos[25][1]-1, 11*uw+2, ch2);
          XftDrawRect(draw, &xcol[cgc], KPos[31][0]-1, KPos[31][1]-1, 11*uw+2, ch2);
        }
        for(kn=1; kn<=Km; kn++){                               /* 各文字鍵の矩形を塗る */
          if(kn==ak)                                       /* 下見の鍵なら重ね地にする */
            XftDrawRect(draw, &xcol[1], KPos[kn][0]-1, KPos[kn][1]-1, cw2, ch2);
          else if(kn==lk){                                   /* 甲打済みなら甲鍵位置を */
            if(Ll)                                               /* 固定乙鍵盤の時は緑 */
              XftDrawRect(draw, &xcol[4], KPos[kn][0]-1, KPos[kn][1]-1, cw2, ch2);
            else                                                   /* その他は青地にし */
              XftDrawRect(draw, &xcol[3], KPos[kn][0]-1, KPos[kn][1]-1, cw2, ch2);
            if(ls)                                   /* 裏甲打ならその左に緑の■を出す */
              XftDrawRect(draw, &xcol[4], KPos[kn][0]-uw+1, KPos[kn][1]-1, uw-2, ch2);
          }else if(Hon){
            if((kn>=25 && kn<=28)||(kn>=31 && kn<=34));            /* 指置き位置は放置 */
            else XftDrawRect(draw, &xcol[8], KPos[kn][0]-1, KPos[kn][1]-1,cw2,ch2);
          }
          if(*(p=&Bw[(Hmax+2)*kn])){
            if(kn==rk || kn==gk){                            /* 赤か緑の字で表示する鍵 */
              if(kn==rk)                                                   /* 倣い鍵は */
                XftDrawStringUtf8(draw, &xcol[7], cft,
                                 KPos[kn][0]-cxo, KPos[kn][1]-cyo, p, strlen(p));
              else
                XftDrawStringUtf8(draw, &xcol[4], cft,
                                 KPos[kn][0]-cxo, KPos[kn][1]-cyo, p, strlen(p));
              XftDrawRect(draw, &xcol[4], KPos[kn][0], KPos[kn][1]+cch+1, ccw,1);/*下線*/
            }else if(((kn==lk ||(((kn>=25&&kn<=28)||(kn>=31&&kn<=34))&&Hon))&&kn!=ak))
              XftDrawStringUtf8(draw, &xcol[5], cft,
                                 KPos[kn][0]-cxo, KPos[kn][1]-cyo, p, strlen(p));
            else
              XftDrawStringUtf8(draw, &xcol[cgc], cft,
                                 KPos[kn][0]-cxo, KPos[kn][1]-cyo, p, strlen(p));
          }
        }
        for(kn=50; kn<58; kn++)        /* 押上鍵およびkiの機能鍵の位置に下地を表示する */
          if(Hon && ntoy[kn]) XftDrawRect(draw, &xcol[9],
                                          KPos[kn][0]-1, KPos[kn][1]-1, cw2, ch2);
        if(ntoy[50] && Sh)                                                    /* Shift */
          XftDrawRect(draw, &xcol[4], KPos[50][0], KPos[50][1], ccw, cch);
        if(ntoy[51] && Cp)                                                 /* CapsLock */
          XftDrawRect(draw, &xcol[4], KPos[51][0], KPos[51][1], ccw, cch);
        if(ntoy[52] && (Sv & 0x01))                                            /* Ctrl */
          XftDrawRect(draw, &xcol[4], KPos[52][0], KPos[52][1], ccw, cch);
        if(ntoy[53] && (Sv & 0x02))                                             /* Alt */
          XftDrawRect(draw, &xcol[4], KPos[53][0], KPos[53][1], ccw, cch);
        if(ntoy[54] && !Sv){                         /* 54番鍵(配字切替え鍵)がある場合 */
          BYTE c=4;                                                    /* 文字の色は緑 */
          if(Kn==54 && Ak)
            XftDrawRect(draw, &xcol[1], KPos[54][0], KPos[54][1], ccw, cch);
          if(Mk){                                                /* 配字簿選択鍵盤の時 */
            if((!CT||Co==1) && Sh){                 /* 非倣い鍵盤でShiftを押していたら */
              if(!*(p=FH[7])){if(kiM==1) p=kiDsp[0][2]; else p=kiDsp[0][1];} /* 主か副 */
            }else if(!Sh && Mkn ) p=FH[10];          /* 該当配字簿探し時ならそれを示す */
            else if(Sh && Mkns) p=FH[11];                  /* 文字列で次の配字簿を示す */
            else                p=FH[12];                            /* 文字入力に戻る */
          }else if(!CT || Co==1){                              /* 表記群が出ていない時 */
            if(Sh){                                             /* Shiftが押されていて */
              if(Lk && Mr){                          /* 乙打待ちなら甲打省略の切り替え */
                if(Ll) p=FH[9]; else  p=FH[8];
              }else p=FH[6];                   /* 乙打待ちでなければ配字簿選択鍵の表示 */
            }else{                          /* Shiftが押されていなければ単・複切り替え */
              if(Mr) {if(!*(p=FH[5])) p=kiStH[0][0];}        /* 現在複打相なら単打相の */
              else{                                                        /* 単打相で */
                if(Ll){                                                /* 甲打省略の時 */
                  if(!*(p=FH[4])){                               /* 指定文字がなければ */
                    c=3;                                                   /* 青い字で */
                    p=kiMapH[Lk][0];                 /* 甲鍵盤に出ている乙鍵盤の見出し */
                  }
                }
                else  {if(!*(p=FH[3])) p=kiMapH[0][0];}        /* そうでなければ甲鍵盤 */
              }
            }
          }else if(Ms==3 && !Sh){                                      /* 固定乙鍵盤へ */
            c=7; if(!*(p=FH[4])) p=kiMapH[Lk][0];
          }else if(Ms==2 && Sh){                                   /* 固定乙鍵盤解除へ */
            c=7; if(!*(p=FH[9])) p=kiMapH[0][0];
          }else if(Ms==1 && !Sh){                                        /* 対打相なら */
            c=7;                                                       /* 赤い字で示す */
            if(Mr) {if(!*(p=FH[5])) p=kiStH[0][0];}          /* 現在複打相なら単打相の */
            else{                                                      /* 現在単打相で */
              if(!*(p=FH[3])){               /* 甲鍵盤へ切り替える見出しの指定がない時 */
                if(Ll) p=kiMapH[Lk][0];                        /* 固定乙鍵盤ならそれへ */
                else   p=kiMapH[ 0][0];                      /* 通常乙鍵盤なら甲鍵盤へ */
              }
            }
          }else if(Ts[0]>' ' && Sh && Ms<2) p=FH[6];
          else p=FH[0];
          if(*p)                                                 /* 見出しがあれば表示 */
            XftDrawStringUtf8(draw, &xcol[c], cft,
                                   KPos[54][0]-cxo, KPos[54][1]-cyo, p, strlen(p));
          if(c==7)                               /* 赤い字で示す時は、緑の下線を付ける */
            XftDrawRect(draw, &xcol[4], KPos[54][0], KPos[54][1]+cch+1, ccw, 1);
        }
        if(ntoy[55] && !Sv){                           /* 55番鍵(倣い入力鍵)がある場合 */
          if(Kn==55 && Ak)
            XftDrawRect(draw, &xcol[1], KPos[55][0], KPos[55][1], ccw, cch);
          if(Dk){if(Sh) p=FH[20]; else if(Dkn) p=FH[19]; else p=FH[18];}   /* 字引鍵盤 */
          else if(!CT){if(Sh) p=FH[14]; else   p=FH[13];}                /* 自力入力時 */
          else if(Co==1){if(Sh) p=FH[17]; else p=FH[15];}            /* 呼び字列入力時 */
          else {if(Sh) p=FH[22]; else p=FH[21];}        /* 表記表示中のK55に対する処置 */
          if(*p)                                                 /* 見出しがあれば表示 */
            XftDrawStringUtf8(draw, &xcol[4], cft,
                                   KPos[55][0]-cxo, KPos[55][1]-cyo, p, strlen(p));
        }
        if(ntoy[56] && !Sv){                       /* 56番鍵(案内様式指示鍵)がある場合 */
          if(Kn==56 && Ak)
            XftDrawRect(draw, &xcol[1], KPos[56][0], KPos[56][1], ccw, cch);
          if(Sh){                                                 /* Shiftを押していて */
            if(Gk){                                                  /* 表示簿鍵盤なら */
              if(!*(p=FH[26])){if(kiF==1) p=kiDsp[2][2]; else p=kiDsp[2][1];}/* 主か副 */
            }else p=FH[25];                                /* 通常鍵盤なら表示簿鍵盤へ */
          }else {if(Gk) p=FH[27]; else p=FH[24];}/* 押してなければ文字鍵盤戻りか不表示 */
          XftDrawStringUtf8(draw, &xcol[4], cft,
                                   KPos[56][0]-cxo, KPos[56][1]-cyo, p, strlen(p));
        }
        if(ntoy[57] && !Sv){                               /* 57番鍵(下見鍵)がある場合 */
          if(Ak){                                /* 既に下見の打鍵待ちなら、塗り潰して */
            XftDrawRect(draw, &xcol[1], KPos[57][0], KPos[57][1], ccw, cch);
            p=FH[2];                 /* 次に打つと下見終了であることを示す文字列を出す */
          }else p=FH[1];                                               /* 下見への表示 */
          XftDrawStringUtf8(draw, &xcol[4], cft,
                                   KPos[57][0]-cxo, KPos[57][1]-cyo, p, strlen(p));
        }
      }else{                                                 /* 鍵盤図を表示しない場合 */
        if(Gk||Dk||Mk||!CT){                             /* 倣い鍵盤以外の鍵盤であれば */
          XftDrawRect(draw, &xcol[0], Rc5x, Rc5y, Rc5w, Rc5h);       /* 表示矩形を塗り */
          XftDrawStringUtf8(draw, &xcol[cgc], cft, Rc4x-cxo, Rc4y-cyo, pt, strlen(pt));
        }else if(Co>1) XftDrawRect(draw, &xcol[6], Rc5x, Rc5y, Rc5w, Rc5h);  /* 注目行 */
        else if(Co==1) XftDrawRect(draw, &xcol[4], Rc5x, Rc5y, Rc5w, Rc5h);/* 呼び字列 */
        if(Ak){                                            /* 下見の機能を使っていたら */
          if((CT && !Gk && !Dk && !Mk) || Ak>1)
            XftDrawRect(draw, &xcol[1], Rc4x-1, Rc4y-1, Rc4w+2, Rc4h+2);   /* 字列矩形 */
          XftDrawRect(draw, &xcol[1], Rc1x, Rc1y, Rc1w, Rc1h);     /* 下見鍵矩形を塗り */
          if(Ak==1){                                               /* 鍵盤が出ている時 */
            if(!Gk && !Dk && !Mk){       /* 倣い入力時で選択鍵盤が出ていなければ鍵盤題 */
              if(CT){
                if(Mr && ((Co==1 && !Lk) || Co==2))                      /* 甲鍵盤は青 */
                  XftDrawStringUtf8(draw, &xcol[3], cft,Rc4x-cxo,Rc4y-cyo,pt,strlen(pt));
                else                                                         /* 他は黒 */
                  XftDrawStringUtf8(draw, &xcol[2], cft,Rc4x-cxo,Rc4y-cyo,pt,strlen(pt));
              }
            }
          }
        }
        if((!Ak || Ak==2) &&  (kn||gkn||(Ms && CT && Co==2)||        /* 倣い鍵か現行鍵 */
                     (Mk && Mkn && Mkn<100)||            /* 探して得た次の配字簿の鍵か */
                     (Dk && Dkn && Dkn<100))){     /* 探して得た次の字引の鍵かがあれば */
          BYTE k;
          if(!kn && Ms && CT && Co==2 && !Gk){if(!(Ms & 0x01)) k=50; else k=0;}/* 打相 */
          else if(kn || !gkn) k=kn;                  /* 倣い鍵がある時はその文字鍵番号 */
          else if(gkn) k=gkn;                          /* 現行簿の鍵ならその文字鍵番号 */
          if(!Mk && !Dk && !Gk && CT && Co==2 && Rk && !Ll)              /* 甲鍵盤は青 */
            XftDrawStringUtf8(draw, &xcol[3], cft, Gw*uw-cxo, dh2-cyo, Kdd[k], 2);
          else if(kn || !gkn)                                                    /* 赤 */
            XftDrawStringUtf8(draw, &xcol[7], cft, Gw*uw-cxo, dh2-cyo, Kdd[k], 2);
          else if(gkn)                                                           /* 緑 */
            XftDrawStringUtf8(draw, &xcol[4], cft, Gw*uw-cxo, dh2-cyo, Kdd[k], 2);
          else if(lk)                                                      /* 甲鍵は青 */
            XftDrawStringUtf8(draw, &xcol[3], cft, Gw*uw-cxo, dh2-cyo, Kdd[k], 2);
        }
      }
      if(CT && (Dsp || (!Mk && !Dk && !Gk && !Ak))){     /* 倣い入力時の各種情報を表示 */
        if(Dsp>=2){                                /* 倣い入力に拡張表示をしている場合 */
          XftDrawRect(draw, &xcol[0], 1, hx+1, Gw*uw-2, lh);   /* 字引標題の矩形を塗り */
          q=DicM;                                                      /* 標題の字列を */
          XftDrawStringUtf8(draw, &xcol[2], cft, uw-cxo, hx+2-cyo, q, strlen(q));/*表示*/
          if(Hon) XftDrawRect(draw, &xcol[4], Rc3x, Rc3y-1, Rc3w, Rc3h);   /* 呼び字列 */
          else    XftDrawRect(draw, &xcol[5], Rc3x, Rc3y-1, Rc3w, Rc3h);     /* の矩形 */
          if(Dsp==2) XftDrawRect(draw, &xcol[5], uw-1, hx+dh2+2*lh-1, (Gw-2)*uw+2, ch2);
          else XftDrawRect(draw, &xcol[5], uw-1, hx+dh2+2*lh-1,(Gw-2)*uw+2,Dmax*lh-dh+3);
        }else if(Dsp==1 && Co==1){                                   /* 定形表示の場合 */
          if(Hon) XftDrawRect(draw, &xcol[4], Rc3x, Rc3y-1, Rc3w, Rc3h);   /* 呼び字列 */
          else    XftDrawRect(draw, &xcol[5], Rc3x, Rc3y-1, Rc3w, Rc3h);     /* の矩形 */
        }
        if(Co==1){                                             /* 呼び字列の入力中なら */
          int x, y;
          XGlyphInfo xgl;
          XftTextExtentsUtf8(dpy, cft, Cs, Ci, &xgl);        /* 呼び字列の寸法を求めて */
          x=uw+xgl.xOff;                                     /* 次の書き出し位置を出し */
          if(Dsp){
            y=Rc3y+Rc3h;                                                   /* 文字位置 */
            if(Hon) XftDrawRect(draw, &xcol[5], x, y-dh, 1, dh);
            else    XftDrawRect(draw, &xcol[4], x, y-dh, 1, dh);
          }else{
            y=Rc4y+Rc4h+dh;                                                /* 文字位置 */
            XftDrawRect(draw, &xcol[5], x, y-dh, 1, dh);
          }
        }
        if(Cn){                                                    /* 呼び字列があれば */
          if(Dsp>=2 || (Dsp==1 && Co==1)){
            if(Hon) XftDrawStringUtf8(draw, &xcol[5], cft, Rc3x-cxo,Rc3y-cyo, Cs,Cn);
            else    XftDrawStringUtf8(draw, &xcol[4], cft, Rc3x-cxo,Rc3y-cyo, Cs,Cn);
          }else if(!Dsp && Co==1)
            XftDrawStringUtf8(draw, &xcol[5], cft, Rc4x-cxo,Rc4y-cyo, Cs,Cn);
          if(Co>1){                                              /* 表記群が出ている時 */
            BYTE i;
            for(i=0; i<Dn; i++){
              if(i==Di){                                                     /* 注目行 */
                BYTE j, fn, c, k, B[Cmax+2];
                int x, y;
                XGlyphInfo xgl;
                unsigned int th=1;
                if(Knx) c=7; else if(Rk&&Co==2) c=3; else c=4; /* 倣い打鍵の下線色分け */
                if(Dsp>=2){                                              /* 鍵盤表示で */
                  if(Dsp==2) j=0; else j=i;  /* １行だけ表示かDmax行を一度に表示かの別 */
                  XftDrawRect(draw, &xcol[6], uw-1, hx+dh2+(j+2)*lh-1, (Gw-2)*uw+2, ch2);
                }else if(Dsp==1){
                  XftDrawRect(draw, &xcol[6], Rc4x-1, Rc4y-1, Rc4w+2, Rc4h+2);
                }
                if(Fn) fn=Fn; else fn=Tw[Ti];                /* 表示する字列のバイト数 */
                XftTextExtentsUtf8(dpy, cft, Ts, Ti, &xgl);/* 注目字の位置を出しておく */
                x=uw+xgl.xOff;                               /* 次の書き出し位置を出し */
                if     (Dsp>=2) y=hx+dh2+(j+2)*lh-cyo;
                else if(Dsp==1) y=1-cyo;
                else            y=dh2-cyo;
                XftDrawStringUtf8(draw, &xcol[2], cft, uw-cxo, y, Ts, Tn);
                if(!Tw[Ti]) XftDrawRect(draw, &xcol[c], x+1, y+cyo+1, th, cch);/* 行端 */
                else{                                                    /* 行中の場合 */
                  XftTextExtentsUtf8(dpy, cft, &Ts[Ti], fn, &xgl);   /* 注目字列の寸法 */
                  XftDrawRect(draw, &xcol[6], x, y+cyo+1, xgl.xOff, cch);
                  XftDrawStringUtf8(draw, &xcol[7], cft, x, y, &Ts[Ti], fn);
                  y+=cyo+cch+1;
                  XftDrawRect(draw, &xcol[c], x, y, xgl.xOff, th);       /* 下線を引く */
                }
              }else if(Dsp==3){                              /* 群表示で注目行以外の行 */
                XftDrawStringUtf8(draw, &xcol[2], cft,
                                uw-cxo, hx+dh2+(i+2)*lh-cyo, DsM[i], strlen(DsM[i]));
              }
            }
            if(!Ak && Dsp && !Gk && !Dk && Cd[0]){/* 非下見時 文字コードを右下隅に表示 */
              XGlyphInfo xgl;
              int n;
              n=strlen(Cd);
              XftTextExtentsUtf8(dpy, cft, Cd, n, &xgl);   /* 文字コード字列の幅を出す */
              XftDrawStringUtf8(draw, &xcol[7], cft, Rc2x-xgl.xOff, Rc2y-cyo, Cd, n);
            }
          }
        }
      }
      if(Ak){                                      /* 下見中であれば関連情報を表示する */
        BYTE j, sw=0, *q;
        if(Dsp){                                                       /* 鍵盤表示の時 */
          if(Ak==1 && CT && Dsp==1){           /* 倣い入力で定形鍵盤の下見を開始した時 */
            XftDrawRect(draw, &xcol[1], Rc4x-1, Rc4y-1, Rc4w+2, Rc4h+2);   /* 下見矩形 */
            XftDrawStringUtf8(draw, &xcol[2], cft, Rc4x-cxo, Rc4y-cyo, pt, strlen(pt));
          }
          if(Ak!=1 && CT && ((Kn>=58 && Kn<=63)||Kn==55)){      /* ↑←→↓BS Entr K55 */
          }else if(Kn==57 && Ak==1 && !CT && !Mr && !Gk && !Mk){ /* 単打鍵盤下見開始時 */
            sprintf(SctCd, "%8ld", Rct); sw=1;         /* 総KeyRelease回数の文字列控え */
          }else if(SctCd[0]) sw=1;             /* 鍵盤や鍵に関する通知があればその用意 */
        }else if(Ak!=1){                                     /* 無盤表示で鍵の下見の時 */
          if(Ak==2 && Kd==kn)                                           c=7; /* 該当鍵 */
          else if(!kn && Ms && CT && Co==2 && Kn==54 &&
                          ((!(Ms & 0x01) && Sh)||((Ms & 0x01) && !Sh))) c=7; /* 打相赤 */
          else if(gkn && Kd==gkn)                                       c=4; /* 現行簿 */
          else if(lk && Kd==lk)                                         c=3;   /* 甲鍵 */
          else                                                          c=2; /* その他 */
          XftDrawRect(draw, &xcol[1], Rc1x, Rc1y, Rc1w, Rc1h);       /* 下見色に塗って */
          if(Kn<50){                                               /* 文字鍵番号を描く */
            XftDrawStringUtf8(draw, &xcol[c], cft, Rc1x-cxo, Rc1y-cyo, Kdd[Kd], 2);
          }
        }
        q=ntD;                                                   /* それ以外は本字列の */
        if(Ak!=1 && *q){                                           /* 有効字列があれば */
          for(j=0; q[j]; j++);                                       /* バイト数を出し */
          XftDrawRect(draw, &xcol[1], Rc4x-1, Rc4y-1, Rc4w+2,  Rc4h+2);    /* 標題欄に */
          if(Mk && Ak==2)      /* 配字簿鍵盤で下見する甲鍵盤の見出しは青い字で表示する */
            XftDrawStringUtf8(draw, &xcol[3], cft, Rc4x-cxo, Rc4y-cyo, q,j);
          else                                             /* その他は黒い字で表示する */
            XftDrawStringUtf8(draw, &xcol[2], cft, Rc4x-cxo, Rc4y-cyo, q,j);
        }
        if(sw){                                            /* 統計採取時の鍵盤であれば */
          int n;
          XGlyphInfo xgl;
          n=strlen(SctCd);                                 /* 統計値字列の字数を出して */
          XftTextExtentsUtf8(dpy, cft, SctCd, n, &xgl);/* 右詰めにするため字列幅を出し */
          XftDrawStringUtf8(draw, &xcol[2], cft, Rc2x-uw-xgl.xOff, Rc2y-cyo, SctCd, n);
        }
      }
      XCopyArea(dpy, pix, wnd, gc, 0, 0, Ww, Wh, 0, 0);            /* ウィンドウに写す */
      XFlush(dpy);
      XftDrawDestroy(draw);
      XFreePixmap(dpy, pix);                                       /* Pixmapを解放する */
    }
    rd=0; ph=0;
  }                                                                      /* 再描画終り */
}
