/****************************************************************************************
*                   XIM Protocol のXlibインタフェイス                13-07-29月  越川和忠
*  （Hidetoshi Tajima氏によるIMdkitを『き』専用に縮小再構成して得ている）
*
* 書き替えたものを配布する時は、日付、作成者名共、更新者のものに書き替えられたい。
*
* 譜誌
* 00-12-04月 IMdkit/i18n/下の数ファイルを統合して、IMdlib.cとする。
* 01-05-15火 _Xi18nMessageHandler()を少し修正
* 02-08-03土 ReadXIMMessageの出力がNULLの時、それを知らせる標準出力を埋め込む
* 03-09-12金 _XRegisterFilterByTypeと_XUnregisterFilterの対応を調べる
* 03-09-13土 Preedit関連を削除する
* 03-09-28日 modifiersとransportは始めから"Xi18n"と"X/"の定数で与える。
* 03-09-29月 Preedit関連の残りを整理する。
* 03-10-08水 PreeditとExtentionのXIM Messageが来たら、stderrで知らせるようにしておく。
* 03-10-10金 XIM Protocolをstderrに出す指定ができるようにする。
* 04-06-05土 IMdkitの内容を更に厳選して、xkilib.cとして、１つのファイルにまとめる。
* 04-06-20日 『き』に特化しすぎているので、xi18n- を xki- にしておく。
* 04-06-26土 １ファイル化して不要になったstatic宣言を取り除く。
* 04-06-27日 mallocに対する後始末(freeの欠落)を点検する。
* 04-07-09金 mallocが0で返った時の処理は見送り、free()の欠落を直すに止める。
* 04-07-10土 Fedora Core 2を機会にr6imの存在を知り、念のため、該当内容を照合する。
* 04-07-11日 ReadXIMMessageで来たpacketが0だった時の処理をr6imに合わせる。
* 04-07-15木 mallocとfreeの検査用関数を作って置き替え、メモリリークを調べる。
* 04-07-17土 Xlib関数が確保し使用者がfreeする場合はXFreeで区別する。
* 04-07-18日 QueryExtensionMessageProcでext_listは非0の判定をしてfreeする。
* 04-07-22木 XIMS構造体領域を解放する際の下位構造Specとargsのfree欠落を直す。
* 04-07-23金 生成したClientを解放していない部分を調べる。
* 04-07-24土 FrameMgrFreeでfm->itersの鎖を除去する次第を追加する。
* 04-07-25日 該当XIM Protocolが来ないための累積は放置とし、試験的な埋め込みを除去する。
* 04-09-08水 起動時オプションLog2で、XIM Protocolをファイルに記録できるようにする。
* 05-10-09日 Logファイル字列の型を BYTE * でなく、char * にする。
* 05-10-12水 ファイル名に冠せるxki を xim-ki にする(xkilibをxim-kilibのように)。
* 05-10-13木 むしろ、余計な修飾をせず、単に、kiとする。
* 08-06-09月 (CARD16)NULLという書き方が１個所あったのを (CARD16)0 に直す。
* 10-11-14日 Logを書き出すfprintfのWindowの型に(unsigned int)をcastしておく。
* 13-01-31木 Logを書き出す先はコンソール(stderr))だけにする。
* 13-07-29月 当「譜誌」で参考にならない行は削除しておく。
*
* まとめ
*   百相鍵盤『き』をＸに実装するなら、Xlib内 Local IMとして、Compose方式を差し替える形が
* 妥当であるが、簡単ではないので、まず、外付けのＸＩＭとして作り、Ｘのアプリケーションで
* ある程度使えるものにした。
*   IMdkitは、そのままではコンパイルがうまく行かなかったので、外部のライブラリとして利用
* するのは止めて、『き』に必要な基本の機能を抽出した『き』内のライブラリにまとめ、『き』
* の実験・改造を『き』のソースコードがあれば自由にできるようにした。
* 
* Ｘlib ―  仲介lib     ――――    IMサーバー
*             ↓                        
*     IMdkitから抽出して特化          ki.c
*           kilib.c                 kiTalk.c
*           kilib.h
* 
* X/opengroup/unsupported/lib/IMdkitのファイル群と『き』が基にしたファイル
* 
* IMdkit/
*   README
*   Imakefile
*   API.txt
*   IMCore/
*     IMConn.c       ○    ○印を付けた16冊のファイルから、
*     IMMethod.c     ○    『き』に必要な機能を抽出して、
*     IMValues.c     ○    kilib.h および kilib.c として
*     IMdkit.h       ○    再構成する。
*   Xi18n/
*     FrameMgr.c     ○
*     FrameMgr.h     ○
*     i18nIMProto.c  ○
*     Xi18n.h        ○
*     Xi18nX.h       ○
*     XimProto.h     ○
*     i18nAttr.c     ○
*     i18nIC.c       ○
*     i18nMethod.c   ○
*     i18nPtHdr.c    ○
*     i18nUtil.c     ○
*     i18nX.c        ○
*     i18nClbk.c
*     i18nTr.c
*     Xi18nTr.h
*     Xtrans.h
*   Xi18n_sample/
*     sampleIM.c     この枠組みを参考にして独自の ki.cを作る。
*     IC.c
*     IC.h
*     Imakefile
*     README
*   Ximp/(省略)
*   Ximp_sample/(省略)
*
* Transportは、/Xだけ。
* i18nのXIMだけ。
* InputStyleは、XIMPreeditNothing | XIMStatusNothing だけ。
* IMdkitでは重要なPreeditやCallBack、Extensionの機能は、『き』では使わない。
* IMdkitのIMServer用API関数は、次の４関数だけ使う。
* ・IMOpenIM      内容（それに伴い引き数）も変更
* ・IMCloseIM
* ・IMForwardEvent
* ・IMCommitString
* mallocに対応するfreeの欠落をなくした。
*
* しかしながら、
* クライアントから来るXIM Protocol自体に欠落があるので、対応するfreeを実行できないなど、
* 困ることがいろいろあり、また、終了する時期を知る方法がないので、終らせる時は、使用者が
* killで強制終了させる。いずれも、IMサーバー側では根本的な解決はできない。
* ただ、このことは 他のXIMサーバーでも事情は同じと思われる。
* それを承知で使えば、入力操作自体は既に快適なので、プログラムをいじるのはここまでにし、
* 使いながら今後の実装方法を考えることにする。
* ・そもそも、打鍵を扱う機能を、文字列を扱うサーバーの処理に委ねている現行ＩＭの考え方に
*   誤りがある。コンソールデバイスのドライバとして実装されるべき機能であろう。

* 願わくは、ここを読まれた有志が、Xlib内での実装、さらにはデバイスドライバレベルでの実装
* を検討されることを。
****************************************************************************************/
#include <X11/Xmd.h>
#include <X11/Xlib.h>
#include <X11/Xlibint.h>
#include <stdio.h>
#include "kilib.h"

#define COUNTER_MASK 0x10

extern unsigned char Log;                  /* XIM Protocolのログをコンソールに出す時 1 */

typedef enum{                                                         /* Frame型の種類 */
  BIT8     = 0x1,                                                  /* {CARD8* | INT8*} */
  BIT16    = 0x2,                                                /* {CARD16* | INT16*} */
  BIT32    = 0x3,                                                /* {CARD32* | INT32*} */
  BARRAY   = 0x4,                                                       /* int*, void* */
  ITER     = 0x5,                                                              /* int* */
  POINTER  = 0x6,                                                   /* 次項は PTR_ITEM */
  PTR_ITEM = 0x7,                                                    /* ポインタを持つ */
  PADDING  = 0x8,                                        /* データフィールドに埋込む時 */
  EOL      = 0x9,                                                      /* リストの最後 */
  COUNTER_BIT8  = COUNTER_MASK|0x1,
  COUNTER_BIT16 = COUNTER_MASK|0x2,
  COUNTER_BIT32 = COUNTER_MASK|0x3
}XimFrameType;

#define _FRAME(a) {a, NULL}
#define _PTR(p)   {PTR_ITEM, (void *)p}
/* PADDING B15-B8: 有効項目の数、B7-B0: 埋込み単位。例えば 04 で 4 単位埋込みを表す */
#define _PAD2(n)   {PADDING, (void*)((n)<<8|2)}
#define _PAD4(n)   {PADDING, (void*)((n)<<8|4)}
#define FmCounterByte   0
#define FmCounterNumber 1
#define _BYTE_COUNTER(type, offset) \
               {(COUNTER_MASK|type), (void*)((offset)<<8|FmCounterByte)}
#define _NUMBER_COUNTER(type, offset) \
               {(COUNTER_MASK|type), (void*)((offset)<<8|FmCounterNumber)}

typedef struct _XimFrame{
  XimFrameType type;
  void* data;                                                   /* PTR_ITEM、PADDING用 */
}XimFrameRec, *XimFrame;

typedef enum{
  FmSuccess,
  FmEOD,
  FmInvalidCall,
  FmBufExist,
  FmCannotCalc,
  FmNoMoreData
}FmStatus;

typedef struct _FrameMgr *FrameMgr;

XimFrameRec ximattr_fr[] ={
  _FRAME(BIT16),                                                       /* attribute ID */
  _FRAME(BIT16),                                                          /* valueの型 */
  _FRAME(BIT16),                                                 /* im-attributeの長さ */
  _FRAME(BARRAY),                                                      /* im-attribute */
  _PAD4(2),
  _FRAME(EOL),
};

XimFrameRec xicattr_fr[] = {
  _FRAME(BIT16),                                                       /* attribute ID */
  _FRAME(BIT16),                                                  /* type of the value */
  _FRAME(BIT16),                                             /* length of ic-attribute */
  _FRAME(BARRAY),                                                      /* ic-attribute */
  _PAD4(2),
  _FRAME(EOL),
};

XimFrameRec ximattribute_fr[] = {
  _FRAME(BIT16),                                                       /* attribute ID */
  _FRAME(BIT16),                                                       /* value length */
  _FRAME(BARRAY),                                                             /* value */
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec xicattribute_fr[] = {
  _FRAME(BIT16),                                                       /* attribute ID */
  _FRAME(BIT16),                                                       /* value length */
  _FRAME(BARRAY),                                                             /* value */
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec encodinginfo_fr[] = {
  _FRAME(BIT16),                                            /* length of encoding info */
  _FRAME(BARRAY),                                                     /* encoding info */
  _PAD4(2),
  _FRAME(EOL),
};

XimFrameRec str_fr[] = {
  _FRAME(BIT8),                                                      /* number of byte */
  _FRAME(BARRAY),                                                            /* string */
  _FRAME(EOL),
};

XimFrameRec xpcs_fr[] = {
  _FRAME(BIT16),                                          /* length of string in bytes */
  _FRAME(BARRAY),                                                            /* string */
  _PAD4(2),
};

XimFrameRec ext_fr[] = {
  _FRAME(BIT16),                                             /* extension major-opcode */
  _FRAME(BIT16),                                             /* extension minor-opcode */
  _FRAME(BIT16),                                           /* length of extension name */
  _FRAME(BARRAY),                                                    /* extension name */
  _PAD4(2),
  _FRAME(EOL),
};

XimFrameRec inputstyle_fr[] = {
  _FRAME(BIT32),                                                         /* inputstyle */
  _FRAME(EOL),
};

XimFrameRec attr_head_fr[] = {                                  /* Protocol definition */
  _FRAME(BIT16),                                                       /* attribute id */
  _FRAME(BIT16),                                                   /* attribute length */
  _FRAME(EOL),
};

XimFrameRec input_styles_fr[] = {
  _FRAME(BIT16),                                                     /* number of list */
  _PAD4(1),                                                                  /* unused */
  _FRAME(ITER),                                                       /* XIMStyle list */
  _FRAME(POINTER),
  _PTR(inputstyle_fr),
  _FRAME(EOL),
};

XimFrameRec packet_header_fr[] = {
  _FRAME(BIT8),                                                        /* major-opcode */
  _FRAME(BIT8),                                                        /* minor-opcode */
  _FRAME(BIT16),                                                             /* length */
  _FRAME(EOL),
};

XimFrameRec connect_fr[] = {
  _FRAME(BIT8),                                                          /* byte order */
  _PAD2(1),                                                                  /* unused */
  _FRAME(BIT16),                                      /* client-major-protocol-version */
  _FRAME(BIT16),                                      /* client-minor-protocol-version */
  _BYTE_COUNTER(BIT16, 1),                     /* length of client-auth-protocol-names */
  _FRAME(ITER),                                          /* client-auth-protocol-names */
  _FRAME(POINTER),
  _PTR(xpcs_fr),
  _FRAME(EOL),
};

XimFrameRec connect_reply_fr[] = {
  _FRAME(BIT16),                                      /* server-major-protocol-version */
  _FRAME(BIT16),                                      /* server-minor-protocol-version */
  _FRAME(EOL),
};

XimFrameRec open_fr[] = {
  _FRAME(POINTER),                                                      /* locale name */
  _PTR(str_fr),
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec open_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),                   /* byte length of IM attributes supported */
  _FRAME(ITER),                                              /* IM attribute supported */
  _FRAME(POINTER),
  _PTR(ximattr_fr),
  _BYTE_COUNTER(BIT16, 2),                         /* number of IC attribute supported */
  _PAD4(1),                                                                  /* unused */
  _FRAME(ITER),                                              /* IC attribute supported */
  _FRAME(POINTER),
  _PTR(xicattr_fr),
  _FRAME(EOL),
};

XimFrameRec close_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _PAD4(1),                                                                  /* unused */
  _FRAME(EOL),
};

XimFrameRec close_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _PAD4(1),                                                                  /* unused */
  _FRAME(EOL),
};

XimFrameRec set_event_mask_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(BIT32),                                                 /* forward-event-mask */
  _FRAME(BIT32),                                             /* synchronous-event-mask */
  _FRAME(EOL),
};

XimFrameRec encoding_negotiation_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),                  /* byte length of encodings listed by name */
  _FRAME(ITER),                            /* supported list of encoding in IM library */
  _FRAME(POINTER),
  _PTR(str_fr),
  _PAD4(1),
  _BYTE_COUNTER(BIT16, 2),         /* byte length of encodings listed by detailed data */
  _PAD4(1),
  _FRAME(ITER),                       /* list of encodings supported in the IM library */
  _FRAME(POINTER),
  _PTR(encodinginfo_fr),
  _FRAME(EOL),
};

XimFrameRec encoding_negotiation_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                /* category of the encoding determined */
  _FRAME(BIT16),                                  /* index of the encoding dterminated */
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec query_extension_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),    /* byte length of extensions supported by the IM library */
  _FRAME(ITER),                              /* extensions supported by the IM library */
  _FRAME(POINTER),
  _PTR(str_fr),
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec query_extension_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),     /* byte length of extensions supported by the IM server */
  _FRAME(ITER),                       /* list of extensions supported by the IM server */
  _FRAME(POINTER),
  _PTR(ext_fr),
  _FRAME(EOL),
};

XimFrameRec get_im_values_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),                           /* byte length of im-attribute-id */
  _FRAME(ITER),                                                     /* im-attribute-id */
  _FRAME(BIT16),
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec get_im_values_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),                     /* byte length of im-attribute returned */
  _FRAME(ITER),                                               /* im-attribute returned */
  _FRAME(POINTER),
  _PTR(ximattribute_fr),
  _FRAME(EOL),
};

XimFrameRec create_ic_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _BYTE_COUNTER(BIT16, 1),                             /* byte length of ic-attributes */
  _FRAME(ITER),                                                       /* ic-attributes */
  _FRAME(POINTER),
  _PTR(xicattribute_fr),
  _FRAME(EOL),
};

XimFrameRec create_ic_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec destroy_ic_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec destroy_ic_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec set_ic_values_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _BYTE_COUNTER(BIT16, 2),                             /* byte length of ic-attributes */
  _PAD4(1),
  _FRAME(ITER),                                                        /* ic-attribute */
  _FRAME(POINTER),
  _PTR(xicattribute_fr),
  _FRAME(EOL),
};

XimFrameRec set_ic_values_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec get_ic_values_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _BYTE_COUNTER(BIT16, 1),                           /* byte length of ic-attribute-id */
  _FRAME(ITER),                                                        /* ic-attribute */
  _FRAME(BIT16),
  _PAD4(2),
  _FRAME(EOL),
};

XimFrameRec get_ic_values_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _BYTE_COUNTER(BIT16, 2),                              /* byte length of ic-attribute */
  _PAD4(1),
  _FRAME(ITER),                                                        /* ic-attribute */
  _FRAME(POINTER),
  _PTR(xicattribute_fr),
  _FRAME(EOL),
};

XimFrameRec set_ic_focus_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec unset_ic_focus_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec forward_event_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(BIT16),                                                               /* flag */
  _FRAME(BIT16),                                                    /* sequence number */
  _FRAME(EOL),
};

XimFrameRec sync_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec commit_chars_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(BIT16),                                                               /* flag */
  _FRAME(BIT16),                                    /* byte length of committed string */
  _FRAME(BARRAY),                                                  /* committed string */
  _PAD4(1),
  _FRAME(EOL),
};

XimFrameRec commit_both_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(BIT16),                                                               /* flag */
  _PAD4(1),                                                                  /* unused */
  _FRAME(BIT32),                                                             /* keysym */
  _FRAME(BIT16),                                    /* byte length of committed string */
  _FRAME(BARRAY),                                                  /* committed string */
  _PAD4(2),
  _FRAME(EOL),
};

XimFrameRec reset_ic_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(EOL),
};

XimFrameRec reset_ic_reply_fr[] = {
  _FRAME(BIT16),                                                    /* input-method-ID */
  _FRAME(BIT16),                                                   /* input-context-ID */
  _FRAME(BIT16),                                    /* byte length of committed string */
  _FRAME(BARRAY),                                                  /* committed string */
  _PAD4(2),
  _FRAME(EOL),
};

typedef struct _Iter *Iter;

typedef struct _FrameInst *FrameInst;

typedef union {
  int num;                                                               /* For BARRAY */
  FrameInst fi;                                                         /* For POINTER */
  Iter iter;                                                               /* For ITER */
} ExtraDataRec, *ExtraData;

typedef struct _Chain {
  ExtraDataRec d;
  int frame_no;
  struct _Chain *next;
} ChainRec, *Chain;

typedef struct _ChainMgr {
  Chain top;
  Chain tail;
} ChainMgrRec, *ChainMgr;

typedef struct _ChainIter {
  Chain cur;
} ChainIterRec, *ChainIter;

typedef struct _FrameIter {
  Iter iter;
  Bool counting;
  unsigned int counter;
  int end;
  struct _FrameIter* next;
} FrameIterRec, *FrameIter;

typedef struct _FrameInst {
  XimFrame template;
  ChainMgrRec cm;
  int cur_no;
} FrameInstRec;

typedef void  (*IterStartWatchProc)(Iter it, void* client_data);

typedef struct _Iter {
  XimFrame template;
  int max_count;
  Bool allow_expansion;
  ChainMgrRec cm;
  int cur_no;
  IterStartWatchProc start_watch_proc;
  void* client_data;
  Bool start_counter;
} IterRec;

typedef struct _FrameMgr {
  XimFrame frame;
  FrameInst fi;
  char* area;
  int idx;
  Bool byte_swap;
  int total_size;
  FrameIter iters;
} FrameMgrRec;

typedef union {
  int num;                                                       /* For BARRAY and PAD */
  struct {                                                            /* For COUNTER_* */
    Iter iter;        
    Bool is_byte_len;
  } counter;
} XimFrameTypeInfoRec, *XimFrameTypeInfo;

#define NO_VALUE -1
#define NO_VALID_FIELD -2

XimFrameType FrameInstGetNextType(FrameInst fi, XimFrameTypeInfo info);
XimFrameType FrameInstPeekNextType(FrameInst fi, XimFrameTypeInfo info);
void IterFree(Iter it);
FmStatus IterSetSize(Iter it, int num);
FmStatus IterSetIterCount(Iter it, int num);
int IterGetTotalSize(Iter it);
void IterReset(Iter it);
Bool IterIsLoopEnd(Iter it, Bool* myself);
Bool FrameInstIsIterLoopEnd(FrameInst fi);
FmStatus FrameInstSetSize(FrameInst fi, int num);

#define IterGetIterCount(it) ((it)->allow_expansion ? NO_VALUE : (it)->max_count)
#define IterFixIteration(it) ((it)->allow_expansion = False)
#define ChainMgrInit(cm) (cm)->top = (cm)->tail = NULL
#define ChainMgrFree(cm) {\
  Chain tmp, cur = (cm)->top;\
  while (cur){tmp = cur->next; free(cur); cur = tmp;}\
}
#define ChainIterInit(ci, cm) {(ci)->cur = (cm)->top;}
#define FrameInstIsEnd(fi) ((fi)->template[(fi)->cur_no].type == EOL)

Iter IterInit(XimFrame frame, int count){
  Iter it;
  register XimFrameType type;

  it = (Iter)malloc(sizeof(IterRec));
  it->template = frame;
  it->max_count = (count == NO_VALUE) ? 0 : count;
  it->allow_expansion = count == NO_VALUE;
  it->cur_no = 0;
  it->start_watch_proc = NULL;
  it->client_data = NULL;
  it->start_counter = False;
  type = frame->type;
  if(type & COUNTER_MASK){                  /* COUNTER_XXX であれば ITERの項目ではない */
    free(it);
    return NULL;
  }
  if(type == BIT8 || type == BIT16 || type == BIT32);                    /* 何もしない */
  else if(type == BARRAY || type == ITER || type == POINTER) ChainMgrInit(&it->cm);
  else {free(it); return NULL;}                                      /* ここには来ない */
  return it;
}

int _FrameInstIncrement(XimFrame frame, int count){
  XimFrameType type;
  type = frame[count].type;
  type &= ~COUNTER_MASK;
  switch(type){
    case BIT8:
    case BIT16:
    case BIT32:
    case BARRAY:
    case PADDING:
      return count + 1;
      break;
    case POINTER:
      return count + 2;
      break;
    case ITER:
      return _FrameInstIncrement(frame, count + 1);
      break;
    default:
      break;
  }
  return -1;                                                                  /* Error */
}

int _FrameInstDecrement(XimFrame frame, int count){
  register int i;
  XimFrameType type;

  if     (count == 0) return -1;                                             /* 既に 0 */
  else if(count == 1) return 0;                        /* カウンタ内容を調べる必要あり */
  type = frame[count - 2].type;
  type &= ~COUNTER_MASK;
  switch(type){
    case BIT8:
    case BIT16:
    case BIT32:
    case BARRAY:
    case PADDING:
    case PTR_ITEM:
      return count - 1;
      break;
    case POINTER:
    case ITER:
      i = count - 3;
      while(i >= 0){
        if (frame[i].type != ITER) return i + 1;
        i--;
      }
      return 0;
    default:
      break;
  }
  return -1;                                                                  /* Error */
}

Bool ChainIterGetNext(ChainIter ci, int* frame_no, ExtraData d){
  if (ci->cur == NULL) return False;
  *frame_no = ci->cur->frame_no;
  *d = ci->cur->d;
  ci->cur = ci->cur->next;
  return True;
}

void FrameInstFree(FrameInst fi){
  ChainIterRec ci;
  int frame_no;
  ExtraDataRec d;

  ChainIterInit(&ci, &fi->cm);
  while(ChainIterGetNext(&ci, &frame_no, &d)){
    register XimFrameType type;
    type = fi->template[frame_no].type;
    if(type == ITER){
      if(d.iter) IterFree(d.iter);
    }else if(type == POINTER){
      if (d.fi) FrameInstFree(d.fi);
    }
  }
  ChainMgrFree(&fi->cm);
  free(fi);
}

void IterFree(Iter it){
  if(it->template->type == BARRAY){
    ChainMgrFree(&it->cm);
  }else if(it->template->type == ITER){
    ChainIterRec ci;
    int count;
    ExtraDataRec d;

    ChainIterInit(&ci, &it->cm);
    while(ChainIterGetNext(&ci, &count, &d)) IterFree(d.iter);
    ChainMgrFree(&it->cm);
  }else if(it->template->type == POINTER){
    ChainIterRec ci;
    int count;
    ExtraDataRec dr;

    ChainIterInit(&ci, &it->cm);
    while(ChainIterGetNext(&ci, &count, &dr)) FrameInstFree(dr.fi);
    ChainMgrFree(&it->cm);
  }
  free(it);
}

FrameInst FrameInstInit(XimFrame frame){
  FrameInst fi;
  register int i;

  fi= (FrameInst)malloc(sizeof(FrameInstRec));
  fi->template = frame;
  fi->cur_no = 0;
  ChainMgrInit(&fi->cm);
  return fi;
}

FrameMgr FrameMgrInit(XimFrame frame, char* area, Bool byte_swap){
  FrameMgr fm;

  fm = (FrameMgr)malloc(sizeof(FrameMgrRec));
  fm->frame = frame;
  fm->fi = FrameInstInit(frame);
  fm->area = (char *)area;
  fm->idx = 0;
  fm->byte_swap = byte_swap;
  fm->total_size = NO_VALUE;
  fm->iters = NULL;
  return fm;
}

void _FrameMgrRemoveIter(FrameMgr fm, FrameIter it){
  FrameIter prev, p;
  prev = NULL;
  p = fm->iters;
  while(p){
    if(p == it){
      if(prev) prev->next = p->next;
      else      fm->iters = p->next;
      free(p);
      break;
    }else{
      prev = p;
      p = p->next;
    }
  }
}

void FrameMgrFree(FrameMgr fm){
  FrameIter p, next;
  for(p=fm->iters; p; p=next){next=p->next; _FrameMgrRemoveIter(fm, p);}
  FrameInstFree(fm->fi);
  free(fm);
}

FmStatus FrameMgrSetBuffer(FrameMgr fm, void* area){
  if (fm->area) return FmBufExist;
  fm->area = (char *)area;
  return FmSuccess;
}

ExtraData ChainMgrGetExtraData(ChainMgr cm, int frame_no){
  Chain cur;
  cur = cm->top;
  while(cur){
    if(cur->frame_no == frame_no) return &cur->d;
    cur = cur->next;
  }
  return NULL;
}

ExtraData ChainMgrSetData(ChainMgr cm, int frame_no, ExtraDataRec data){
  Chain cur = (Chain)malloc(sizeof(ChainRec));
  cur->frame_no = frame_no;
  cur->d = data;
  cur->next = NULL;
  if(cm->top == NULL) cm->top = cm->tail = cur;
  else               {cm->tail->next = cur; cm->tail = cur;}
  return &cur->d;
}

XimFrameType IterGetNextType(Iter it, XimFrameTypeInfo info){
  XimFrameType type = it->template->type;
  if(it->start_counter){
    (*it->start_watch_proc)(it, it->client_data);
    it->start_counter = False;
  }
  if(it->cur_no >= it->max_count){
    if(it->allow_expansion){
      it->max_count = it->cur_no + 1;
    }else{
      return EOL;
    }
  }
  if(type == BIT8 || type == BIT16 || type == BIT32){
    it->cur_no++;
    return type;
  }else if(type == BARRAY){
    ExtraData d;
    ExtraDataRec dr;

    if(info){
      if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL) info->num = NO_VALUE;
      else                                                        info->num = d->num;
    }
    it->cur_no++;
    return BARRAY;
  }else if(type == ITER){
    XimFrameType ret_type;
    ExtraData d;
    ExtraDataRec dr;

    if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL){
      dr.iter = IterInit(it->template + 1, NO_VALUE);
      d = ChainMgrSetData(&it->cm, it->cur_no, dr);
    }
    ret_type = IterGetNextType(d->iter, info);
    if(ret_type == EOL){
      it->cur_no++;
      ret_type = IterGetNextType(it, info);
    }
    return ret_type;
  }else if(type == POINTER){
    XimFrameType ret_type;
    ExtraData d;
    ExtraDataRec dr;

    if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL){
      dr.fi = FrameInstInit(it->template[1].data);
      d = ChainMgrSetData(&it->cm, it->cur_no, dr);
    }
    ret_type = FrameInstGetNextType(d->fi, info);
    if(ret_type == EOL){
      it->cur_no++;
      ret_type = IterGetNextType(it, info);
    }
    return ret_type;
  }else{
    ;                                                                /* ここには来ない */
  }
}

#define _UNIT(n)   ((int)(n) & 0xff)
#define _NUMBER(n) (((int)(n) >> 8) & 0xff)
#define Swap16(p, n) ((p)->byte_swap ? (((n) << 8 & 0xff00) | ((n) >> 8 & 0xff)) : n)
#define Swap32(p, n) ((p)->byte_swap ? (((n) << 24 & 0xff000000) | \
((n) <<  8 & 0xff0000) | ((n) >>  8 & 0xff00) | ((n) >> 24 & 0xff)) : n)

int _FrameInstGetItemSize(FrameInst fi, int cur_no){
  XimFrameType type;

  type = fi->template[cur_no].type;
  type &= ~COUNTER_MASK;
  switch(type){
    case BIT8 :
      return 1;
      break;
    case BIT16 :
      return 2;
      break;
    case BIT32 :
      return 4;
      break;
    case BARRAY :
      {
        ExtraData d;
        if((d = ChainMgrGetExtraData(&fi->cm, cur_no)) == NULL) return NO_VALUE;
        if(d->num == NO_VALUE) return NO_VALUE;
        return d->num;
      }
      break;
    case PADDING :
      {
        register int unit, number, size, i;
        unit   = _UNIT(fi->template[cur_no].data);
        number = _NUMBER(fi->template[cur_no].data);
        i = cur_no;
        size = 0;
        while(number > 0){
          i = _FrameInstDecrement(fi->template, i);
          size += _FrameInstGetItemSize(fi, i);
          number--;
        }
        size = (unit - (size % unit)) % unit;
        return size;
      }
      break;
    case ITER :
      {
        ExtraData d;
        int sub_size;
        if((d = ChainMgrGetExtraData(&fi->cm, cur_no)) == NULL) return NO_VALUE;
        sub_size = IterGetTotalSize(d->iter);
        if(sub_size == NO_VALUE) return NO_VALUE;
        return sub_size;
      }
      break;
    case POINTER :
      {
        ExtraData d;
        int sub_size;
        if((d = ChainMgrGetExtraData(&fi->cm, cur_no)) == NULL) return NO_VALUE;
        sub_size = FrameInstGetTotalSize(d->fi);
        if(sub_size == NO_VALUE) return NO_VALUE;
        return sub_size;
      }
      break;
    default :
      break;
  }
  return NO_VALUE;
}
int FrameInstGetTotalSize(FrameInst fi){
  register int size, i;

  size = 0;
     i = 0;
  while(fi->template[i].type != EOL){
    size += _FrameInstGetItemSize(fi, i);
    i = _FrameInstIncrement(fi->template, i);
  }
  return size;
}

XimFrameType FrameInstGetNextType(FrameInst fi, XimFrameTypeInfo info){
  XimFrameType ret_type;

  ret_type = fi->template[fi->cur_no].type;
  switch(ret_type){
    case BIT8 :
    case BIT16 :
    case BIT32 :
    case EOL :
      fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
      break;
    case COUNTER_BIT8 :
    case COUNTER_BIT16 :
    case COUNTER_BIT32 :
      if(info){
        register int offset, iter_idx;

        info->counter.is_byte_len = 
          ((int)fi->template[fi->cur_no].data & 0xff) == FmCounterByte;
        offset = (int)fi->template[fi->cur_no].data >> 8;
        iter_idx = fi->cur_no + offset;
        if(fi->template[iter_idx].type == ITER){
          ExtraData d;
          ExtraDataRec dr;

          if((d = ChainMgrGetExtraData(&fi->cm, iter_idx)) == NULL){
            dr.iter = IterInit(&fi->template[iter_idx + 1], NO_VALUE);
            d = ChainMgrSetData(&fi->cm, iter_idx, dr);
          }
          info->counter.iter = d->iter;
        }else{
          ;                                                          /* ここには来ない */
        }
      }
      fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
      break;
    case BARRAY :
      if(info){
        ExtraData d;
        if((d = ChainMgrGetExtraData(&fi->cm, fi->cur_no)) == NULL) info->num = NO_VALUE;
        else                                                        info->num = d->num;
      }
      fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
      break;
    case PADDING :
      if(info){
        register int unit, number, size, i;

        unit = _UNIT(fi->template[fi->cur_no].data);
        number = _NUMBER(fi->template[fi->cur_no].data);
        i = fi->cur_no;
        size = 0;
        while(number > 0){
          i = _FrameInstDecrement(fi->template, i);
          size += _FrameInstGetItemSize(fi, i);
          number--;
        }
        info->num = (unit - (size % unit)) % unit;
      }
      fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
      break;
    case ITER :
      {
        ExtraData d;
        ExtraDataRec dr;
        XimFrameType sub_type;

        if((d = ChainMgrGetExtraData(&fi->cm, fi->cur_no)) == NULL){
          dr.iter = IterInit(&fi->template[fi->cur_no + 1], NO_VALUE);
          d = ChainMgrSetData(&fi->cm, fi->cur_no, dr);
        }
        sub_type = IterGetNextType(d->iter, info);
        if(sub_type == EOL){
          fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
          ret_type = FrameInstGetNextType(fi, info);
        }else{
          ret_type = sub_type;
        }
      }
      break;
    case POINTER :
      {
        ExtraData d;
        ExtraDataRec dr;
        XimFrameType sub_type;

        if((d = ChainMgrGetExtraData(&fi->cm, fi->cur_no)) == NULL){
          dr.fi = FrameInstInit(fi->template[fi->cur_no + 1].data);
          d = ChainMgrSetData(&fi->cm, fi->cur_no, dr);
        }
        sub_type = FrameInstGetNextType(d->fi, info);
        if(sub_type == EOL){
          fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
          ret_type = FrameInstGetNextType(fi, info);
        }else{
          ret_type = sub_type;
        }
      }
      break;
    default :
      break;                                                         /* ここには来ない */
  }
  return ret_type;
}

FmStatus _FrameMgrPutToken(FrameMgr fm, void* data, int data_size){
  XimFrameType type;
  XimFrameTypeInfoRec info;

  if (fm->total_size != NO_VALUE && fm->idx >= fm->total_size) return FmNoMoreData;
  type = FrameInstGetNextType(fm->fi, &info);
  if(type & COUNTER_MASK){
    unsigned long input_length;

    if(info.counter.is_byte_len){
      if((input_length = IterGetTotalSize(info.counter.iter))== NO_VALUE){
        return FmCannotCalc;
      }
    }else{
      if((input_length = IterGetIterCount(info.counter.iter))== NO_VALUE){
        return FmCannotCalc;
      }
    }
    if(type == COUNTER_BIT8){
      *(CARD8*)(fm->area + fm->idx) = input_length;
      fm->idx++;
    }else if(type == COUNTER_BIT16){
      *(CARD16*)(fm->area + fm->idx) = Swap16(fm, input_length);
      fm->idx += 2;
    }else if(type == COUNTER_BIT32){
      *(CARD32*)(fm->area + fm->idx) = Swap32(fm, input_length);
      fm->idx += 4;
    }
    _FrameMgrPutToken(fm, data, data_size);
    return FmSuccess;
  }
  if(type == BIT8){
    if(data_size == sizeof(unsigned char)){
      unsigned long num = *(unsigned char*)data;
      *(CARD8*)(fm->area + fm->idx) = num;
    }else if(data_size == sizeof(unsigned short)){
      unsigned long num = *(unsigned short*)data;
      *(CARD8*)(fm->area + fm->idx) = num;
    }else if(data_size == sizeof(unsigned int)){
      unsigned long num = *(unsigned int*)data;
      *(CARD8*)(fm->area + fm->idx) = num;
    }else if(data_size == sizeof(unsigned long)){
      unsigned long num = *(unsigned long*)data;
      *(CARD8*)(fm->area + fm->idx) = num;
    }else{
      ;                                                              /* ここには来ない */
    }
    fm->idx++;
    return FmSuccess;
  }else if(type == BIT16){
    if(data_size == sizeof(unsigned char)){
      unsigned long num = *(unsigned char*)data;
      *(CARD16*)(fm->area + fm->idx) = Swap16(fm, num);
    }else if(data_size == sizeof(unsigned short)){
      unsigned long num = *(unsigned short*)data;
      *(CARD16*)(fm->area + fm->idx) = Swap16(fm, num);
    }else if(data_size == sizeof(unsigned int)){
      unsigned long num = *(unsigned int*)data;
      *(CARD16*)(fm->area + fm->idx) = Swap16(fm, num);
    }else if(data_size == sizeof(unsigned long)){
      unsigned long num = *(unsigned long*)data;
      *(CARD16*)(fm->area + fm->idx) = Swap16(fm, num);
    }else{
      ;                                                              /* ここには来ない */
    }
    fm->idx += 2;
    return FmSuccess;
  }else if(type == BIT32){
    if (data_size == sizeof(unsigned char)){
      unsigned long num = *(unsigned char*)data;
      *(CARD32*)(fm->area + fm->idx) = Swap32(fm, num);
    }else if(data_size == sizeof(unsigned short)){
      unsigned long num = *(unsigned short*)data;
      *(CARD32*)(fm->area + fm->idx) = Swap32(fm, num);
    }else if(data_size == sizeof(unsigned int)){
      unsigned long num = *(unsigned int*)data;
      *(CARD32*)(fm->area + fm->idx) = Swap32(fm, num);
    }else if(data_size == sizeof(unsigned long)){
      unsigned long num = *(unsigned long*)data;
      *(CARD32*)(fm->area + fm->idx) = Swap32(fm, num);
    }else{
      ;                                                              /* ここには来ない */
    }
    fm->idx += 4;
    return FmSuccess;
  }else if(type == BARRAY && info.num != NO_VALUE){
    if(info.num > 0){
      bcopy(*(char**)data, fm->area + fm->idx, info.num);
      fm->idx += info.num;
    }
    return FmSuccess;
  }else if(type == BARRAY && info.num == NO_VALUE){
    return FmInvalidCall;
  }else if(type == PADDING && info.num != NO_VALUE){
    fm->idx += info.num;
    return _FrameMgrPutToken(fm, data, data_size);
  }else if(type == PADDING && info.num == NO_VALUE){
    return FmInvalidCall;
  }else if(type == ITER){
    return FmInvalidCall;
  }else if(type == EOL){
    return FmEOD;
  }else{
    ;                                                                /* ここには来ない */
  }
}

void _IterStartWatch(Iter it, void* client_data){
  FrameIter p = (FrameIter)client_data;
  p->counting = True;
}

FrameIter _FrameMgrAppendIter(FrameMgr fm, Iter it, int end){
  FrameIter p = fm->iters;

  while(p && p->next) p = p->next;
  if(!p){                                                                  /* 鎖の先頭 */
    fm->iters = p = (FrameIter)malloc(sizeof(FrameIterRec));
  }else{                                                                   /* 鎖の最後 */
    p->next = (FrameIter)malloc(sizeof(FrameIterRec));
    p = p->next;
  }
  if(p){
    p->iter    = it;
    p->counting= False;
    p->counter = 0;
    p->end     = end;
    p->next    = NULL;
  }
  return(p);
}

FrameIter _FrameIterCounterIncr(FrameIter fitr, int i){
  FrameIter p = fitr;
  while(p){
    if(p->counting){
      p->counter += i;
      if(p->counter >= p->end){
        IterFixIteration(p->iter);
        return(p);
      }
    }
    p = p->next;
  }
  return(NULL);
}

FmStatus _FrameMgrGetToken(FrameMgr fm , void* data, int data_size){
  XimFrameType type;
  static XimFrameTypeInfoRec info;                                           /* memory */
  ExtraData d;
  FrameIter fitr;

  if(fm->total_size != NO_VALUE && fm->idx >= fm->total_size) return FmNoMoreData;
  type = FrameInstGetNextType(fm->fi, &info);
  if(type & COUNTER_MASK){
    int end;
    FrameIter client_data;

    type &= ~COUNTER_MASK;
    if     (type == BIT8)  end = *(CARD8*)(fm->area + fm->idx);
    else if(type == BIT16) end = Swap16(fm, *(CARD16*)(fm->area + fm->idx));
    else if(type == BIT32) end = Swap32(fm, *(CARD32*)(fm->area + fm->idx));
    if(client_data = _FrameMgrAppendIter(fm, info.counter.iter, end)){
      info.counter.iter->start_counter = True;
      info.counter.iter->start_watch_proc = _IterStartWatch;
      info.counter.iter->client_data = client_data;
    }
  }
  type &= ~COUNTER_MASK;
  if(type == BIT8){
    if(data_size == sizeof(unsigned char)){
      *(unsigned char*)data = *(CARD8*)(fm->area + fm->idx);
    }else if(data_size == sizeof(unsigned short)){
      *(unsigned short*)data = *(CARD8*)(fm->area + fm->idx);
    }else if(data_size == sizeof(unsigned int)){
      *(unsigned int*)data = *(CARD8*)(fm->area + fm->idx);
    }else if(data_size == sizeof(unsigned long)){
      *(unsigned long*)data = *(CARD8*)(fm->area + fm->idx);
    }else{
      ;                                                              /* ここには来ない */
    }
    fm->idx++;
    if(fitr = _FrameIterCounterIncr(fm->iters, 1)) _FrameMgrRemoveIter(fm, fitr);
    return FmSuccess;
  }else if(type == BIT16){
    if(data_size == sizeof(unsigned char)){
      *(unsigned char*)data = Swap16(fm, *(CARD16*)(fm->area + fm->idx));
    }else if(data_size == sizeof(unsigned short)){
      *(unsigned short*)data = Swap16(fm, *(CARD16*)(fm->area + fm->idx));
    }else if(data_size == sizeof(unsigned int)){
      *(unsigned int*)data = Swap16(fm, *(CARD16*)(fm->area + fm->idx));
    }else if(data_size == sizeof(unsigned long)){
      *(unsigned long*)data = Swap16(fm, *(CARD16*)(fm->area + fm->idx));
    }else{
      ;                                                              /* ここには来ない */
    }
    fm->idx += 2;
    if(fitr = _FrameIterCounterIncr(fm->iters, 2)) _FrameMgrRemoveIter(fm, fitr);
    return FmSuccess;
  }else if(type == BIT32){
    if(data_size == sizeof(unsigned char)){
      *(unsigned char*)data = Swap32(fm, *(CARD32*)(fm->area + fm->idx));
    }else if(data_size == sizeof(unsigned short)){
      *(unsigned short*)data = Swap32(fm, *(CARD32*)(fm->area + fm->idx));
    }else if(data_size == sizeof(unsigned int)){
      *(unsigned int*)data = Swap32(fm, *(CARD32*)(fm->area + fm->idx));
    }else if(data_size == sizeof(unsigned long)){
      *(unsigned long*)data = Swap32(fm, *(CARD32*)(fm->area + fm->idx));
    }else{
      ;                                                              /* ここには来ない */
    }
    fm->idx += 4;
    if(fitr = _FrameIterCounterIncr(fm->iters, 4)) _FrameMgrRemoveIter(fm, fitr);
    return FmSuccess;
  }else if(type == BARRAY && info.num != NO_VALUE){
    if(info.num > 0){
      *(char**)data = fm->area + fm->idx;
      fm->idx += info.num;
      if(fitr=_FrameIterCounterIncr(fm->iters, info.num)) _FrameMgrRemoveIter(fm, fitr);
    }else{
      *(char**)data = NULL;
    }
    return FmSuccess;
  }else if(type == BARRAY && info.num == NO_VALUE){
    return FmInvalidCall;
  }else if(type == PADDING && info.num != NO_VALUE){
    fm->idx += info.num;
    if(fitr = _FrameIterCounterIncr(fm->iters, info.num)) _FrameMgrRemoveIter(fm, fitr);
    return _FrameMgrGetToken(fm, data, data_size);
  }else if(type == PADDING && info.num == NO_VALUE){
    return FmInvalidCall;
  }else if(type == ITER){
    return FmInvalidCall;                                           /* ここには来ない! */
  }else if(type == EOL){
    return FmEOD;
  }else{
    ;                                                                /* ここには来ない */
  }
}

FmStatus FrameInstSetSize(FrameInst fi, int num){
  ChainIterRec ci;
  ExtraData d;
  ExtraDataRec dr;
  XimFrameType type;
  register int i;

  i = 0;
  while((type = fi->template[i].type) != EOL){
    if(type == BARRAY){
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.num = -1;
        d = ChainMgrSetData(&fi->cm, i, dr);
      }
      if(d->num == NO_VALUE){
        d->num = num;
        return FmSuccess;
      }
    }else if(type == ITER){
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.iter = IterInit(&fi->template[i + 1], NO_VALUE);
        d = ChainMgrSetData(&fi->cm, i, dr);
      }
      if(IterSetSize(d->iter, num) == FmSuccess) return FmSuccess;
    }else if(type == POINTER){
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.fi = FrameInstInit(fi->template[i + 1].data);
        d = ChainMgrSetData(&fi->cm, i, dr);
      }
      if(FrameInstSetSize(d->fi, num) == FmSuccess) return FmSuccess;
    }
    i = _FrameInstIncrement(fi->template, i);
  }
  return FmNoMoreData;
}

FmStatus IterSetSize(Iter it, int num){
  XimFrameType type;
  register int i;

  if(!it->allow_expansion && it->max_count == 0) return FmNoMoreData;
  type = it->template->type;
  if(type == BARRAY){
    ExtraData d;
    ExtraDataRec dr;
    for(i = 0; i < it->max_count; i++){
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.num = NO_VALUE;
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      if(d->num == NO_VALUE){
        d->num = num;
        return FmSuccess;
      }
    }
    if(it->allow_expansion){
      ExtraDataRec dr;
      dr.num = num;
      (void)ChainMgrSetData(&it->cm, it->max_count, dr);
      it->max_count++;
      return FmSuccess;
    }
    return FmNoMoreData;
  }else if(type == ITER){
    ExtraData d;
    ExtraDataRec dr;
    for(i = 0; i < it->max_count; i++){
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.iter = IterInit(it->template + 1, NO_VALUE);
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      if(IterSetSize(d->iter, num) == FmSuccess) return FmSuccess;
    }
    if(it->allow_expansion){
      ExtraDataRec dr;
      dr.iter = IterInit(it->template + 1, NO_VALUE);
      (void)ChainMgrSetData(&it->cm, it->max_count, dr);
      it->max_count++;
      if (IterSetSize(dr.iter, num) == FmSuccess) return FmSuccess;
    }
    return FmNoMoreData;
  }else if(type == POINTER){
    ExtraData d;
    ExtraDataRec dr;
    for(i = 0; i < it->max_count; i++){
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.fi = FrameInstInit(it->template[1].data);
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      if(FrameInstSetSize(d->fi, num) == FmSuccess) return FmSuccess;
    }
    if(it->allow_expansion){
      ExtraDataRec dr;
      dr.fi = FrameInstInit(it->template[1].data);
      (void)ChainMgrSetData(&it->cm, it->max_count, dr);
      it->max_count++;
      if(FrameInstSetSize(dr.fi, num) == FmSuccess) return FmSuccess;
    }
    return FmNoMoreData;
  }
  return FmNoMoreData;
}

FmStatus FrameMgrSetSize(FrameMgr fm, int barray_size){
  if(FrameInstSetSize(fm->fi, barray_size) == FmSuccess) return FmSuccess;
  else                                                   return FmNoMoreData;
}

FmStatus FrameInstSetIterCount(FrameInst fi, int num){
  ChainIterRec ci;
  ExtraData d;
  ExtraDataRec dr;
  register int i;
  XimFrameType type;

  i = 0;
  while((type = fi->template[i].type) != EOL){
    if(type == ITER){
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.iter = IterInit(&fi->template[i + 1], num);
        (void)ChainMgrSetData(&fi->cm, i, dr);
        return FmSuccess;
      }
      if(IterSetIterCount(d->iter, num) == FmSuccess) return FmSuccess;
    }else if(type == POINTER){
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.fi = FrameInstInit(fi->template[i + 1].data);
        d = ChainMgrSetData(&fi->cm, i, dr);
      }
      if(FrameInstSetIterCount(d->fi, num) == FmSuccess) return FmSuccess;
    }
    i = _FrameInstIncrement(fi->template, i);
  }
  return FmNoMoreData;
}

FmStatus FrameMgrSetIterCount(FrameMgr fm, int count){
  if(FrameInstSetIterCount(fm->fi, count) == FmSuccess) return FmSuccess;
  else                                                  return FmNoMoreData;
}

int FrameMgrGetTotalSize(FrameMgr fm){
  return FrameInstGetTotalSize(fm->fi);
}

int IterGetSize(Iter it){
  register int i;
  ExtraData d;
  ExtraDataRec dr;

  if(it->cur_no >= it->max_count) return NO_VALID_FIELD;
  if(it->template->type == BARRAY){
    if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL){
      return NO_VALUE;
    }
    return d->num;
  }else if(it->template->type == ITER){
    for(i = it->cur_no; i < it->max_count; i++){
      int ret_size;
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.iter = IterInit(it->template + 1, NO_VALUE);
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      ret_size = IterGetSize(d->iter);
      if (ret_size == NO_VALID_FIELD) continue;
      else                            return ret_size;
    }
    return NO_VALID_FIELD;
  }else if(it->template->type == POINTER){
    for(i = it->cur_no; i < it->max_count; i++){
      int ret_size;
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.fi = FrameInstInit(it->template[1].data);
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      ret_size = FrameInstGetSize(d->fi);
      if(ret_size == NO_VALID_FIELD) continue;
      else                           return ret_size;
    }
    return NO_VALID_FIELD;
  }
  return NO_VALID_FIELD;
}

FmStatus IterSetIterCount(Iter it, int num){
  XimFrameType type;
  register int i;

  if(it->allow_expansion){
    it->max_count = num;
    it->allow_expansion = False;
    return FmSuccess;
  }
  if(it->max_count == 0) return FmNoMoreData;
  if(it->template->type == ITER){
    for(i = 0; i < it->max_count; i++){
      ExtraData d;
      ExtraDataRec dr;
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.iter = IterInit(it->template + 1, num);
        (void)ChainMgrSetData(&it->cm, i, dr);
        return FmSuccess;
      }
      if(IterSetIterCount(d->iter, num) == FmSuccess) return FmSuccess;
    }
    if(it->allow_expansion){
      ExtraDataRec dr;
      dr.iter = IterInit(it->template + 1, num);
      (void)ChainMgrSetData(&it->cm, it->max_count, dr);
      it->max_count++;
      return FmSuccess;
    }
  }else if(it->template->type == POINTER){
    for(i = 0; i < it->max_count; i++){
      ExtraData d;
      ExtraDataRec dr;
      if ((d = ChainMgrGetExtraData(&it->cm, i)) == NULL) {
        dr.fi = FrameInstInit(it->template[1].data);
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      if (FrameInstSetIterCount(d->fi, num) == FmSuccess) return FmSuccess;
    }
    if(it->allow_expansion){
      ExtraDataRec dr;
      dr.fi = FrameInstInit(it->template[1].data);
      (void)ChainMgrSetData(&it->cm, it->max_count, dr);
      it->max_count++;
      if(FrameInstSetIterCount(dr.fi, num) == FmSuccess) return FmSuccess;
    }
  }
  return FmNoMoreData;
}

int FrameInstGetSize(FrameInst fi){
  XimFrameType type;
  register int i;
  ExtraData d;
  ExtraDataRec dr;

  i = fi->cur_no;
  while((type = fi->template[i].type) != EOL){
    if(type == BARRAY){
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL) return NO_VALUE;
      return d->num;
    }else if(type == ITER){
      int ret_size;
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.iter = IterInit(&fi->template[i + 1], NO_VALUE);
        d = ChainMgrSetData(&fi->cm, i, dr);
      }
      ret_size = IterGetSize(d->iter);
      if(ret_size != NO_VALID_FIELD) return ret_size;
    }else if(type == POINTER){
      int ret_size;
      if((d = ChainMgrGetExtraData(&fi->cm, i)) == NULL){
        dr.fi = FrameInstInit(fi->template[i + 1].data);
        d = ChainMgrSetData(&fi->cm, i, dr);
      }
      ret_size = FrameInstGetSize(d->fi);
      if(ret_size != NO_VALID_FIELD) return ret_size;
    }
    i = _FrameInstIncrement(fi->template, i);
  }
  return NO_VALID_FIELD;
}

int FrameMgrGetSize(FrameMgr fm){
  register int ret_size;

  ret_size = FrameInstGetSize(fm->fi);
  if(ret_size == NO_VALID_FIELD) return NO_VALUE;
  return ret_size;
}

Bool _FrameMgrProcessPadding(FrameMgr fm, FmStatus* status){
  XimFrameTypeInfoRec info;
  XimFrameType next_type = FrameInstPeekNextType(fm->fi, &info);
  FrameIter fitr;

  if((next_type == PADDING) && (info.num != NO_VALUE)){
    next_type = FrameInstGetNextType(fm->fi, &info);
    fm->idx += info.num;
    if(fitr = _FrameIterCounterIncr(fm->iters, info.num)) _FrameMgrRemoveIter(fm, fitr);
    *status = FmSuccess;
    return(True);
  }else if((next_type == PADDING) && (info.num == NO_VALUE)){
    *status = FmInvalidCall;
    return(True);
  }else{
    *status = FmSuccess;
    return(False);
  }
}

Bool _FrameMgrIsIterLoopEnd(FrameMgr fm);

Bool FrameMgrIsIterLoopEnd(FrameMgr fm, FmStatus* status){
  do{
    if(_FrameMgrIsIterLoopEnd(fm)) return(True);
  }while(_FrameMgrProcessPadding(fm, status));
  return(False);
}

Bool _FrameMgrIsIterLoopEnd(FrameMgr fm){
  return(FrameInstIsIterLoopEnd(fm->fi));
}

XimFrameType IterPeekNextType(Iter it, XimFrameTypeInfo info){
  XimFrameType type = it->template->type;

  if(!it->allow_expansion && (it->cur_no >= it->max_count)) return(EOL);
  if(type == BIT8 || type == BIT16 || type == BIT32) return(type);
  else if(type == BARRAY){
    ExtraData d;
    ExtraDataRec dr;

    if(info){
      if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL) info->num = NO_VALUE;
      else                                                        info->num = d->num;
    }
    return(BARRAY);
  }else if(type == ITER){
    XimFrameType ret_type;
    ExtraData d;
    ExtraDataRec dr;

    if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL){
      dr.iter = IterInit(it->template + 1, NO_VALUE);
      d = ChainMgrSetData(&it->cm, it->cur_no, dr);
    }
    ret_type = IterPeekNextType(d->iter, info);
    if (ret_type == EOL) ret_type = IterPeekNextType(it, info);
    return(ret_type);
  }else if(type == POINTER){
    XimFrameType ret_type;
    ExtraData d;
    ExtraDataRec dr;

    if((d = ChainMgrGetExtraData(&it->cm, it->cur_no)) == NULL){
      dr.fi = FrameInstInit(it->template[1].data);
      d = ChainMgrSetData(&it->cm, it->cur_no, dr);
    }
    ret_type = FrameInstPeekNextType(d->fi, info);
    if(ret_type == EOL) ret_type = IterPeekNextType(it, info);
    return(ret_type);
  }else{
    ;                                                                /* ここには来ない */
  }
}

XimFrameType FrameInstPeekNextType(FrameInst fi, XimFrameTypeInfo info){
  XimFrameType ret_type;

  ret_type = fi->template[fi->cur_no].type;
  switch(ret_type){
    case BIT8 :
    case BIT16 :
    case BIT32 :
    case EOL :
      break;
    case COUNTER_BIT8 :
    case COUNTER_BIT16 :
    case COUNTER_BIT32 :
      if(info){
        register int offset, iter_idx;
        info->counter.is_byte_len =
          ((int)fi->template[fi->cur_no].data & 0xff) == FmCounterByte;
        offset = (int)fi->template[fi->cur_no].data >> 8;
        iter_idx = fi->cur_no + offset;
        if(fi->template[iter_idx].type == ITER){
          ExtraData d;
          ExtraDataRec dr;
          if((d = ChainMgrGetExtraData(&fi->cm, iter_idx)) == NULL){
            dr.iter = IterInit(&fi->template[iter_idx + 1], NO_VALUE);
            d = ChainMgrSetData(&fi->cm, iter_idx, dr);
          }
          info->counter.iter = d->iter;
        }else{
          ;                                                          /* ここには来ない */
        }
      }
      break;
    case BARRAY :
      if(info){
        ExtraData d;
        if((d = ChainMgrGetExtraData(&fi->cm, fi->cur_no)) == NULL) info->num = NO_VALUE;
        else                                                        info->num = d->num;
      }
      break;
    case PADDING :
      if(info){
        register int unit, number, size, i;

        unit   = _UNIT(fi->template[fi->cur_no].data);
        number = _NUMBER(fi->template[fi->cur_no].data);
        i      = fi->cur_no;
        size   = 0;
        while(number > 0){
          i = _FrameInstDecrement(fi->template, i);
          size += _FrameInstGetItemSize(fi, i);
          number--;
        }
        info->num = (unit - (size % unit)) % unit;
      }
      break;
    case ITER :
      {
        ExtraData d;
        ExtraDataRec dr;
        XimFrameType sub_type;

        if((d = ChainMgrGetExtraData(&fi->cm, fi->cur_no)) == NULL){
          dr.iter = IterInit(&fi->template[fi->cur_no + 1], NO_VALUE);
          d = ChainMgrSetData(&fi->cm, fi->cur_no, dr);
        }
        sub_type = IterPeekNextType(d->iter, info);
        if(sub_type == EOL){
          ret_type = FrameInstPeekNextType(fi, info);
        }else{
          ret_type = sub_type;
        }
      }
      break;
    case POINTER :
      {
        ExtraData d;
        ExtraDataRec dr;
        XimFrameType sub_type;

        if((d = ChainMgrGetExtraData(&fi->cm, fi->cur_no)) == NULL){
          dr.fi = FrameInstInit(fi->template[fi->cur_no + 1].data);
          d = ChainMgrSetData(&fi->cm, fi->cur_no, dr);
        }
        sub_type = FrameInstPeekNextType(d->fi, info);
        if(sub_type == EOL) ret_type = FrameInstPeekNextType(fi, info);
        else                ret_type = sub_type;
      }
      break;
    default :
      break;                                                         /* ここには来ない */
  }
  return ret_type;
}

Bool IterIsLoopEnd(Iter it, Bool* myself){
  Bool ret = False;
  *myself = False;

  if(!it->allow_expansion && (it->cur_no == it->max_count)){
    *myself = True;
    ret = True;
  }else if(it->template->type == POINTER){
    ExtraData d = ChainMgrGetExtraData(&it->cm, it->cur_no);
    if(d){
      if (FrameInstIsIterLoopEnd(d->fi)) ret = True;
      else{
        if(FrameInstIsEnd(d->fi)){
          it->cur_no++;
          if(!it->allow_expansion && (it->cur_no == it->max_count)){
            *myself = True;
            ret = True;
          }
        }
      }
    }
  }else if(it->template->type == ITER){
    ExtraData d = ChainMgrGetExtraData(&it->cm, it->cur_no);
    if (d) {
      Bool yourself;
      if (IterIsLoopEnd(d->iter, &yourself)) {
        ret = True;
      }
    }
  }
  return(ret);
}

Bool FrameInstIsIterLoopEnd(FrameInst fi){
  Bool ret = False;

  if(fi->template[fi->cur_no].type == ITER){
    ExtraData d = ChainMgrGetExtraData(&fi->cm, fi->cur_no);
    Bool yourself;

    if(d){
      ret = IterIsLoopEnd(d->iter, &yourself);
      if(ret && yourself){
        fi->cur_no = _FrameInstIncrement(fi->template, fi->cur_no);
      }
    }
  }
  return(ret);
}

void FrameInstReset(FrameInst fi){
  ChainIterRec ci;
  int frame_no;
  ExtraDataRec d;

  ChainIterInit(&ci, &fi->cm);
  while(ChainIterGetNext(&ci, &frame_no, &d)){
    register XimFrameType type;
    type = fi->template[frame_no].type;
    if(type == ITER){
      if(d.iter) IterReset(d.iter);
    }else if(type == POINTER){
      if(d.fi) FrameInstReset(d.fi);
    }
  }
  fi->cur_no = 0;
}

int IterGetTotalSize(Iter it){
  register int size, i;
  XimFrameType type;

  if(it->allow_expansion)     return NO_VALUE;
  else if(it->max_count == 0) return 0;
  type = it->template->type;
  size = 0;
  if     (type == BIT8)  size = it->max_count;
  else if(type == BIT16) size = it->max_count * 2;
  else if(type == BIT32) size = it->max_count * 4;
  else if(type == BARRAY){
    for(i = 0; i < it->max_count; i++){
      register int num;
      ExtraData d;
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL) return NO_VALUE;
      if((num = d->num) == NO_VALUE) return NO_VALUE;
      size += num;
    }
  }else if(type == ITER){
    for(i = 0; i < it->max_count; i++){
      register int num;
      ExtraData d;
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL) return NO_VALUE;
      if((num = IterGetTotalSize(d->iter)) == NO_VALUE) return NO_VALUE;
      size += num;
    }
  }else if(type == POINTER){
    for(i = 0; i < it->max_count; i++){
      register int num;
      ExtraData d;
      ExtraDataRec dr;
      if((d = ChainMgrGetExtraData(&it->cm, i)) == NULL){
        dr.fi = FrameInstInit(it->template[1].data);
        d = ChainMgrSetData(&it->cm, i, dr);
      }
      if((num = FrameInstGetTotalSize(d->fi)) == NO_VALUE) return NO_VALUE;
      size += num;
    }
  }else{
    ;                                                                /* ここには来ない */
  }
  return size;
}

void IterReset(Iter it){
  if(it->template->type == ITER){
    ChainIterRec ci;
    int count;
    ExtraDataRec d;

    ChainIterInit(&ci, &it->cm);
    while(ChainIterGetNext(&ci, &count, &d)) IterReset(d.iter);
  }else if(it->template->type == POINTER){
    ChainIterRec ci;
    int count;
    ExtraDataRec dr;

    ChainIterInit(&ci, &it->cm);
    while(ChainIterGetNext(&ci, &count, &dr)) FrameInstReset(dr.fi);
  }
  it->cur_no = 0;
}

#define IC_SIZE 64

XIMStyle Styles[] = {                                  /* XIM    Supported Inputstyles */
  XIMPreeditNothing | XIMStatusNothing,                                   /* Root only */
  0
};

#define FrameMgrPutToken(fm, obj) _FrameMgrPutToken((fm), &(obj), sizeof(obj))
#define FrameMgrGetToken(fm, obj) _FrameMgrGetToken((fm), &(obj), sizeof(obj))

void _Xi18nMessageHandler(XIMS, CARD16, unsigned char *, Bool *);

Xi18nClient *_Xi18nFindClient(Xi18n i18n_core, CARD16 connect_id){
  Xi18nClient *client = i18n_core->address.clients;

  while(client != NULL){
    if(client->connect_id == connect_id) return client;
    client = client->next;
  }
  return NULL;
}

Bool _Xi18nNeedSwap(Xi18n i18n_core, CARD16 connect_id){ /* IMのバイト順と違うならTrue */
  CARD8  im_byteOrder = i18n_core->address.im_byteOrder;                 /* 'l' か 'B' */
  Xi18nClient *client = _Xi18nFindClient(i18n_core, connect_id);
  return (client->byte_order != im_byteOrder);
}

Xi18nClient *_Xi18nNewClient(Xi18n i18n_core){   /* < NewXClient < ReadXConnectMessage */
  static CARD16 connect_id = 0;
  Xi18nClient *client;

  client=(Xi18nClient *)malloc(sizeof(Xi18nClient));
  memset(client, 0, sizeof(Xi18nClient));               /* 確保したclientに 0 を詰める */
  client->connect_id = ++connect_id;
  client->pending = (XIMPending *)NULL;
  client->sync = False;
  client->byte_order = '?';                      /* バイト順は始めは“不明”にしておく */
  memset(&client->pending, 0, sizeof(XIMPending *));
  client->next = i18n_core->address.clients;
  i18n_core->address.clients = client;
  return (Xi18nClient *)client;
}

void _Xi18nDeleteClient(Xi18n i18n_core, CARD16 connect_id){
  Xi18nClient *target = _Xi18nFindClient(i18n_core, connect_id);
  Xi18nClient *ccp, *ccp0;

  for(ccp=i18n_core->address.clients, ccp0=NULL; ccp!=NULL; ccp0=ccp, ccp=ccp->next){
    if(ccp==target){
      if(ccp0==NULL) i18n_core->address.clients = ccp->next;
      else                           ccp0->next = ccp->next;
      free(target);
      return;
    }
  }
  return;
}

void _Xi18nSendMessage(XIMS ims, CARD16 connect_id,
             CARD8 major_opcode, CARD8 minor_opcode, unsigned char *data, long length){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  unsigned char *reply_hdr = NULL;
  int header_size;
  unsigned char *reply = NULL;
  unsigned char *replyp;
  int reply_length;
  long p_len = length/4;

  fm=FrameMgrInit(packet_header_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  header_size = FrameMgrGetTotalSize(fm);
  reply_hdr = (unsigned char *)malloc(header_size);
  if(!reply_hdr){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  FrameMgrSetBuffer(fm, reply_hdr);
  FrameMgrPutToken(fm, major_opcode);
  FrameMgrPutToken(fm, minor_opcode);
  FrameMgrPutToken(fm, p_len);
  reply_length = header_size + length;
  reply = (unsigned char *)malloc(reply_length);
  replyp = reply;
  memmove(reply, reply_hdr, header_size);
  replyp += header_size;
  memmove(replyp, data, length);
  i18n_core->methods.send(ims, connect_id, reply, reply_length);
  free(reply_hdr);
  free(reply);
  FrameMgrFree(fm);
  return;
}

void _Xi18nSetEventMask(XIMS ims, CARD16 connect_id,
                   CARD16 im_id, CARD16 ic_id, CARD32 forward_mask, CARD32 sync_mask){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  unsigned char *reply = NULL;
  register int total_size;

  fm=FrameMgrInit(set_event_mask_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply) return;
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, im_id);                                      /* input-method-id */
  FrameMgrPutToken(fm, ic_id);                                     /* input-context-id */
  FrameMgrPutToken(fm, forward_mask);
  FrameMgrPutToken(fm, sync_mask);
  _Xi18nSendMessage(ims, connect_id, XIM_SET_EVENT_MASK, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  return;
}

typedef struct _XClient{
  Window client_win;                                                  /* client window */
  Window accept_win;                                                  /* accept window */
}XClient;

typedef struct{
  Atom  xim_request;
  Atom  connect_request;
}XSpecRec;

XClient *NewXClient(Xi18n i18n_core, Window new_client){
  Display *dpy = i18n_core->address.dpy;
  Xi18nClient *client = _Xi18nNewClient(i18n_core);
  XClient *x_client;

  x_client = (XClient *)malloc(sizeof(XClient));
  x_client->client_win = new_client;
  x_client->accept_win = XCreateSimpleWindow(dpy, DefaultRootWindow(dpy),
                                              0, 0, 1, 1, 1, 0, 0);
  client->trans_rec = x_client;
  return ((XClient *)x_client);
}

unsigned char *ReadXIMMessage(XIMS ims, XClientMessageEvent *ev, int *connect_id){
                                                      /* < Xi18nXWait, WaitXIMProtocol */
  Xi18n i18n_core = ims->protocol;
  Xi18nClient *client = i18n_core->address.clients;
  XClient *x_client;

  FrameMgr fm;
  register int total_size;
  unsigned char *p = NULL;
  unsigned char *p1;

  while (client != NULL) {
    x_client = (XClient *)client->trans_rec;
    if(x_client->accept_win == ev->window){
      *connect_id = client->connect_id;
      break;
    }
    client = client->next;
  }
  if(ev->format == 8){                                           /* ClientMessage only */
    XimProtoHdr *hdr = (XimProtoHdr *)ev->data.b;
    unsigned char *rec = (unsigned char *)(hdr + 1);
    CARD8 major_opcode, minor_opcode;
    CARD16 length;

    if(client->byte_order == '?'){
      if(hdr->major_opcode == XIM_CONNECT) client->byte_order = (CARD8)rec[0];
      else    return (unsigned char *)NULL;                          /* can do nothing */
    }
    fm=FrameMgrInit(packet_header_fr, (char *)hdr,
                    _Xi18nNeedSwap(i18n_core, *connect_id));
    total_size = FrameMgrGetTotalSize(fm);
    FrameMgrGetToken(fm, major_opcode);                                    /* get data */
    FrameMgrGetToken(fm, minor_opcode);
    FrameMgrGetToken(fm, length);
    FrameMgrFree(fm);
    if((p=(unsigned char *)malloc(total_size + length * 4)) == NULL)
      return (unsigned char *)NULL;
    p1=p;
    memmove(p1, &major_opcode, sizeof(CARD8)); p1 += sizeof(CARD8);
    memmove(p1, &minor_opcode, sizeof(CARD8)); p1 += sizeof(CARD8);
    memmove(p1, &length, sizeof(CARD16)); p1 += sizeof(CARD16);
    memmove(p1, rec, length * 4);
  }else if(ev->format == 32){                      /* ClientMessage and WindowProperty */
    unsigned long length = (unsigned long)ev->data.l[0];
    Atom atom = (Atom)ev->data.l[1];
    int            return_code;
    Atom           actual_type_ret;
    int            actual_format_ret;
    unsigned long  bytes_after_ret;
    unsigned char  *prop;
    unsigned long  nitems;

    return_code = XGetWindowProperty(i18n_core->address.dpy, x_client->accept_win,
            atom, 0L, length * 4, True, AnyPropertyType,
            &actual_type_ret, &actual_format_ret, &nitems, &bytes_after_ret, &prop);
    if(return_code != Success || actual_format_ret == 0 || nitems == 0){
      if(return_code == Success) XFree(prop);
      return (unsigned char *)NULL;
    }
    if(length != nitems) length = nitems;       /* if hit, it might be an error (r6im) */
    if((p=(unsigned char *)malloc(length * 4))!=NULL) memmove(p, prop, length * 4);
    XFree(prop);
  }
  return (unsigned char *)p;
}

Bool WaitXIMProtocol(Display *dpy, Window win, XEvent *ev, XPointer client_data){
                   /* ReadXConnectMessage、_XRegisterFilterByTypeのXi18nXDisconnect で */
                                         /* _XUnregisterFilterの引数として呼び出される */
  XIMS ims = (XIMS)client_data;
  Xi18n i18n_core = ims->protocol;
  XSpecRec *spec = (XSpecRec *)i18n_core->address.connect_addr;
  Bool delete = True;
  unsigned char *packet;
  int connect_id;

  if(((XClientMessageEvent *)ev)->message_type==spec->xim_request){ /*"_XIM_PROTOCOL"の*/
    if(packet=ReadXIMMessage(ims,(XClientMessageEvent *)ev, &connect_id)){ /*アトムなら*/
      _Xi18nMessageHandler(ims, connect_id, packet, &delete);/* 読込んでハンドラに渡す */
      if(delete==True) free(packet);
      return True;
    }else{
if(Log) fprintf(stderr, "connect_id=%d ReadXIMMessage return NULL\n", connect_id);
    }
  }
  return False;
}

#define XCM_DATA_LIMIT  20

void ReadXConnectMessage(XIMS ims, XClientMessageEvent *ev){
  Xi18n i18n_core = ims->protocol;
  XSpecRec *spec = (XSpecRec *)i18n_core->address.connect_addr;
  XEvent event;
  Display *dpy = i18n_core->address.dpy;
  Window new_client = ev->data.l[0];
  CARD32 major_version = ev->data.l[1];
  CARD32 minor_version = ev->data.l[2];
  XClient *x_client = NewXClient(i18n_core, new_client);

  if(ev->window != i18n_core->address.im_window) return;
  if(major_version!=0 || minor_version!=0) major_version = minor_version = 0;
  _XRegisterFilterByType(dpy, x_client->accept_win,
                       ClientMessage, ClientMessage, WaitXIMProtocol, (XPointer)ims);
if(Log){
  fprintf(stderr, "_XReg :WaitXIMProtocol %u\n", (unsigned int)x_client->accept_win);
}
  event.xclient.type = ClientMessage;
  event.xclient.display = dpy;
  event.xclient.window = new_client;
  event.xclient.message_type = spec->connect_request;               /* "_XIM_XCONNECT" */
  event.xclient.format       = 32;
  event.xclient.data.l[0]    = x_client->accept_win;
  event.xclient.data.l[1]    = major_version;
  event.xclient.data.l[2]    = minor_version;
  event.xclient.data.l[3]    = XCM_DATA_LIMIT;     /* 当関数を記した前の行に 20 と定義 */
  XSendEvent(dpy, new_client, False, NoEventMask, &event);
  XFlush(dpy);
}

Bool WaitXConnectMessage(Display *dpy, Window win, XEvent *ev, XPointer client_data){
 /* Xi18nXBeginで_XRegisterFilterByTypeの、Xi18nXEndで_XUnregisterFilterの各引数になる */
  XIMS ims = (XIMS)client_data;
  Xi18n i18n_core = ims->protocol;
  XSpecRec *spec = (XSpecRec *)i18n_core->address.connect_addr;

  if(((XClientMessageEvent *)ev)->message_type==spec->connect_request){     /* XCONNET */
    ReadXConnectMessage(ims, (XClientMessageEvent *)ev);       /* のアトムなら読み出す */
    return True;         /* クライアントは処理せずに、次のイベントの取り出しに移らせる */
  }
  return False;                                            /* クライアントに実行させる */
}

Bool Xi18nXBegin(XIMS ims){                       /* < _Xi18nCheckXAddress < ki_openIM */
  Xi18n i18n_core = ims->protocol;
  Display *dpy = i18n_core->address.dpy;
  XSpecRec *spec = (XSpecRec *)i18n_core->address.connect_addr;
  spec->xim_request = XInternAtom(i18n_core->address.dpy, "_XIM_PROTOCOL", False);
  spec->connect_request = XInternAtom(i18n_core->address.dpy, "_XIM_XCONNECT", False);
  _XRegisterFilterByType(dpy, i18n_core->address.im_window,
                ClientMessage, ClientMessage, WaitXConnectMessage, (XPointer)ims);
if(Log){
  fprintf(stderr, "_XReg :WaitXConnectMessage %u\n",
                                             (unsigned int)i18n_core->address.im_window);
}
  return True;
}  /* ClientMessageイベントが来たらフィルタWaitXConnectMessageを実行するように登録する */

Bool Xi18nXEnd(XIMS ims){
  Xi18n i18n_core = ims->protocol;
  Display *dpy = i18n_core->address.dpy;

  _XUnregisterFilter(dpy, i18n_core->address.im_window,
         WaitXConnectMessage, (XPointer)ims);   /* 該当するXFilterEventRecを鎖から外す */
if(Log){
  fprintf(stderr, "_XUnreg: WaitXConnectMessage %u\n",
                                             (unsigned int)i18n_core->address.im_window);
}
  return True;
}

char *MakeNewAtom(CARD16 connect_id, char *atomName){
  static int sequence = 0;
  sprintf(atomName, "_server%d_%d", connect_id,(sequence>20?(sequence = 0):sequence++));
  return atomName;
}

Bool Xi18nXSend(XIMS ims, CARD16 connect_id, unsigned char *reply, long length){
                                                                /* < _Xi18nSendMessage */
  Xi18n i18n_core = ims->protocol;
  Xi18nClient *client = _Xi18nFindClient(i18n_core, connect_id);
  XSpecRec *spec = (XSpecRec *)i18n_core->address.connect_addr;
  XClient *x_client = (XClient *)client->trans_rec;
  XEvent event;

  event.type = ClientMessage;
  event.xclient.window = x_client->client_win;
  event.xclient.message_type = spec->xim_request;
  if(length>XCM_DATA_LIMIT){
    Atom atom;
    char atomName[16];
    Atom actual_type_ret;
    int actual_format_ret;
    int return_code;
    unsigned long nitems_ret;
    unsigned long bytes_after_ret;
    unsigned char *win_data;

    event.xclient.format = 32;
    atom = XInternAtom(i18n_core->address.dpy, MakeNewAtom(connect_id, atomName), False);
    return_code = XGetWindowProperty(i18n_core->address.dpy, x_client->client_win,
                           atom, 0L, 10000L, False, XA_STRING, &actual_type_ret,
                           &actual_format_ret, &nitems_ret, &bytes_after_ret, &win_data);
    if(return_code!=Success) return False;
    if(win_data) XFree((char *)win_data);
    XChangeProperty(i18n_core->address.dpy, x_client->client_win,
                      atom, XA_STRING, 8,PropModeAppend, (unsigned char *)reply, length);
    event.xclient.data.l[0] = length;
    event.xclient.data.l[1] = atom;
  }else{
    unsigned char buffer[XCM_DATA_LIMIT];
    int i;
    event.xclient.format = 8;

    memmove(buffer, reply, length);
    for(i=length; i<XCM_DATA_LIMIT; i++) buffer[i] = (char)0;
    length = XCM_DATA_LIMIT;
    memmove(event.xclient.data.b, buffer, length);
  }
  XSendEvent(i18n_core->address.dpy, x_client->client_win, False, NoEventMask, &event);
  XFlush(i18n_core->address.dpy);
  return True;
}

Bool CheckCMEvent(Display *display, XEvent *event, XPointer ki_core){
  Xi18n i18n_core = (Xi18n)((void *)ki_core);
  XSpecRec *spec  = (XSpecRec *)i18n_core->address.connect_addr;

  if((event->type==ClientMessage) && (event->xclient.message_type == spec->xim_request))
    return True;
  return False;
}

Bool Xi18nXWait(XIMS ims, CARD16 connect_id, CARD8 major_opcode, CARD8 minor_opcode){
  Xi18n i18n_core = ims->protocol;
  XEvent event;
  Xi18nClient *client = _Xi18nFindClient(i18n_core, connect_id);
  XClient *x_client = (XClient *)client->trans_rec;

  for (;;) {
    unsigned char *packet;
    XimProtoHdr *hdr;
    int connect_id_ret;

    XIfEvent(i18n_core->address.dpy, &event, CheckCMEvent, (XPointer)i18n_core);
    if(event.xclient.window == x_client->accept_win){
      packet = ReadXIMMessage(ims,(XClientMessageEvent *)&event, &connect_id_ret);
      if(packet){
        hdr = (XimProtoHdr *)packet;
        if((hdr->major_opcode == major_opcode) && (hdr->minor_opcode == minor_opcode))
          return True;
        else if(hdr->major_opcode == XIM_ERROR) return False;
      }else return False;
    }
  }
}

Bool Xi18nXDisconnect(XIMS ims, CARD16 connect_id){         /* < DisconnectMessageProc */
  Xi18n i18n_core = ims->protocol;
  Display *dpy = i18n_core->address.dpy;
  Xi18nClient *client = _Xi18nFindClient(i18n_core, connect_id);
  XClient *x_client = (XClient *)client->trans_rec;

  _XUnregisterFilter(dpy, x_client->accept_win, WaitXIMProtocol, (XPointer)ims);
if(Log){
  fprintf(stderr, "_XUnreg: WaitXIMProtocol %u\n", (unsigned int)x_client->accept_win);
}
  XDestroyWindow(dpy, x_client->accept_win);
   free(x_client);
  _Xi18nDeleteClient(i18n_core, connect_id);
  return True;
}

Bool _Xi18nCheckXAddress(Xi18n i18n_core){                /* < CheckIMName < ki_openIM */
  XSpecRec *spec;
  if(!(spec=(XSpecRec *)malloc(sizeof(XSpecRec)))) return False;
  i18n_core->address.connect_addr= (XSpecRec *)spec;
  i18n_core->methods.begin       = Xi18nXBegin;                         /* < ki_openIM */
  i18n_core->methods.end         = Xi18nXEnd;                          /* < ki_closeIM */
  i18n_core->methods.send        = Xi18nXSend;                  /* < _Xi18nSendMessage */
  i18n_core->methods.wait        = Xi18nXWait;      /* < _Xi18nSringConversionCallback */
  i18n_core->methods.disconnect  = Xi18nXDisconnect;        /* < DisconnectMessageProc */
  return True;
}

void GetAttrHeader(unsigned char *rec, XICAttribute *list, Bool need_swap){
  FrameMgr fm;
  fm=FrameMgrInit(attr_head_fr, (char *)rec, need_swap);
  FrameMgrPutToken(fm, list->attribute_id);
  FrameMgrPutToken(fm, list->value_length);
  FrameMgrFree(fm);
  return;
}

Bool IsNestedList(Xi18n i18n_core, CARD16 icvalue_id){
  XICAttr *ic_attr = i18n_core->address.xic_attr;
  int i;

  for(i=0; i<i18n_core->address.ic_attr_num; i++, ic_attr++){
    if(ic_attr->attribute_id == icvalue_id){
      if(ic_attr->type == XimType_NEST) return True;
      else                              return False;
    }
  }
  return False;
}

Bool IsSeparator(Xi18n i18n_core, CARD16 icvalue_id){
  return (i18n_core->address.separatorAttr_id == icvalue_id);
}

void GetICValue(Xi18n i18n_core,
        XICAttribute *attr_ret, CARD16 *id_list, int list_num, int *number_ret){
  XICAttr *xic_attr = i18n_core->address.xic_attr;
  register int i, j, n;

  i=n=0;
  if(IsNestedList(i18n_core, id_list[i])){
    i++;
    while(i<list_num && !IsSeparator(i18n_core, id_list[i])){
      for(j=0; j<i18n_core->address.ic_attr_num; j++){
        if(xic_attr[j].attribute_id == id_list[i]){
          attr_ret[n].attribute_id = xic_attr[j].attribute_id;
          attr_ret[n].name_length = xic_attr[j].length;
          attr_ret[n].name = malloc(xic_attr[j].length + 1);
          strcpy(attr_ret[n].name, xic_attr[j].name);
          attr_ret[n].type = xic_attr[j].type;
          n++; i++;
          break;
        }
      }
    }
  }else{
    for(j=0; j<i18n_core->address.ic_attr_num; j++){
      if(xic_attr[j].attribute_id == id_list[i]){
        attr_ret[n].attribute_id = xic_attr[j].attribute_id;
        attr_ret[n].name_length = xic_attr[j].length;
        attr_ret[n].name = malloc(xic_attr[j].length + 1);
        strcpy(attr_ret[n].name, xic_attr[j].name);
        attr_ret[n].type = xic_attr[j].type;
        n++;
        break;
      }
    }
  }
  *number_ret = n;
  return;
}

void _Xi18nChangeIC(XIMS ims, IMProtocol *call_data, unsigned char *p, int create_flag){
                                      /* < CreateICMessageProc,  SetICValueMessageProc */
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  FmStatus status;
  CARD16 byte_length;
  register int total_size;
  unsigned char *reply = NULL;
  register int i, attrib_num;
  XICAttribute *attrib_list;
  XICAttribute ic_attr[IC_SIZE];
  CARD16 ic_num = 0;
  CARD16 connect_id = call_data->any.connect_id;
  IMChangeICStruct *changeic =(IMChangeICStruct*)&call_data->changeic;
  CARD16 input_method_ID;

  memset(ic_attr, 0, sizeof(XICAttribute) * IC_SIZE);
  if(create_flag == True){
    fm=FrameMgrInit(create_ic_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
    FrameMgrGetToken(fm, input_method_ID);
    FrameMgrGetToken(fm, byte_length);
  }else{
    fm=FrameMgrInit(set_ic_values_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
    FrameMgrGetToken(fm, input_method_ID);
    FrameMgrGetToken(fm, changeic->icid);
    FrameMgrGetToken(fm, byte_length);
  }
  attrib_list = (XICAttribute *)malloc(sizeof(XICAttribute) * IC_SIZE);
  if(!attrib_list){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(attrib_list, 0, sizeof(XICAttribute) * IC_SIZE);
  attrib_num = 0;
  while(FrameMgrIsIterLoopEnd(fm, &status) == False){
    void *value;
    int value_length;
    FrameMgrGetToken(fm, attrib_list[attrib_num].attribute_id);
    FrameMgrGetToken(fm, value_length);
    FrameMgrSetSize(fm, value_length);
    attrib_list[attrib_num].value_length = value_length;
    FrameMgrGetToken(fm, value);
    attrib_list[attrib_num].value = (void *)malloc(value_length + 1);
    memmove(attrib_list[attrib_num].value, value, value_length);
    attrib_num++;
  }
  for(i=0; i<attrib_num; i++) free(attrib_list[i].value);
  free(attrib_list);
  FrameMgrFree(fm);

  changeic->ic_attr_num = ic_num;
  changeic->ic_attr = ic_attr;
  if(i18n_core->address.improto)                            /* MyProtoHandler があれば */
    if(!(i18n_core->address.improto(ims, call_data))) return; /* 実行してFalseなら出る */
  if(create_flag == True)
    fm=FrameMgrInit(create_ic_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  else
    fm=FrameMgrInit(set_ic_values_reply_fr, NULL, _Xi18nNeedSwap(i18n_core,connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  FrameMgrPutToken(fm, changeic->icid);
  if(create_flag == True)                                                    /* CREATE */
    _Xi18nSendMessage(ims, connect_id, XIM_CREATE_IC_REPLY, 0, reply, total_size);
  else                                                                /* SET_IC_VALUES */
    _Xi18nSendMessage(ims, connect_id, XIM_SET_IC_VALUES_REPLY, 0, reply, total_size);
  if(create_flag == True){
    long mask;
    if(i18n_core->address.imvalue_mask & I18N_FILTERMASK)
         mask = i18n_core->address.filterevent_mask;
    else mask = DEFAULT_FILTER_MASK;                   /* static event flow is default */
    _Xi18nSetEventMask(ims, connect_id, input_method_ID, changeic->icid, mask, ~mask);
  }
  free(reply);
  FrameMgrFree(fm);
  return;
}

void _Xi18nGetIC(XIMS ims, IMProtocol *call_data, unsigned char *p){
                                                           /* < GetICValuesMessageProc */
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  FmStatus status;
  CARD16 byte_length;
  register int total_size;
  unsigned char *reply = NULL;
  register int i, number;
  int iter_count;
  CARD16 *attrID_list;
  XICAttribute ic_attr[IC_SIZE], *icp;
  CARD16 ic_count = 0;
  IMChangeICStruct *getic = (IMChangeICStruct*)&call_data->changeic;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;
  memset(ic_attr, 0, sizeof(XICAttribute) * IC_SIZE);
  fm=FrameMgrInit(get_ic_values_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, getic->icid);
  FrameMgrGetToken(fm, byte_length);
  attrID_list = (CARD16 *)malloc(sizeof(CARD16) * IC_SIZE);
  memset(attrID_list, 0, sizeof(CARD16) * IC_SIZE);
  number = 0;
  while(FrameMgrIsIterLoopEnd(fm, &status) == False){
    FrameMgrGetToken(fm, attrID_list[number]);
    number++;
  }
  FrameMgrFree(fm);
  i=0;
  while(i<number){
    int read_number;
    if(IsNestedList(i18n_core, attrID_list[i])){
    }else{
      GetICValue(i18n_core, &ic_attr[i], &attrID_list[i], number, &read_number);
      i += read_number;
      ic_count += read_number;
    }
  }
  getic->ic_attr_num = ic_count;
  getic->ic_attr = ic_attr;
  free(attrID_list);
  if(i18n_core->address.improto)
    if (!(i18n_core->address.improto(ims, call_data))) return;  /* MyProtoHandler 実行 */
  iter_count = getic->ic_attr_num;
  fm=FrameMgrInit(get_ic_values_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrSetIterCount(fm, iter_count);
  for(i=0; i<(int)getic->ic_attr_num; i++) FrameMgrSetSize(fm, ic_attr[i].value_length);
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  FrameMgrPutToken(fm, getic->icid);
  for(i=0; i<(int)getic->ic_attr_num; i++){
    FrameMgrPutToken(fm, ic_attr[i].attribute_id);
    FrameMgrPutToken(fm, ic_attr[i].value_length);
    FrameMgrPutToken(fm, ic_attr[i].value);
  }
  _Xi18nSendMessage(ims, connect_id, XIM_GET_IC_VALUES_REPLY, 0, reply, total_size);
  free(reply);
  for (icp = ic_attr; icp < &ic_attr[i]; icp++) {
    if(icp->value_length && icp->value) free(icp->value);
    if(icp->name_length && icp->name) free(icp->name);
  }
  FrameMgrFree(fm);
  return;
}

void GetProtocolVersion(CARD16 client_major, CARD16 client_minor,
                        CARD16 *server_major, CARD16 *server_minor){
  *server_major = client_major;
  *server_minor = client_minor;
}

void ConnectMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  register int total_size;
  CARD16 server_major_version, server_minor_version;
  unsigned char *reply = NULL;
  IMConnectStruct *imconnect =  (IMConnectStruct*)&call_data->imconnect;
  CARD16 connect_id = call_data->any.connect_id;

  fm = FrameMgrInit(connect_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, imconnect->byte_order);
  FrameMgrGetToken(fm, imconnect->major_version);
  FrameMgrGetToken(fm, imconnect->minor_version);
  FrameMgrFree(fm);
  GetProtocolVersion(imconnect->major_version, imconnect->minor_version,
                        &server_major_version, &server_minor_version);
  fm = FrameMgrInit(connect_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, server_major_version);
  FrameMgrPutToken(fm, server_minor_version);
  _Xi18nSendMessage(ims, connect_id, XIM_CONNECT_REPLY, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  return;
}

void DisConnectMessageProc(XIMS ims, IMProtocol *call_data){
  Xi18n i18n_core = ims->protocol;
  unsigned char *reply = NULL;
  CARD16 connect_id = call_data->any.connect_id;

  _Xi18nSendMessage(ims, connect_id, XIM_DISCONNECT_REPLY, 0, reply, 0);
  i18n_core->methods.disconnect(ims, connect_id);
  return;
}

void OpenMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  unsigned char *reply = NULL;
  int str_size;
  register int i, total_size;
  CARD16 connect_id = call_data->any.connect_id;
  int str_length;
  char *name;
  IMOpenStruct *imopen = (IMOpenStruct *)&call_data->imopen;
  fm = FrameMgrInit(open_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, str_length);
  FrameMgrSetSize(fm, str_length);
  FrameMgrGetToken(fm, name);
  imopen->lang.length = str_length;
  imopen->lang.name = malloc(str_length + 1);
  strncpy(imopen->lang.name, name, str_length);
  imopen->lang.name[str_length] = (char)0;
  FrameMgrFree(fm);
  if(i18n_core->address.improto)
    if(!(i18n_core->address.improto(ims, call_data))) return;
  free(imopen->lang.name);
  fm = FrameMgrInit(open_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrSetIterCount(fm, i18n_core->address.im_attr_num);
  for(i=0; i<i18n_core->address.im_attr_num; i++){
    str_size = strlen(i18n_core->address.xim_attr[i].name);
    FrameMgrSetSize(fm, str_size);
  }
  FrameMgrSetIterCount(fm, i18n_core->address.ic_attr_num);
  for(i=0; i<i18n_core->address.ic_attr_num; i++){
    str_size = strlen(i18n_core->address.xic_attr[i].name);
    FrameMgrSetSize(fm, str_size);
  }
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, connect_id);                                 /* input-method ID */
  for(i=0; i<i18n_core->address.im_attr_num; i++){
    str_size = FrameMgrGetSize(fm);
    FrameMgrPutToken(fm, i18n_core->address.xim_attr[i].attribute_id);
    FrameMgrPutToken(fm, i18n_core->address.xim_attr[i].type);
    FrameMgrPutToken(fm, str_size);
    FrameMgrPutToken(fm, i18n_core->address.xim_attr[i].name);
  }
  for(i=0; i<i18n_core->address.ic_attr_num; i++){
    str_size = FrameMgrGetSize(fm);
    FrameMgrPutToken(fm, i18n_core->address.xic_attr[i].attribute_id);
    FrameMgrPutToken(fm, i18n_core->address.xic_attr[i].type);
    FrameMgrPutToken(fm, str_size);
    FrameMgrPutToken(fm, i18n_core->address.xic_attr[i].name);
  }
  _Xi18nSendMessage(ims, connect_id, XIM_OPEN_REPLY, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  return;
}

void CloseMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  unsigned char *reply = NULL;
  register int total_size;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(close_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrFree(fm);
  if(i18n_core->address.improto)
    if(!(i18n_core->address.improto(ims, call_data))) return;
  fm = FrameMgrInit(close_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  _Xi18nSendMessage(ims, connect_id, XIM_CLOSE_REPLY, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  return;
}

XIMExt *MakeExtensionList(Xi18n i18n_core,
                      XIMStr *lib_extension, int number, int *reply_number){
  XIMExt *ext_list;
  XIMExt *im_ext = (XIMExt *)i18n_core->address.extension;
  int im_ext_len = i18n_core->address.ext_num;
  int i, j;

  *reply_number = 0;
  if(number==0){                                               /* query all extensions */
    *reply_number = im_ext_len;
  }else{
    for(i=0; i<im_ext_len; i++){
      for(j=0; j<(int)number; j++)
        if(!strcmp(lib_extension[j].name, im_ext[i].name)) {(*reply_number)++; break;}
    }
  }
  if(!(*reply_number)) return NULL;
  ext_list = (XIMExt *)malloc(sizeof(XIMExt) * (*reply_number));
  if (!ext_list) return NULL;
  memset(ext_list, 0, sizeof(XIMExt) * (*reply_number));
  if(number==0){                                               /* query all extensions */
    for(i=0; i<im_ext_len; i++){
      ext_list[i].major_opcode = im_ext[i].major_opcode;
      ext_list[i].minor_opcode = im_ext[i].minor_opcode;
      ext_list[i].length = im_ext[i].length;
      ext_list[i].name = malloc(im_ext[i].length + 1);
      strcpy(ext_list[i].name, im_ext[i].name);
    }
  }else{
    int n = 0;
    for(i=0; i<im_ext_len; i++){
      for(j=0; j<(int)number; j++)
        if(!strcmp(lib_extension[j].name, im_ext[i].name)){
          ext_list[n].major_opcode = im_ext[i].major_opcode;
          ext_list[n].minor_opcode = im_ext[i].minor_opcode;
          ext_list[n].length = im_ext[i].length;
          ext_list[n].name = malloc(im_ext[i].length + 1);
          strcpy(ext_list[n].name, im_ext[i].name);
          n++;
          break;
        }
    }
  }
  return ext_list;
}

void QueryExtensionMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  FmStatus status;
  unsigned char *reply = NULL;
  int str_size;
  register int i, number, total_size;
  int byte_length;
  int reply_number = 0;
  XIMExt *ext_list;
  IMQueryExtensionStruct *query_ext = (IMQueryExtensionStruct *)&call_data->queryext;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm=FrameMgrInit(query_extension_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, byte_length);
  query_ext->extension = (XIMStr *)malloc(sizeof(XIMStr) * 10);
  memset(query_ext->extension, 0, sizeof(XIMStr) * 10);
  number = 0;
  while(FrameMgrIsIterLoopEnd(fm, &status) == False){
    char *name;
    int str_length;
    FrameMgrGetToken(fm, str_length);
    FrameMgrSetSize(fm, str_length);
    query_ext->extension[number].length = str_length;
    FrameMgrGetToken(fm, name);
    query_ext->extension[number].name = malloc(str_length + 1);
    strncpy(query_ext->extension[number].name, name, str_length);
    query_ext->extension[number].name[str_length] = (char)0;
    number++;
  }
  query_ext->number = number;
  FrameMgrFree(fm);
  ext_list = MakeExtensionList(i18n_core, query_ext->extension, number, &reply_number);
  for(i=0; i<number; i++) free(query_ext->extension[i].name);
  free(query_ext->extension);
  fm=FrameMgrInit(query_extension_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrSetIterCount(fm, reply_number);
  for(i=0; i<reply_number; i++){
    str_size = strlen(ext_list[i].name);
    FrameMgrSetSize(fm, str_size);
  }
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  for(i=0; i<reply_number; i++){
    str_size = FrameMgrGetSize(fm);
    FrameMgrPutToken(fm, ext_list[i].major_opcode);
    FrameMgrPutToken(fm, ext_list[i].minor_opcode);
    FrameMgrPutToken(fm, str_size);
    FrameMgrPutToken(fm, ext_list[i].name);
  }
  _Xi18nSendMessage(ims, connect_id, XIM_QUERY_EXTENSION_REPLY, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  for(i=0; i<reply_number; i++) free(ext_list[i].name);
  if(ext_list) free((char *)ext_list);
  return;
}

void SyncReplyMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  CARD16 connect_id = call_data->any.connect_id;
  Xi18nClient *client = (Xi18nClient *)_Xi18nFindClient(i18n_core, connect_id);
  CARD16 input_method_ID, input_context_ID;

  fm = FrameMgrInit(sync_reply_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, input_context_ID);
  FrameMgrFree(fm);
  client->sync = False;
  return;
}

void GetIMValueFromName(Xi18n i18n_core, CARD16 connect_id,
                        char *buf, char *name, int *length){
  register int i;

  if(!strcmp(name, XNQueryInputStyle)){
    XIMStyles *styles = (XIMStyles*)&i18n_core->address.input_styles;
    *length = sizeof(CARD16) * 2;                              /* count_styles, unused */
    *length += styles->count_styles * sizeof(CARD32);
    if(buf != NULL){
      FrameMgr fm;
      unsigned char *data = NULL;
      int total_size;
      fm = FrameMgrInit(input_styles_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
      FrameMgrSetIterCount(fm, styles->count_styles);
      total_size = FrameMgrGetTotalSize(fm);
      data = (unsigned char *)malloc(total_size);
      if (!data) return;
      memset(data, 0, total_size);
      FrameMgrSetBuffer(fm, data);
      FrameMgrPutToken(fm, styles->count_styles);
      for(i=0; i<(int)styles->count_styles; i++)
        FrameMgrPutToken(fm, styles->supported_styles[i]);
      memmove(buf, data, total_size);
      free(data);
      FrameMgrFree(fm);
    }
  }
}

XIMAttribute *MakeIMAttributeList(Xi18n i18n_core, CARD16 connect_id,
                         CARD16 *list, int *number, int *length){
  XIMAttribute *attrib_list;
  int list_num;
  XIMAttr *attr = i18n_core->address.xim_attr;
  int list_len = i18n_core->address.im_attr_num;
  register int i, j;
  int value_length;
  int number_ret = 0;

  *length = 0;
  list_num = 0;
  for(i=0; i<*number; i++){
    for(j=0; j<list_len; j++){
      if(attr[j].attribute_id == list[i]){
        list_num++;
        break;
      }
    }
  }
  attrib_list = (XIMAttribute *)malloc(sizeof(XIMAttribute) * list_num);
  if(!attrib_list) return NULL;
  memset(attrib_list, 0, sizeof(XIMAttribute) * list_num);
  number_ret = list_num;
  list_num = 0;
  for(i=0; i<*number; i++){
    for(j=0; j<list_len; j++){
      if(attr[j].attribute_id == list[i]){
        attrib_list[list_num].attribute_id = attr[j].attribute_id;
        attrib_list[list_num].name_length = attr[j].length;
        attrib_list[list_num].name = attr[j].name;
        attrib_list[list_num].type = attr[j].type;
        GetIMValueFromName(i18n_core, connect_id, NULL, attr[j].name, &value_length);
        attrib_list[list_num].value_length = value_length;
        attrib_list[list_num].value = (void *)malloc(value_length);
        memset(attrib_list[list_num].value, 0, value_length);
        GetIMValueFromName(i18n_core, connect_id,
                           attrib_list[list_num].value, attr[j].name, &value_length);
        *length += sizeof(CARD16) * 2;
        *length += value_length;
        *length += IMPAD(value_length);
        list_num++;
        break;
      }
    }
  }
  *number = number_ret;
  return attrib_list;
}

void GetIMValuesMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  FmStatus status;
  CARD16 byte_length;
  int list_len, total_size;
  unsigned char *reply = NULL;
  int iter_count;
  register int i, j;
  int number;
  CARD16 *im_attrID_list;
  char **name_list;
  CARD16 name_number;
  XIMAttribute *im_attribute_list;
  IMGetIMValuesStruct *getim = (IMGetIMValuesStruct *)&call_data->getim;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(get_im_values_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, byte_length);
  im_attrID_list = (CARD16 *)malloc(sizeof(CARD16) * 20);
  memset(im_attrID_list, 0, sizeof(CARD16) * 20);
  name_list = (char **)malloc(sizeof(char *) * 20);
  memset(name_list, 0, sizeof(char *) * 20);
  number = 0;
  while (FrameMgrIsIterLoopEnd(fm, &status) == False) {
    FrameMgrGetToken(fm, im_attrID_list[number]);
    number++;
  }
  FrameMgrFree(fm);
  name_number = 0;
  for(i=0; i<number; i++){
    for(j=0; j<i18n_core->address.im_attr_num; j++)
      if(i18n_core->address.xim_attr[j].attribute_id == im_attrID_list[i]){
        name_list[name_number++] = i18n_core->address.xim_attr[j].name;
        break;
      }
  }
  getim->number = name_number;
  getim->im_attr_list = name_list;
  free(name_list);
  im_attribute_list = MakeIMAttributeList(i18n_core, connect_id,
                                            im_attrID_list, &number, &list_len);
  if(im_attrID_list) free(im_attrID_list);
  fm = FrameMgrInit(get_im_values_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  iter_count = number;
  FrameMgrSetIterCount(fm, iter_count);
  for(i=0; i<iter_count; i++) FrameMgrSetSize(fm, im_attribute_list[i].value_length);
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  for(i=0; i<iter_count; i++){
    FrameMgrPutToken(fm, im_attribute_list[i].attribute_id);
    FrameMgrPutToken(fm, im_attribute_list[i].value_length);
    FrameMgrPutToken(fm, im_attribute_list[i].value);
  }
  _Xi18nSendMessage(ims, connect_id, XIM_GET_IM_VALUES_REPLY, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  for (i=0; i < iter_count; i++) {
    if(im_attribute_list[i].value_length && im_attribute_list[i].value)
      free(im_attribute_list[i].value);
  }
  free(im_attribute_list);
  return;
}

void CreateICMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  _Xi18nChangeIC(ims, call_data, p, True);
  return;
}

void SetICValuesMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  _Xi18nChangeIC(ims, call_data, p, False);
  return;
}

void GetICValuesMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  _Xi18nGetIC(ims, call_data, p);
  return;
}

void SetICFocusMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  IMChangeFocusStruct *setfocus = (IMChangeFocusStruct*)&call_data->changefocus;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;
  fm = FrameMgrInit(set_ic_focus_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, setfocus->icid);
  FrameMgrFree(fm);
  if(i18n_core->address.improto)
    if(!(i18n_core->address.improto(ims, call_data))) return;
  return;
}

void UnsetICFocusMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  IMChangeFocusStruct *unsetfocus = (IMChangeFocusStruct*)&call_data->changefocus;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(unset_ic_focus_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, unsetfocus->icid);
  FrameMgrFree(fm);
  if(i18n_core->address.improto)
    if(!(i18n_core->address.improto(ims, call_data))) return;
  return;
}

void DestroyICMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  register int total_size;
  unsigned char *reply = NULL;
  IMDestroyICStruct *destroy = (IMDestroyICStruct*)&call_data->destroyic;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(destroy_ic_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, destroy->icid);
  FrameMgrFree(fm);
  if(i18n_core->address.improto)
    if(!(i18n_core->address.improto(ims, call_data))) return;
  fm = FrameMgrInit(destroy_ic_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  FrameMgrPutToken(fm, destroy->icid);
  _Xi18nSendMessage(ims, connect_id, XIM_DESTROY_IC_REPLY, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  return;
}

void ResetICMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  register int total_size;
  unsigned char *reply = NULL;
  IMResetICStruct *resetic = (IMResetICStruct*)&call_data->resetic;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(reset_ic_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, resetic->icid);
  FrameMgrFree(fm);
  if(i18n_core->address.improto)
    if(!(i18n_core->address.improto(ims, call_data))) return;
  fm = FrameMgrInit(reset_ic_reply_fr, NULL, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrSetSize(fm, resetic->length);
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  FrameMgrPutToken(fm, resetic->icid);
  FrameMgrPutToken(fm, resetic->commit_string);
  _Xi18nSendMessage(ims, connect_id, XIM_RESET_IC_REPLY, 0, reply, total_size);
  FrameMgrFree(fm);
  free(reply);
  return;
}

int WireEventToEvent(Xi18n i18n_core, xEvent *event, CARD16 serial, XEvent *ev){
  ev->xany.serial = event->u.u.sequenceNumber & ((unsigned long) 0xffff);
  ev->xany.serial |= serial << 16;
  ev->xany.send_event = False;
  ev->xany.display = i18n_core->address.dpy;
  switch(ev->type = event->u.u.type & 0x7f){
    case KeyPress:
    case KeyRelease:
      ((XKeyEvent *)ev)->keycode = event->u.u.detail;
      ((XKeyEvent *)ev)->window  = event->u.keyButtonPointer.event;
      ((XKeyEvent *)ev)->state   = event->u.keyButtonPointer.state;
      ((XKeyEvent *)ev)->time    = event->u.keyButtonPointer.time;
      ((XKeyEvent *)ev)->root    = event->u.keyButtonPointer.root;
      ((XKeyEvent *)ev)->x       = event->u.keyButtonPointer.eventX;
      ((XKeyEvent *)ev)->y       = event->u.keyButtonPointer.eventY;
      ((XKeyEvent *)ev)->x_root  = 0;
      ((XKeyEvent *)ev)->y_root  = 0;
      return True;
    default:
      break;
  }
  return False;
}

void ForwardEventMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  xEvent wire_event;
  IMForwardEventStruct *forward = (IMForwardEventStruct*)&call_data->forwardevent;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(forward_event_fr, (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, forward->icid);
  FrameMgrGetToken(fm, forward->sync_bit);
  FrameMgrGetToken(fm, forward->serial_number);
  p += sizeof(CARD16) * 4;
  memmove(&wire_event, p, sizeof(xEvent));
  FrameMgrFree(fm);
  if(WireEventToEvent(i18n_core,
                   &wire_event, forward->serial_number,&forward->event) == True) {
    if(i18n_core->address.improto)
      if(!(i18n_core->address.improto(ims, call_data))) return;
  }
  return;
}

void EncodingNegotiationMessageProc(XIMS ims, IMProtocol *call_data, unsigned char *p){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  FmStatus status;
  CARD16 byte_length;
  register int i, total_size;
  unsigned char *reply = NULL;
  IMEncodingNegotiationStruct *enc_nego =
                       (IMEncodingNegotiationStruct *)&call_data->encodingnego;
  CARD16 connect_id = call_data->any.connect_id;
  CARD16 input_method_ID;

  fm = FrameMgrInit(encoding_negotiation_fr,
                       (char *)p, _Xi18nNeedSwap(i18n_core, connect_id));
  FrameMgrGetToken(fm, input_method_ID);
  FrameMgrGetToken(fm, byte_length);                             /* ENCODING STR field */
  if(byte_length > 0){
    enc_nego->encoding = (XIMStr *)malloc(sizeof(XIMStr) * 10);
    memset(enc_nego->encoding, 0, sizeof(XIMStr) * 10);
    i = 0;
    while(FrameMgrIsIterLoopEnd(fm, &status) == False){
      char *name;
      int str_length;
      FrameMgrGetToken(fm, str_length);
      FrameMgrSetSize(fm, str_length);
      enc_nego->encoding[i].length = str_length;
      FrameMgrGetToken(fm, name);
      enc_nego->encoding[i].name = malloc(str_length + 1);
      strncpy(enc_nego->encoding[i].name, name, str_length);
      enc_nego->encoding[i].name[str_length] = (char)0;
      i++;
    }
    enc_nego->encoding_number = i;
  }
  FrameMgrGetToken(fm, byte_length);                            /* ENCODING INFO field */
  if(byte_length > 0){
    enc_nego->encodinginfo = (XIMStr *)malloc(sizeof(XIMStr) * 10);
    memset(enc_nego->encoding, 0, sizeof(XIMStr) * 10);
    i = 0;
    while(FrameMgrIsIterLoopEnd(fm, &status) == False){
      char *name;
      int str_length;
      FrameMgrGetToken(fm, str_length);
      FrameMgrSetSize(fm, str_length);
      enc_nego->encodinginfo[i].length = str_length;
      FrameMgrGetToken(fm, name);
      enc_nego->encodinginfo[i].name = malloc(str_length + 1);
      strncpy(enc_nego->encodinginfo[i].name, name, str_length);
      enc_nego->encodinginfo[i].name[str_length] = (char)0;
      i++;
    }
    enc_nego->encoding_info_number = i;
  }
  enc_nego->enc_index = (INT16)XIM_Default_Encoding_IDX; /* 以上にかかわらず -1 にする */
  enc_nego->category = 0;
  FrameMgrFree(fm);
  fm = FrameMgrInit(encoding_negotiation_reply_fr, NULL,
                                       _Xi18nNeedSwap(i18n_core, connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  reply = (unsigned char *)malloc(total_size);
  if(!reply){
    _Xi18nSendMessage(ims, connect_id, XIM_ERROR, 0, 0, 0);
    return;
  }
  memset(reply, 0, total_size);
  FrameMgrSetBuffer(fm, reply);
  FrameMgrPutToken(fm, input_method_ID);
  FrameMgrPutToken(fm, enc_nego->category);
  FrameMgrPutToken(fm, enc_nego->enc_index);
  _Xi18nSendMessage(ims, connect_id,
                    XIM_ENCODING_NEGOTIATION_REPLY, 0, reply, total_size);
  free(reply);
  if(enc_nego->encoding != NULL){
    for(i=0; i<(int)enc_nego->encoding_number; i++) free(enc_nego->encoding[i].name);
    free(enc_nego->encoding);
  }
  if(enc_nego->encodinginfo != NULL){
    for(i=0; i<(int)enc_nego->encoding_info_number; i++)
      free(enc_nego->encodinginfo[i].name);
    free(enc_nego->encodinginfo);
  }
  FrameMgrFree(fm);
  return;
}

void AddQueue(Xi18nClient *client, unsigned char *p){
  XIMPending  *new_pend, *last;

  if((new_pend = (XIMPending *)malloc(sizeof(XIMPending))) == NULL) return;
  new_pend->p = p;
  new_pend->next = (XIMPending *)NULL;
  if(!client->pending) client->pending = new_pend;
  else{
    for(last=client->pending; last->next; last=last->next);
    last->next = new_pend;
  }
  return;
}

void ProcessQueue(XIMS ims, CARD16 connect_id){
  Xi18n i18n_core = ims->protocol;
  Xi18nClient *client = (Xi18nClient *)_Xi18nFindClient(i18n_core, connect_id);
  while (client->sync == False && client->pending != NULL) {
    XimProtoHdr *hdr = (XimProtoHdr *)client->pending->p;
    unsigned char *p1 = (unsigned char *)(hdr + 1);
    IMProtocol call_data;
    call_data.major_code = hdr->major_opcode;
    call_data.any.minor_code = hdr->minor_opcode;
    call_data.any.connect_id = connect_id;
    switch(hdr->major_opcode){
      case XIM_FORWARD_EVENT:
        ForwardEventMessageProc(ims, &call_data, p1);
        break;
      default:
        break;
    }
    free(hdr);
    {
      XIMPending *old = client->pending;
      client->pending = old->next;
      free(old);
    }
  }
  return;
}

void 
_Xi18nMessageHandler(XIMS ims, CARD16 connect_id, unsigned char *p, Bool *delete){
  XimProtoHdr *hdr = (XimProtoHdr *)p;
FILE *wf;
  if(p==NULL){                                                    /* pがNULLで来た時は */
    return;                                                                  /* 即出る */
  }else{
    unsigned char *p1 = (unsigned char *)(hdr + 1);
    IMProtocol call_data;
    Xi18n i18n_core = ims->protocol;
    Xi18nClient *client = (Xi18nClient *)_Xi18nFindClient(i18n_core, connect_id);

    memset(&call_data, 0, sizeof(IMProtocol));
    call_data.major_code = hdr->major_opcode;
    call_data.any.minor_code = hdr->minor_opcode;
    call_data.any.connect_id = connect_id;
    switch(call_data.major_code){
      case XIM_CONNECT:
if(Log) fprintf(stderr, "%d XIM_CONNECT\n", connect_id);
        ConnectMessageProc(ims, &call_data, p1);
        break;
      case XIM_DISCONNECT:
if(Log) fprintf(stderr, "%d XIM_DISCONNECT\n", connect_id);
        DisConnectMessageProc(ims, &call_data);
        break;
      case XIM_OPEN:
if(Log) fprintf(stderr, "%d XIM_OPEN\n", connect_id);
        OpenMessageProc(ims, &call_data, p1);
        break;
      case XIM_CLOSE:
if(Log) fprintf(stderr, "%d XIM_CLOSE\n", connect_id);
        CloseMessageProc(ims, &call_data, p1);
        break;
      case XIM_QUERY_EXTENSION:
if(Log) fprintf(stderr, "%d XIM_QUERY_EXTENSION\n", connect_id);
        QueryExtensionMessageProc(ims, &call_data, p1);
        break;
      case XIM_GET_IM_VALUES:
if(Log) fprintf(stderr, "%d XIM_GET_IM_VALUES\n", connect_id);
        GetIMValuesMessageProc(ims, &call_data, p1);
        break;
      case XIM_CREATE_IC:
if(Log) fprintf(stderr, "%d XIM_CREATE_IC\n", connect_id);
        CreateICMessageProc(ims, &call_data, p1);
        break;
      case XIM_SET_IC_VALUES:
if(Log) fprintf(stderr, "%d XIM_SET_IC_VALUES\n", connect_id);
        SetICValuesMessageProc(ims, &call_data, p1);
        break;
      case XIM_GET_IC_VALUES:
if(Log) fprintf(stderr, "%d XIM_GET_IC_VALUES\n", connect_id);
        GetICValuesMessageProc(ims, &call_data, p1);
        break;
      case XIM_SET_IC_FOCUS:
if(Log) fprintf(stderr, "%d XIM_SET_IC_FOCUS\n", connect_id);
        SetICFocusMessageProc(ims, &call_data, p1);
        break;
      case XIM_UNSET_IC_FOCUS:
if(Log) fprintf(stderr, "%d XIM_UNSET_IC_FOCUS\n", connect_id);
        UnsetICFocusMessageProc(ims, &call_data, p1);
        break;
      case XIM_DESTROY_IC:
if(Log) fprintf(stderr, "%d XIM_DESTROY_IC\n", connect_id);
        DestroyICMessageProc(ims, &call_data, p1);
        break;
      case XIM_RESET_IC:
if(Log) fprintf(stderr, "%d XIM_RESET_IC\n", connect_id);
        ResetICMessageProc(ims, &call_data, p1);
        break;
      case XIM_FORWARD_EVENT:
if(Log) fprintf(stderr, "%d XIM_FORWARD_EVENT\n", connect_id);
        if(client->sync == True){
          AddQueue(client, p);
          *delete = False;
        }else{
          ForwardEventMessageProc(ims, &call_data, p1);
        }
        break;
      case XIM_EXTENSION:
if(Log) fprintf(stderr, "%d XIM_EXTENTION?\n", connect_id);
        break;
      case XIM_SYNC:
if(Log) fprintf(stderr, "%d XIM_SYNC\n", connect_id);
        break;
      case XIM_SYNC_REPLY:
if(Log) fprintf(stderr, "%d XIM_SYNC_REPLY\n", connect_id);
        SyncReplyMessageProc(ims, &call_data, p1);
        ProcessQueue(ims, connect_id);
        break;
      case XIM_TRIGGER_NOTIFY:
if(Log) fprintf(stderr, "%d XIM_TRIGGER_NOTIFY?\n", connect_id);
        break;
      case XIM_ENCODING_NEGOTIATION:
if(Log) fprintf(stderr, "%d XIM_ENCODING_NEGOTIATION\n", connect_id);
        EncodingNegotiationMessageProc(ims, &call_data, p1);
        break;
      case XIM_PREEDIT_START_REPLY:
if(Log) fprintf(stderr, "%d XIM_PREEDIT_START_REPLY?\n", connect_id);
        break;
      case XIM_PREEDIT_CARET_REPLY:
if(Log) fprintf(stderr, "%d XIM_PREEDIT_CARET_REPLY?\n", connect_id);
        break;
      case XIM_STR_CONVERSION_REPLY:
if(Log) fprintf(stderr, "%d XIM_STR_CONVERSION_REPLY?\n", connect_id);
        break;
      default:
if(Log) fprintf(stderr, "%d XIM_Protocol %d?\n", call_data.major_code, connect_id);
        break;
    }
  }
}

void  *ki_setup(Display*, Window, char*, char*, IMProtoHandler);
Status ki_openIM(XIMS);
Status ki_closeIM(XIMS);
Status ki_forwardEvent(XIMS, IMForwardEventStruct*);
Status ki_commitString(XIMS, IMCommitStruct*);

IMMethodsRec ki_im_methods={
  ki_setup,
  ki_openIM,
  ki_closeIM,
  ki_forwardEvent,
  ki_commitString,
};

Bool SetXi18nSelectionOwner(Xi18n i18n_core){                           /* < ki_openIM */
  static Atom XIM_Servers = None;
  Display *dpy = i18n_core->address.dpy;
  Window ims_win = i18n_core->address.im_window;
  Window root = RootWindow(dpy, DefaultScreen(dpy));
  Atom realtype;
  int realformat;
  unsigned long bytesafter;
  long *data;
  unsigned long length;
  Atom atom;
  int i;
  int found;
  int forse = False;
  char buf[256];

  (void)sprintf(buf, "@server=%s", i18n_core->address.im_name);
  if((atom=XInternAtom(dpy, buf, False)) == 0) return False;
  i18n_core->address.selection = atom;
  if(XIM_Servers == None)
      XIM_Servers = XInternAtom(dpy, XIM_SERVERS, False);       /* "XIM_SERVERS"のAtom */
  XGetWindowProperty(dpy, root, XIM_Servers, 0L, 1000000L, False, XA_ATOM, &realtype,
                     &realformat, &length, &bytesafter, (unsigned char **)(&data));
  if(realtype==None)   ;                                             /* 存在していない */
  else if(realtype != XA_ATOM) return False;                         /* 型が正しくない */
  else if(realformat != 32){                               /* フォーマットが正しくない */
    if(data != NULL) XFree((char *)data);
    return False;
  }
  found = False;
  for(i=0; i<length; i++){                                       /* 返された要素の中に */
    if(data[i]==atom){                                /* "XIM_SERVERS"のアトムがあれば */
      Window owner;
      found = True;
      owner = XGetSelectionOwner(dpy, atom);             /* そのオーナー(ウィンドウ)が */
      if(owner!=ims_win){                                            /* 当IMでなければ */
        if(owner==None || forse==True)   /* forseはFalseに初期化されたままなので不成立 */
            XSetSelectionOwner(dpy, atom, ims_win, CurrentTime);
        else return False;
      }
      break;
    }
  }
  if(data != NULL) XFree((char *)data);
  if(found==False){                         /* 結局 "XIM_SERVERS" のアトムがなかったら */
    XSetSelectionOwner(dpy, atom, ims_win, CurrentTime);
    (void)XChangeProperty(dpy, root, XIM_Servers, XA_ATOM,
                          32, PropModePrepend, (unsigned char *)&atom, 1);
  }
  i18n_core->address.Localename = XInternAtom(dpy, LOCALES, False);       /* "LOCALES" */
  i18n_core->address.Transportname = XInternAtom(dpy, TRANSPORT, False);/* "TRANSPORT" */
  return (XGetSelectionOwner(dpy, atom) == ims_win);      /* "@server=..."のウィンドウ */
}

/* ki_setup  <-- IMOpenIM */
typedef struct{
  char *name;
  CARD16 type;
}IMListOfAttr;

IMListOfAttr Default_IMattr[]={                                /* < _Xi18nInitAttrList */
  {XNQueryInputStyle, XimType_XIMStyles},                      /* "queryInputStyle" 10 */
  {(char *)NULL, (CARD16)0}
};

IMListOfAttr Default_ICattr[] = {                              /* < _Xi18nInitAttrList */
  {XNInputStyle,        XimType_CARD32},                             /* "inputStyle" 3 */
  {XNClientWindow,      XimType_Window},                           /* "clientWindow" 5 */
  {XNFocusWindow,       XimType_Window},                            /* "focusWindow" 5 */
  {XNFilterEvents,      XimType_CARD32},                           /* "filterEvents" 3 */
/* 03-09-29月 次の数項は『き』には不要だが、ないと起動しないクライアントがあるので残す */
  {XNPreeditAttributes, XimType_NEST},                   /* "preeditAttributes" 0x7fff */
  {XNStatusAttributes,  XimType_NEST},                    /* "statusAttributes" 0x7fff */
  {XNFontSet,           XimType_XFontSet},                             /* "fontSet" 13 */
  {XNArea,              XimType_XRectangle},                              /* "area" 11 */
  {XNAreaNeeded,        XimType_XRectangle},                        /* "areaNeeded" 11 */
  {XNColormap,          XimType_CARD32},                              /* "colorMap"  3 */
  {XNStdColormap,       XimType_CARD32},                            /* "stdColorMap" 3 */
  {XNForeground,        XimType_CARD32},                             /* "foreground" 3 */
  {XNBackground,        XimType_CARD32},                             /* "background" 3 */
  {XNBackgroundPixmap,  XimType_CARD32},                       /* "backgroundPixmap" 3 */
  {XNSpotLocation,      XimType_XPoint},                          /* "spotLocation" 12 */
  {XNLineSpace,         XimType_CARD32},                              /* "lineSpace" 3 */
/*{XNPreeditState,      XimType_CARD32},*/                         /* "preeditState" 3 */
  {XNSeparatorofNestedList, XimType_SeparatorOfNestedList},/* "separatorofNestedList"0 */
  {(char *)NULL,        (CARD16)0}
};

XIMAttr *CreateAttrList(Xi18n i18n_core, IMListOfAttr *attr, int *total_count){
                                                               /* < _Xi18nInitAttrList */
  XIMAttr *args, *p;
  unsigned int buf_size;

  for(*total_count=0; attr[*total_count].name; ++(*total_count));          /* 項目数を */
  buf_size = (unsigned)(*total_count + 1) * sizeof(XIMAttr);       /* 項目サイズ倍した */
  args = (XIMAttr *)malloc(buf_size);                                /* 領域を確保する */
  if(!args) return (XIMAttr *)NULL;
  memset(args, 0, buf_size);
  for(p=args; attr->name != NULL; attr++, p++){
    p->name = attr->name;                                         /* "queryInputStyle" */
    p->length = strlen(attr->name);                                             /*  15 */
    p->type = (CARD16)attr->type;                              /* XimType_XIMStyles 10 */
    p->attribute_id = XrmStringToQuark(p->name);             /* クォークを得て設定する */
    if(!strcmp(p->name, XNPreeditAttributes))
      i18n_core->address.preeditAttr_id = p->attribute_id;
    else if(!strcmp(p->name, XNStatusAttributes))
      i18n_core->address.statusAttr_id = p->attribute_id;
    else if(!strcmp(p->name, XNSeparatorofNestedList))
      i18n_core->address.separatorAttr_id = p->attribute_id;
  }
  p->name = (char*)NULL;
  return args;
}

void *ki_setup(Display *dpy, Window wnd, char *imname, char *imlocale,
                  IMProtoHandler MyProtoHandler){
  Xi18n  i18n_core;
  XIMAttr    *args;
  CARD16  endian=1;
  int  total_count;

  if((i18n_core=(Xi18n)malloc(sizeof(Xi18nCore)))==(Xi18n)NULL) return NULL;
  memset(i18n_core, 0, sizeof(Xi18nCore));
  i18n_core->address.dpy              = dpy;
  i18n_core->address.im_locale        = imlocale;
  i18n_core->address.im_name          = imname;
  i18n_core->address.im_window        = wnd;
  i18n_core->address.input_styles.count_styles = 1;
  i18n_core->address.input_styles.supported_styles = Styles;
  i18n_core->address.improto          = MyProtoHandler;
  i18n_core->address.filterevent_mask = KeyPressMask | KeyReleaseMask;
  i18n_core->address.imvalue_mask
             = I18N_IM_LOCALE    | I18N_IM_NAME    | I18N_IMSERVER_WIN |
               I18N_INPUT_STYLES | I18N_IM_HANDLER | I18N_FILTERMASK;
  if(*(char *)&endian) i18n_core->address.im_byteOrder = 'l';
  else                 i18n_core->address.im_byteOrder = 'B';
  args = CreateAttrList(i18n_core, Default_IMattr, &total_count);
  i18n_core->address.im_attr_num = total_count;
  i18n_core->address.xim_attr = (XIMAttr *)args;
  args = CreateAttrList(i18n_core, Default_ICattr, &total_count);
  i18n_core->address.ic_attr_num = total_count;
  i18n_core->address.xic_attr = (XICAttr *)args;
  return i18n_core;
}

void ReturnSelectionNotify(Xi18n i18n_core, XSelectionRequestEvent *ev){
                                                            /* < WaitXSelectionRequest */
  XEvent event;
  Display *dpy = i18n_core->address.dpy;
  char buf[256];

  event.type = SelectionNotify;
  event.xselection.requestor = ev->requestor;
  event.xselection.selection = ev->selection;
  event.xselection.target = ev->target;
  event.xselection.time = ev->time;
  event.xselection.property = ev->property;
  if(ev->target == i18n_core->address.Localename){
    (void)sprintf(buf, "@locale=%s", i18n_core->address.im_locale);
  }else if(ev->target == i18n_core->address.Transportname){
    (void)sprintf(buf, "@transport=X/");
  }
  XChangeProperty(dpy, event.xselection.requestor,
        ev->target, ev->target, 8, PropModeReplace, (unsigned char *)buf, strlen(buf));
  XSendEvent(dpy, event.xselection.requestor, False, NoEventMask, &event);
  XFlush(i18n_core->address.dpy);
}

Bool WaitXSelectionRequest(Display *dpy, Window win, XEvent *ev, XPointer client_data){
         /* ki_openIMで_XRegisterFilterByType、ki_cloeIMで_XUnregisterFilterの各引数に */
  XIMS  ims       = (XIMS)client_data;
  Xi18n i18n_core = ims->protocol;

  if(((XSelectionRequestEvent *)ev)->selection==i18n_core->address.selection){
    ReturnSelectionNotify(i18n_core, (XSelectionRequestEvent *)ev);
    return True;
  }
  return False;
}

Status ki_openIM(XIMS ims){                                              /* < IMOpenIM */
  Xi18n i18n_core = ims->protocol;
  Display    *dpy = i18n_core->address.dpy;

  if(!_Xi18nCheckXAddress(i18n_core) ||                /* Atom控え領域を確保できないか */
     !SetXi18nSelectionOwner(i18n_core)){/* 領域は確保できても該当Atomが得られなければ */
    if(i18n_core->address.xim_attr) free(i18n_core->address.xim_attr);
    if(i18n_core->address.xic_attr) free(i18n_core->address.xic_attr);
    if(i18n_core->address.connect_addr) free(i18n_core->address.connect_addr);
    free(i18n_core); return False;
  }
  i18n_core->methods.begin(ims);     /* WaitXConnectMessageがXRegisterFilterTypeされる */
  _XRegisterFilterByType(dpy, i18n_core->address.im_window,
               SelectionRequest, SelectionRequest, WaitXSelectionRequest, (XPointer)ims);
if(Log){
  fprintf(stderr, "_XReg  :WaitXSelectionRequest %u\n", 
                                             (unsigned int)i18n_core->address.im_window);
}
  return True;
}

Status ki_closeIM(XIMS ims){                                            /* < IMCloseIM */
  Xi18n i18n_core = ims->protocol;
  Display *dpy    = i18n_core->address.dpy;

  i18n_core->methods.end(ims);       /* Xi18nXEndでWaitXConnectMessage用フィルタを外す */
  _XUnregisterFilter(dpy, i18n_core->address.im_window,   /* WaitXSelectionRequest用の */
                  WaitXSelectionRequest, (XPointer)ims);             /* フィルタを外す */
if(Log){
  fprintf(stderr, "_XUnreg :WaitXSelectionRequest %u\n",
                                             (unsigned int)i18n_core->address.im_window);
}
  if(i18n_core->address.xim_attr) free(i18n_core->address.xim_attr);
  if(i18n_core->address.xic_attr) free(i18n_core->address.xic_attr);
  if(i18n_core->address.connect_addr) free(i18n_core->address.connect_addr);
  free(i18n_core);
  return True;
}

void EventToWireEvent(XEvent *ev, xEvent *event, CARD16 *serial){
                                                                  /* < ki_forwardEvent */
  *serial = (CARD16)(ev->xany.serial >> 16);
  event->u.u.sequenceNumber = (CARD16)(ev->xany.serial & (unsigned long)0xffff);

  switch(ev->type){
    case KeyPress:
    case KeyRelease:
      {
        XKeyEvent *kev = (XKeyEvent*)ev;
        event->u.u.type = ev->type;
        event->u.keyButtonPointer.root = kev->root;
        event->u.keyButtonPointer.state = kev->state;
        event->u.keyButtonPointer.time = kev->time;
        event->u.keyButtonPointer.event = kev->window;
        event->u.keyButtonPointer.child = kev->subwindow;
        event->u.keyButtonPointer.eventX = kev->x;
        event->u.keyButtonPointer.eventY = kev->y;
        event->u.keyButtonPointer.rootX = kev->x_root;
        event->u.keyButtonPointer.rootY = kev->y_root;
        event->u.keyButtonPointer.sameScreen = kev->same_screen;
        event->u.u.detail = kev->keycode;
      }
  }
}

Status ki_forwardEvent(XIMS ims, IMForwardEventStruct *call_data){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  register int total_size;
  unsigned char *reply = NULL;
  unsigned char *replyp;
  CARD16 serial;
  int event_size;
  Xi18nClient *client=(Xi18nClient *)_Xi18nFindClient(i18n_core, call_data->connect_id);

  fm = FrameMgrInit(forward_event_fr, NULL,                         /* create FrameMgr */
                    _Xi18nNeedSwap(i18n_core, call_data->connect_id));
  total_size = FrameMgrGetTotalSize(fm);
  event_size = sizeof(xEvent);
  reply = (unsigned char *)malloc(total_size + event_size);
  if(!reply){
    _Xi18nSendMessage(ims, call_data->connect_id, XIM_ERROR, 0, 0, 0);
    return False;
  }
  memset(reply, 0, total_size + event_size);
  FrameMgrSetBuffer(fm, reply);
  replyp = reply;
  call_data->sync_bit = 1;                                                /* 常に sync */
  client->sync = True;
  FrameMgrPutToken(fm, call_data->connect_id);
  FrameMgrPutToken(fm, call_data->icid);
  FrameMgrPutToken(fm, call_data->sync_bit);
  replyp += total_size;
  EventToWireEvent(&(call_data->event), (xEvent *)replyp, &serial);
  FrameMgrPutToken(fm, serial);
  _Xi18nSendMessage(ims, call_data->connect_id,
                    XIM_FORWARD_EVENT, 0, reply, total_size + event_size);
  free(reply);
  FrameMgrFree(fm);
  return True;
}

Status ki_commitString(XIMS ims, IMCommitStruct *call_data){
  Xi18n i18n_core = ims->protocol;
  FrameMgr fm;
  register int total_size;
  unsigned char *reply = NULL;
  CARD16 str_length;

  call_data->flag |= XimSYNCHRONUS;                                       /* 常に sync */
  if(!(call_data->flag & XimLookupKeySym) && (call_data->flag & XimLookupChars)){
    fm = FrameMgrInit(commit_chars_fr, NULL,                            /* Frameの生成 */
                      _Xi18nNeedSwap(i18n_core, call_data->connect_id));
    str_length = strlen(call_data->commit_string);                /* STRING8での長さを */
    FrameMgrSetSize(fm, str_length);                                           /* 記入 */
    total_size = FrameMgrGetTotalSize(fm);
    reply = (unsigned char *)malloc(total_size);
    if(!reply){
      _Xi18nSendMessage(ims, call_data->connect_id, XIM_ERROR, 0, 0, 0);
      return False;
    }
    memset(reply, 0, total_size);
    FrameMgrSetBuffer(fm, reply);
    str_length = FrameMgrGetSize(fm);
    FrameMgrPutToken(fm, call_data->connect_id);
    FrameMgrPutToken(fm, call_data->icid);
    FrameMgrPutToken(fm, call_data->flag);
    FrameMgrPutToken(fm, str_length);
    FrameMgrPutToken(fm, call_data->commit_string);
  }else{
    fm = FrameMgrInit(commit_both_fr, NULL,                             /* Frameの生成 */
                      _Xi18nNeedSwap(i18n_core, call_data->connect_id));
    str_length = strlen(call_data->commit_string);           /* STRING8 での長さを調べ */
    if(str_length>0) FrameMgrSetSize(fm, str_length);        /* 0 でなければ記入する   */
    total_size = FrameMgrGetTotalSize(fm);
    reply = (unsigned char *)malloc(total_size);
    if(!reply){
      _Xi18nSendMessage(ims, call_data->connect_id, XIM_ERROR, 0, 0, 0);
      return False;
    }
    FrameMgrPutToken(fm, call_data->connect_id);
    FrameMgrPutToken(fm, call_data->icid);
    FrameMgrPutToken(fm, call_data->flag);
    FrameMgrPutToken(fm, call_data->keysym);
    if(str_length>0){
      str_length = FrameMgrGetSize(fm);
      FrameMgrPutToken(fm, str_length);
      FrameMgrPutToken(fm, call_data->commit_string);
    }
  }
  _Xi18nSendMessage(ims, call_data->connect_id, XIM_COMMIT, 0, reply, total_size);
  free(reply);
  FrameMgrFree(fm);
  return True;
}

XIMS IMOpenIM(Display *dpy, Window wnd, char *imname, char *imlocale,
              IMProtoHandler MyProtoHandler){
  XIMS ims;                                      /* XIMProtocolRec構造体の所在地を指す */
  Status ret;

  if((ims =(XIMS)malloc(sizeof(XIMProtocolRec))) == (XIMS)NULL) return((XIMS)NULL);
  memset(ims, 0, sizeof(XIMProtocolRec));
  ims->methods = &ki_im_methods;                     /* 『き』のIM関数が入った固定領域 */
  ims->core.display = dpy;                          /* 引き数で与えられたDisplay所在地 */
  ims->protocol= (*ims->methods->setup)(dpy, wnd, imname, imlocale, MyProtoHandler);
  if(ims->protocol == (void *)NULL) {free(ims); return (XIMS)NULL;}
  ret = (ims->methods->openIM)(ims);
  if(ret==False){free(ims); return (XIMS)NULL;}
  return (XIMS)ims;                      /* 生成したXIMProtocolRec構造体の所在地を返す */
}

Status IMCloseIM(XIMS ims){
  void *p;
  (ims->methods->closeIM)(ims);                                          /* ki_closeIM */
  free(ims);
  return True;
}

void IMForwardEvent(XIMS ims, XPointer call_data){
  (ims->methods->forwardEvent)(ims, call_data);
  return;
}

void IMCommitString(XIMS ims, XPointer call_data){
  (ims->methods->commitString)(ims, call_data);
  return;
}
