/***************************************************************************************
*                         kilib.h                                  05-10-13木 越川和忠
*
*   書き替えたものを配布する時は、
*     1. 日付と作成者名を更新者のものに書き替えて、
*     2. 「譜誌」は削除して下さい。
*
* 譜誌
* KOSHIKAWA edit from IMdkit.h, Xi18n.h and XimProto.h by Hidetoshi Tajima.
* 00-12-04月 01-05-16
* 03-09-28日 03-09-29月
* 04-05-16日 不要なincludeファイルを整理。
* 04-05-26水 xkiでは使わない構造体や関数を取り除く。
* 04-05-28金 IMOpenIM()の引き数構成を『き』専用に変更する。
* 04-05-30日 tab を取り除く。
* 04-06-05土 IMdlib.h として来たのを xkilib.h に改名する。
* 05-10-12水 xki → xim-ki。
* 05-10-13木 xkiやxim-kiなどの飾修をせず、単に、kiとする。
***************************************************************************************/
#ifndef _kilib_h
#define _kilib_h
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Xos.h>

#define XIM_SERVERS         "XIM_SERVERS"
#define XIM_SERVER_CATEGORY "@server="

/*
 * Major Protocol number
 */
#define XIM_CONNECT               1
#define XIM_CONNECT_REPLY         2
#define XIM_DISCONNECT            3
#define XIM_DISCONNECT_REPLY      4

#define XIM_AUTH_REQUIRED        10
#define XIM_AUTH_REPLY           11
#define XIM_AUTH_NEXT            12
#define XIM_AUTH_SETUP           13
#define XIM_AUTH_NG              14

#define XIM_ERROR                20

#define XIM_OPEN                 30
#define XIM_OPEN_REPLY           31
#define XIM_CLOSE                32
#define XIM_CLOSE_REPLY          33
#define XIM_REGISTER_TRIGGERKEYS 34
#define XIM_TRIGGER_NOTIFY       35
#define XIM_TRIGGER_NOTIFY_REPLY 36
#define XIM_SET_EVENT_MASK       37
#define XIM_ENCODING_NEGOTIATION 38
#define XIM_ENCODING_NEGOTIATION_REPLY 39
#define XIM_QUERY_EXTENSION      40
#define XIM_QUERY_EXTENSION_REPLY 41
#define XIM_SET_IM_VALUES        42
#define XIM_SET_IM_VALUES_REPLY  43
#define XIM_GET_IM_VALUES        44
#define XIM_GET_IM_VALUES_REPLY  45

#define XIM_CREATE_IC            50
#define XIM_CREATE_IC_REPLY      51
#define XIM_DESTROY_IC           52
#define XIM_DESTROY_IC_REPLY     53
#define XIM_SET_IC_VALUES        54
#define XIM_SET_IC_VALUES_REPLY  55
#define XIM_GET_IC_VALUES        56
#define XIM_GET_IC_VALUES_REPLY  57
#define XIM_SET_IC_FOCUS         58
#define XIM_UNSET_IC_FOCUS       59
#define XIM_FORWARD_EVENT        60
#define XIM_SYNC                 61
#define XIM_SYNC_REPLY           62
#define XIM_COMMIT               63
#define XIM_RESET_IC             64
#define XIM_RESET_IC_REPLY       65

#define XIM_GEOMETRY             70
#define XIM_STR_CONVERSION       71
#define XIM_STR_CONVERSION_REPLY 72
#define XIM_PREEDIT_START        73
#define XIM_PREEDIT_START_REPLY  74
#define XIM_PREEDIT_DRAW         75
#define XIM_PREEDIT_CARET        76
#define XIM_PREEDIT_CARET_REPLY  77
#define XIM_PREEDIT_DONE         78
#define XIM_STATUS_START         79
#define XIM_STATUS_DRAW          80
#define XIM_STATUS_DONE          81
#define XIM_PREEDITSTATE         82

/* IM Attributes Name */
#define IMServerWindow      "serverWindow"
#define IMServerName        "serverName"
#define IMLocale            "locale"
#define IMInputStyles       "inputStyles"
#define IMProtocolHandler   "protocolHandler"
#define IMEncodingList      "encodingList"
#define IMFilterEventMask   "filterEventMask"
#define IMProtocolDepend    "protocolDepend"

/* Masks for IM Attributes Name */
#define I18N_IMSERVER_WIN   0x0001 /* IMServerWindow */
#define I18N_IM_NAME        0x0002 /* IMServerName */
#define I18N_IM_LOCALE      0x0004 /* IMLocale */
#define I18N_INPUT_STYLES   0x0010 /* IMInputStyles */
#define I18N_IM_HANDLER     0x0080 /* IMProtocolHander */
#define I18N_FILTERMASK     0x0200 /* IMFilterEventMask */

/*
 * values for the type of XIMATTR & XICATTR
 */
#define XimType_SeparatorOfNestedList 0
#define XimType_CARD8                 1
#define XimType_CARD16                2
#define XimType_CARD32                3
#define XimType_Window                5
#define XimType_XIMStyles            10
#define XimType_XRectangle           11
#define XimType_XPoint               12
#define XimType_XFontSet             13
#define XimType_NEST             0x7fff

/*
 * value for the index of XIM_ENCODING_NEGITIATON_REPLY
 */
#define XIM_Default_Encoding_IDX     -1

/*
 * value for the flag of XIM_FORWARD_EVENT, XIM_COMMIT
 */
#define XimSYNCHRONUS            0x0001
#define XimLookupChars           0x0002
#define XimLookupKeySym          0x0004
#define XimLookupBoth            0x0006

/*
 * Minor Protocol Number for Extension Protocol 
 */
#define XIM_EXTENSION               128
#define XIM_EXT_SET_EVENT_MASK   (0x30)
#define XIM_EXT_FORWARD_KEYEVENT (0x32)
#define XIM_EXT_MOVE             (0x33)
#define COMMON_EXTENSIONS_NUM         3

/*
 * Padding macro
 */
#define IMPAD(length) ((4 - ((length) % 4)) % 4)

/* Extracted from IMdkit/IMCore/IMdkit.h of Hidetoshi Tajima */

typedef struct{
  char      *name;
  XPointer  value;
}XIMArg;

typedef char *XIMEncoding;

typedef struct{
  unsigned short count_encodings;
  XIMEncoding    *supported_encodings;
}XIMEncodings;

typedef struct{
  void*   (*setup)();
  Status  (*openIM)();
  Status  (*closeIM)();
  Status  (*forwardEvent)();
  Status  (*commitString)();
}IMMethodsRec, *IMMethods;

typedef struct _XIMS *XIMS;

typedef struct{
  Display *display;
  int      screen;
}IMCoreRec, *IMCore;

typedef struct _XIMS{
  IMMethods  methods;
  IMCoreRec  core;
  void      *protocol;
}XIMProtocolRec;

/*
 * Target Atom for Transport Connection (from Xi18n.h)
 */
#define LOCALES      "LOCALES"
#define TRANSPORT    "TRANSPORT"

typedef struct _XIMPending{
  unsigned char *p;
  struct        _XIMPending *next;
}XIMPending;

typedef struct _XimProtoHdr{
  CARD8     major_opcode;
  CARD8     minor_opcode;
  CARD16    length;
}XimProtoHdr;

typedef struct{
  CARD16    attribute_id;
  CARD16    type;
  CARD16    length;
  char      *name;
}XIMAttr;

typedef struct{
  CARD16    attribute_id;
  CARD16    type;
  CARD16    length;
  char      *name;
}XICAttr;

typedef struct{
  int      attribute_id;
  CARD16   name_length; 
  char     *name;
  int      value_length;
  void     *value;
  int      type;
}XIMAttribute;

typedef struct{
  int       attribute_id;
  CARD16    name_length;
  char      *name;
  int       value_length;
  void      *value;
  int       type;
}XICAttribute;

typedef struct{
  int       length;
  char      *name;
}XIMStr;

typedef struct{
  CARD16    major_opcode;
  CARD16    minor_opcode;
  CARD16    length;
  char      *name;
}XIMExt;

typedef struct _Xi18nClient{
  int         connect_id;
  CARD8       byte_order; /* ? 初期値、B Big-Endian、l little-endian */
  int         sync;
  XIMPending  *pending;
  void        *trans_rec; /* contains transport specific data  */
  struct      _Xi18nClient *next;
}Xi18nClient;

typedef struct _Xi18nCore *Xi18n;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
}IMAnyStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD8      byte_order;
  CARD16     major_version;
  CARD16     minor_version;
}IMConnectStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
}IMDisConnectStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  XIMStr     lang;
}IMOpenStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
}IMCloseStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     number;
  XIMStr     *extension;
}IMQueryExtensionStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     number;
  char       **im_attr_list;
}IMGetIMValuesStruct;

typedef struct{
  int          major_code;
  int          minor_code;
  CARD16       connect_id;
  CARD16       icid;
  CARD16       ic_attr_num;
  XICAttribute *ic_attr;
}IMChangeICStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
}IMDestroyICStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD16     length;
  char       *commit_string;
}IMResetICStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
}IMChangeFocusStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD16     sync_bit;
  CARD16     serial_number;
  XEvent     event;
}IMForwardEventStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD16     flag;
  KeySym     keysym;
  char       *commit_string;
}IMCommitStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     encoding_number;
  XIMStr     *encoding;         /* name information */
  CARD16     encoding_info_number;
  XIMStr     *encodinginfo;     /* detailed information */
  CARD16     category;          /* #0 for name, #1 for detail */
  INT16      enc_index;         /* index of the encoding determined */
}IMEncodingNegotiationStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD32     flag;
  CARD32     forward_event_mask;
  CARD32     sync_event_mask;
}IMSetEventMaskStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD32     flag;
  CARD32     intercept_event_mask;
  CARD32     select_event_mask;
  CARD32     forward_event_mask;
  CARD32     sync_event_mask;
}IMExtSetEventMaskStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD16     x;
  CARD16     y;
}IMMoveStruct;

typedef struct{
  int        major_code;
  int        minor_code;
  CARD16     connect_id;
  CARD16     icid;
  CARD16     flag;
  CARD16     error_code;
  CARD16     str_length;
  CARD16     error_type;
  char       *error_detail;
}IMErrorStruct;

typedef union _IMProtocol{
  int                         major_code;
  IMAnyStruct                 any;
  IMConnectStruct             imconnect;
  IMDisConnectStruct          imdisconnect;
  IMOpenStruct                imopen;
  IMCloseStruct               imclose;
  IMQueryExtensionStruct      queryext;
  IMGetIMValuesStruct         getim;
  IMEncodingNegotiationStruct encodingnego;
  IMExtSetEventMaskStruct     extsetevent;
  IMMoveStruct                extmove;
  IMSetEventMaskStruct        setevent;
  IMChangeICStruct            changeic;
  IMDestroyICStruct           destroyic;
  IMResetICStruct             resetic;
  IMChangeFocusStruct         changefocus;
  IMCommitStruct              commitstring;
  IMForwardEventStruct        forwardevent;
  IMErrorStruct               imerror;
  long                        pad[32];
}IMProtocol;

typedef int (*IMProtoHandler)(XIMS, IMProtocol*);

#define DEFAULT_FILTER_MASK (KeyPressMask | KeyReleaseMask)

/* Xi18nAddressRec structure */
typedef struct _Xi18nAddressRec{
  Display       *dpy;
  CARD8         im_byteOrder; /* byte order 'B' or 'l' */
    /* IM Values */
  long          imvalue_mask;
  Window        im_window;    /* IMServerWindow */
  char          *im_name;     /* IMServerName */
  char          *im_locale;   /* IMLocale */
  XIMStyles     input_styles; /* IMInputStyles */
  XIMEncodings encoding_list; /* IMEncodingList */
  IMProtoHandler improto;     /* IMProtocolHander */
  long          filterevent_mask; /* IMFilterEventMask */
    /* XIM_SERVERS target Atoms */
  Atom  selection;
  Atom  Localename;
  Atom  Transportname;
    /* XIM/XIC Attr */
  int       im_attr_num;
  XIMAttr   *xim_attr;
  int       ic_attr_num;
  XICAttr   *xic_attr;
/* 03-09-29月 『き』では要らないが、ないと動かないクライアントがあるので残す */
CARD16      preeditAttr_id;
CARD16      statusAttr_id;
/* -- */
  CARD16    separatorAttr_id;
    /* XIMExtension List */
  int       ext_num;
  XIMExt    extension[COMMON_EXTENSIONS_NUM]; /* transport specific connection address */
  void      *connect_addr; /* actual data is defined: XSpecRec for X-based connection. */
    /* clients table */
  Xi18nClient *clients;
  Xi18nClient *free_clients;
}Xi18nAddressRec;

typedef struct _Xi18nMethodsRec{
  Bool (*begin)(XIMS);
  Bool (*end)(XIMS);
  Bool (*send)(XIMS, CARD16, unsigned char *, long);
  Bool (*wait)(XIMS, CARD16, CARD8, CARD8);
  Bool (*disconnect)(XIMS, CARD16);
}Xi18nMethodsRec;

typedef struct _Xi18nCore{
  Xi18nAddressRec address;
  Xi18nMethodsRec methods;
}Xi18nCore;

/* XIM 関連のXlib内関数 */
extern void _XRegisterFilterByType(
  Display*   /* dpy */,
  Window     /* window */,
  int        /* start_type */,
  int        /* end_type */,
  Bool (*)(
    Display*   /* display */,
    Window     /* window */,
    XEvent*    /* event */,
    XPointer   /* client_data */
  )         /* filter */,
  XPointer  /* client_data */
);

extern void _XUnregisterFilter(
  Display*     /* dpy */,
  Window       /* window */,
  Bool (*)(
    Display*     /* display */,
    Window       /* window */,
    XEvent*      /* event */,
    XPointer     /* client_data */
  )            /* filter */,
  XPointer     /* client_data */
);

/* IM関数 */
extern XIMS IMOpenIM(Display*, Window, char*, char*, IMProtoHandler);
extern Status IMCloseIM(XIMS);
extern void IMForwardEvent(XIMS, XPointer);
extern void IMCommitString(XIMS, XPointer);

#endif /* _kilib_h */
